<?php

// Copyright (c) Apptimize, Inc. | https://sdk.apptimize.com/license
class apptimize_ABTApptimizeVariable {
	public function __construct(){}
	static function getValue($params, $name, $type, $nestedType = null) {
		apptimize_ABTDataStore::_checkForUpdatedMetadataIfNecessary();
		$metadata = apptimize_ABTDataStore::sharedInstance()->getMetaData($params->appkey);
		if($metadata === null) {
			return null;
		}
		$env = $metadata->makeEnvironment($params);
		$alterations = $metadata->selectAlterationsIntoArray($env);
		{
			$_g = 0;
			while($_g < $alterations->length) {
				$alteration = $alterations[$_g];
				$_g = $_g + 1;
				try {
					if($alteration->getKey() === $name) {
						$valueAlteration = _hx_cast($alteration, _hx_qtype("apptimize.models.ABTValueAlteration"));
						$alterationType = apptimize_ABTApptimizeVariable::apptimizeVariableTypeForString($valueAlteration->getType());
						$alterationNestedType = null;
						if($valueAlteration->getNestedType() !== null) {
							$alterationNestedType = apptimize_ABTApptimizeVariable::apptimizeVariableTypeForString($valueAlteration->getNestedType());
						}
						$tmp = null;
						if($alterationType === $type) {
							$tmp = $alterationNestedType === $nestedType;
						} else {
							$tmp = false;
						}
						if($tmp) {
							$variant = $valueAlteration->getVariant();
							apptimize_ABTDataStore::sharedInstance()->incrementVariantRunCount($params, $variant);
							if(!$valueAlteration->useDefaultValue()) {
								return $valueAlteration->getValue();
							}
							unset($variant);
						}
						unset($valueAlteration,$tmp,$alterationType,$alterationNestedType);
					}
				}catch(Exception $__hx__e) {
					$_ex_ = ($__hx__e instanceof HException) && $__hx__e->getCode() == null ? $__hx__e->e : $__hx__e;
					if(is_string($msg = $_ex_)){
						$tmp1 = "Alteration found for key \"" . _hx_string_or_null($alteration->getKey()) . "\" isn't a value alteration.";
						apptimize_ABTLogger::v($tmp1, _hx_anonymous(array("fileName" => "ABTApptimizeVariable.hx", "lineNumber" => 57, "className" => "apptimize.ABTApptimizeVariable", "methodName" => "getValue")));
						return null;
						unset($tmp1);
					} else throw $__hx__e;;
				}
				unset($msg,$alteration);
			}
		}
		apptimize_ABTLogger::v("No alteration found for dynamic variable \"" . _hx_string_or_null($name) . "\".", _hx_anonymous(array("fileName" => "ABTApptimizeVariable.hx", "lineNumber" => 62, "className" => "apptimize.ABTApptimizeVariable", "methodName" => "getValue")));
		return null;
	}
	static function apptimizeVariableTypeForString($stringType) {
		$type = strtolower($stringType);
		if($type === "string") {
			return apptimize_ABTApptimizeVariableType::$String;
		} else {
			if($type === "double") {
				return apptimize_ABTApptimizeVariableType::$Double;
			} else {
				if($type === "int") {
					return apptimize_ABTApptimizeVariableType::$Integer;
				} else {
					if($type === "boolean") {
						return apptimize_ABTApptimizeVariableType::$Boolean;
					} else {
						if($type === "list") {
							return apptimize_ABTApptimizeVariableType::$hArray;
						} else {
							if($type === "dictionary") {
								return apptimize_ABTApptimizeVariableType::$Dictionary;
							} else {
								return apptimize_ABTApptimizeVariableType::$Invalid;
							}
						}
					}
				}
			}
		}
	}
	function __toString() { return 'apptimize.ABTApptimizeVariable'; }
}
