<?php

// Copyright (c) Apptimize, Inc. | https://sdk.apptimize.com/license
class apptimize_ABTDataStore {
	public function __construct() {
		if(!php_Boot::$skip_constructor) {
		$this->sdkParameters = new apptimize_models_ABTSdkParameters(null);
		$this->resultDispatchQueue = new apptimize_util_ABTDispatch("Results Logging Dispatch Queue");
		$this->resultDispatchQueue->start(null);
		$this->newMdFetcher = new apptimize_api_ABTSecondaryValuesClient();
		$this->propChangeFetcher = new apptimize_api_ABTSecondaryValuesClient();
		$this->metaDataCache = new haxe_ds_StringMap();
	}}
	public $resultLogs;
	public $applicationResultLog;
	public $metaDataCache;
	public $newMdFetcher;
	public $propChangeFetcher;
	public $resultDispatchQueue;
	public $sdkParameters;
	public function initialize() {
		$this->resultLogs = apptimize_support_persistence_ABTPersistence::loadObject(apptimize_support_persistence_ABTPersistence::$kResultLogsKey, null);
		if($this->resultLogs === null) {
			$results_cache_size = apptimize_support_properties_ABTConfigProperties::sharedInstance()->valueForProperty(apptimize_support_properties_ABTConfigProperties::$RESULTS_CACHE_SIZE_KEY);
			if((is_object($_t = Type::getClass($results_cache_size)) && ($_t instanceof Enum) ? $_t == _hx_qtype("String") : _hx_equal($_t, _hx_qtype("String")))) {
				$results_cache_size = Std::parseInt($results_cache_size);
				if($results_cache_size === null) {
					apptimize_ABTLogger::e("Invalid value specified for results_cache_size, defaulting to 10", _hx_anonymous(array("fileName" => "ABTDataStore.hx", "lineNumber" => 103, "className" => "apptimize.ABTDataStore", "methodName" => "initialize")));
					$results_cache_size = 10;
				}
			}
			$this->resultLogs = new apptimize_util_ABTLRUCache($results_cache_size);
		}
		$this->applicationResultLog = new apptimize_models_results_ABTResultLog(null);
	}
	public function hasMetadata($appKey) {
		$hasMD = false;
		{
			apptimize_util_ABTDataLock::$METADATA_LOCK->acquire();
			try {
				$hasMD = $this->metaDataCache->exists($appKey);
			}catch(Exception $__hx__e) {
				$_ex_ = ($__hx__e instanceof HException) && $__hx__e->getCode() == null ? $__hx__e->e : $__hx__e;
				$e = $_ex_;
				{
					apptimize_util_ABTDataLock::$METADATA_LOCK->release();
					throw new HException($e);
				}
			}
			apptimize_util_ABTDataLock::$METADATA_LOCK->release();
		}
		return $hasMD;
	}
	public function _getCurrentEtag($appKey) {
		$md = $this->getMetaData($appKey);
		if($md === null) {
			return null;
		}
		return $md->getEtag();
	}
	public function loadMetaData($appKey) {
		apptimize_ABTDataStore::$appKey = $appKey;
		$this->reloadFromDisk();
		if(!apptimize_ABTDataStore::shouldDisable()) {
			if(apptimize_ABTDataStore::_resetCheckTimeIfNeeded()) {
				$tmp = apptimize_api_ABTApiClient::sharedInstance();
				$tmp->downloadMetaDataForKey($appKey, $this->_getCurrentEtag($appKey));
			}
		}
	}
	public function _resetSubmitTimeIfNeeded($ignoreAppConfig = null) {
		if($ignoreAppConfig === null) {
			$ignoreAppConfig = false;
		}
		$resetClock = false;
		{
			apptimize_util_ABTDataLock::$CHECK_TIME_LOCK->acquire();
			try {
				$timeout = $this->_getMinTimeBetweenPosts($ignoreAppConfig);
				$currentTime = Date::now()->getTime();
				$timeSinceLastCheck = $currentTime - apptimize_ABTDataStore::_getLastSubmitTime();
				if($timeSinceLastCheck > $timeout) {
					apptimize_ABTDataStore::_updateLastSubmitTime($currentTime);
					$resetClock = true;
				}
			}catch(Exception $__hx__e) {
				$_ex_ = ($__hx__e instanceof HException) && $__hx__e->getCode() == null ? $__hx__e->e : $__hx__e;
				$e = $_ex_;
				{
					apptimize_util_ABTDataLock::$CHECK_TIME_LOCK->release();
					throw new HException($e);
				}
			}
			apptimize_util_ABTDataLock::$CHECK_TIME_LOCK->release();
		}
		return $resetClock;
	}
	public function _getMinTimeBetweenPosts($ignoreAppConfig = null) {
		if($ignoreAppConfig === null) {
			$ignoreAppConfig = false;
		}
		$timeout = Std::parseFloat(apptimize_support_properties_ABTConfigProperties::sharedInstance()->valueForProperty(apptimize_support_properties_ABTConfigProperties::$RESULT_POST_DELAY_MS_KEY));
		$minTimeout = $this->sdkParameters->minPostFrequencyMs;
		if($ignoreAppConfig) {
			if($minTimeout === null) {
				return -1;
			} else {
				return $minTimeout;
			}
		} else {
			$tmp = null;
			if($minTimeout !== null) {
				$tmp = $timeout < $minTimeout;
			} else {
				$tmp = false;
			}
			if($tmp) {
				return $minTimeout;
			}
			return $timeout;
		}
	}
	public function _submitResultsIfNecessary() {
		if($this->_resetSubmitTimeIfNeeded(null)) {
			$this->_flushTrackingInternal();
		}
	}
	public function reloadFromDisk() {
		$metadata = apptimize_support_persistence_ABTPersistence::loadObject(apptimize_support_persistence_ABTPersistence::$kMetadataKey, null);
		if($metadata !== null) {
			apptimize_ABTLogger::v("Existing metadata loaded from storage, will update if necessary.", _hx_anonymous(array("fileName" => "ABTDataStore.hx", "lineNumber" => 261, "className" => "apptimize.ABTDataStore", "methodName" => "reloadFromDisk")));
			$this->onMetadataLoaded($metadata);
		} else {
			apptimize_ABTLogger::v("No existing metadata found in storage.", _hx_anonymous(array("fileName" => "ABTDataStore.hx", "lineNumber" => 264, "className" => "apptimize.ABTDataStore", "methodName" => "reloadFromDisk")));
		}
	}
	public function getRequestlessEnvironment($md) {
		$anonUserId = "anon";
		$currentUserId = null;
		$customProperties = null;
		$params = $md->getAppKey();
		$params1 = new apptimize_filter_ABTFilterEnvParams($currentUserId, $anonUserId, $customProperties, $params, apptimize_support_properties_ABTApplicationProperties::sharedInstance());
		$env = $md->makeEnvironment($params1);
		return $env;
	}
	public function getUrlsForMetadata($md) {
		$env = $this->getRequestlessEnvironment($md);
		$urls = $md->extractNeededSecondaryUrls($env);
		return $urls;
	}
	public function onMetadataLoaded($md) {
		$_gthis = $this;
		$urls = $this->getUrlsForMetadata($md);
		$tmp = $this->newMdFetcher;
		$tmp1 = $md->getSecondaryValues();
		$tmp->fetch($urls, $tmp1, array(new _hx_lambda(array(&$_gthis, &$md, &$urls), "apptimize_ABTDataStore_0"), 'execute'));
	}
	public function onMetadataReceived($md) {
		$_gthis = $this;
		if($this->newMdFetcher->fetching()) {
			apptimize_ABTLogger::e("onMetadataReceived called while fetch already in progress", _hx_anonymous(array("fileName" => "ABTDataStore.hx", "lineNumber" => 333, "className" => "apptimize.ABTDataStore", "methodName" => "onMetadataReceived")));
			return;
		}
		$urls = $this->getUrlsForMetadata($md);
		$oldValues = null;
		$oldMD = $this->getMetaData($md->getAppKey());
		if($oldMD !== null) {
			$oldValues = $oldMD->getSecondaryValues();
		}
		$this->newMdFetcher->fetch($urls, $oldValues, array(new _hx_lambda(array(&$_gthis, &$md, &$urls), "apptimize_ABTDataStore_1"), 'execute'));
	}
	public function overrideMetadata($md, $fromNetwork, $secValsChanged) {
		$oldMd = null;
		$isKeyValid = true;
		$mdUpdated = false;
		{
			apptimize_util_ABTDataLock::$METADATA_LOCK->acquire();
			try {
				$isKeyValid1 = $md->getAppKey();
				$isKeyValid = $isKeyValid1 === apptimize_ABTDataStore::getAppKey();
				$key = $md->getAppKey();
				$oldMd = $this->metaDataCache->get($key);
				if($isKeyValid) {
					$tmp = null;
					if($oldMd !== null) {
						$tmp1 = $oldMd->getSequenceNumber();
						$tmp = $tmp1 < $md->getSequenceNumber();
					} else {
						$tmp = true;
					}
					if($tmp) {
						$mdUpdated = true;
					}
					$tmp2 = null;
					if(!$mdUpdated) {
						$tmp2 = $secValsChanged;
					} else {
						$tmp2 = true;
					}
					if($tmp2) {
						$this->metaDataCache->set($key, $md);
						$this->sdkParameters = $md->extractSdkParameters($this->getRequestlessEnvironment($md));
						if($fromNetwork) {
							$tmp3 = apptimize_support_persistence_ABTPersistence::$kDisabledVersions;
							apptimize_support_persistence_ABTPersistence::saveObject($tmp3, $md->getDisabledVersions(), null, null);
						}
					}
				}
			}catch(Exception $__hx__e) {
				$_ex_ = ($__hx__e instanceof HException) && $__hx__e->getCode() == null ? $__hx__e->e : $__hx__e;
				$e = $_ex_;
				{
					apptimize_util_ABTDataLock::$METADATA_LOCK->release();
					throw new HException($e);
				}
			}
			apptimize_util_ABTDataLock::$METADATA_LOCK->release();
		}
		$tmp4 = null;
		$tmp5 = null;
		if($mdUpdated) {
			$tmp5 = $fromNetwork;
		} else {
			$tmp5 = false;
		}
		if(!$tmp5) {
			$tmp4 = $secValsChanged;
		} else {
			$tmp4 = true;
		}
		if($tmp4) {
			$this->writeToDiskIfNeeded();
			$this->dispatchEnrollmentChangeCallbacks($oldMd, $md);
		}
		if($mdUpdated) {
			apptimize_events_ABTEventManager::dispatchOnMetadataUpdated();
			$tmp6 = "Updated metadata for app key \"" . _hx_string_or_null($md->getAppKey()) . "\".";
			apptimize_ABTLogger::i($tmp6, _hx_anonymous(array("fileName" => "ABTDataStore.hx", "lineNumber" => 446, "className" => "apptimize.ABTDataStore", "methodName" => "overrideMetadata")));
			$tmp7 = "New metadata:\x0A" . _hx_string_or_null(haxe_format_JsonPrinter::hprint($md->getMetaData(), null, "  "));
			apptimize_ABTLogger::v($tmp7, _hx_anonymous(array("fileName" => "ABTDataStore.hx", "lineNumber" => 448, "className" => "apptimize.ABTDataStore", "methodName" => "overrideMetadata")));
			$tmp8 = null;
			if($oldMd === null) {
				$tmp8 = apptimize_ApptimizeInternal::_trySetReady();
			} else {
				$tmp8 = false;
			}
			if($tmp8) {
				apptimize_events_ABTEventManager::dispatchOnApptimizeInitialized();
			}
		} else {
			apptimize_ABTLogger::i("Existing metadata is up-to-date.", _hx_anonymous(array("fileName" => "ABTDataStore.hx", "lineNumber" => 456, "className" => "apptimize.ABTDataStore", "methodName" => "overrideMetadata")));
		}
	}
	public function getMetaData($appKey) {
		if($this->metaDataCache === null) {
			return null;
		}
		$md = null;
		{
			apptimize_util_ABTDataLock::$METADATA_LOCK->acquire();
			try {
				$md = $this->metaDataCache->get($appKey);
			}catch(Exception $__hx__e) {
				$_ex_ = ($__hx__e instanceof HException) && $__hx__e->getCode() == null ? $__hx__e->e : $__hx__e;
				$e = $_ex_;
				{
					apptimize_util_ABTDataLock::$METADATA_LOCK->release();
					throw new HException($e);
				}
			}
			apptimize_util_ABTDataLock::$METADATA_LOCK->release();
		}
		$tmp = null;
		if($md !== null) {
			$tmp = $md->getAppKey() !== $appKey;
		} else {
			$tmp = false;
		}
		if($tmp) {
			apptimize_ABTLogger::e("Metadata appkey does not match requested key", _hx_anonymous(array("fileName" => "ABTDataStore.hx", "lineNumber" => 473, "className" => "apptimize.ABTDataStore", "methodName" => "getMetaData")));
			return null;
		}
		return $md;
	}
	public function dispatchEnrollmentChangeCallbacks($oldMetadata, $newMetadata) {
	}
	public function makeEnvironment($params) {
		return $this->getMetaData($params->appkey)->makeEnvironment($params);
	}
	public function writeToDiskIfNeeded() {
		$md = $this->getMetaData(apptimize_ABTDataStore::getAppKey());
		if($md !== null) {
			apptimize_support_persistence_ABTPersistence::saveObject(apptimize_support_persistence_ABTPersistence::$kMetadataKey, $md, null, true);
		}
	}
	public function _saveResultLogs() {
		apptimize_support_persistence_ABTPersistence::saveObject(apptimize_support_persistence_ABTPersistence::$kResultLogsKey, $this->resultLogs, null, true);
	}
	public function addResultLogEntry($env, $entry) {
		$logKey = $env->getUniqueUserID();
		{
			apptimize_ABTDataStore::$resultsLock->acquire();
			try {
				$resultLog = $this->resultLogs->getValue($logKey);
				if($resultLog === null) {
					$resultLog = new apptimize_models_results_ABTResultLog($env);
					$this->resultLogs->insert($logKey, $resultLog, (property_exists($this, "_submitResultLog") ? $this->_submitResultLog: array($this, "_submitResultLog")), $this->resultDispatchQueue);
				}
				$resultLog->logEntry($entry);
				$tmp = $resultLog->entryCount();
				if($tmp > apptimize_support_properties_ABTConfigProperties::sharedInstance()->valueForProperty(apptimize_support_properties_ABTConfigProperties::$MAXIMUM_RESULT_ENTRIES_KEY)) {
					$this->resultLogs->remove($logKey, (property_exists($this, "_submitResultLog") ? $this->_submitResultLog: array($this, "_submitResultLog")), $this->resultDispatchQueue);
				}
				$this->_saveResultLogs();
				$this->_submitResultsIfNecessary();
			}catch(Exception $__hx__e) {
				$_ex_ = ($__hx__e instanceof HException) && $__hx__e->getCode() == null ? $__hx__e->e : $__hx__e;
				$e = $_ex_;
				{
					apptimize_ABTDataStore::$resultsLock->release();
					throw new HException($e);
				}
			}
			apptimize_ABTDataStore::$resultsLock->release();
		}
	}
	public function _submitResultLog($log) {
		if(apptimize_ABTDataStore::shouldDisable()) {
			return;
		}
		$tmp = apptimize_api_ABTApiClient::sharedInstance();
		$tmp->postResultsForKey($log->getAppKey(), $log);
		$this->_saveResultLogs();
	}
	public function flushTracking() {
		if($this->_resetSubmitTimeIfNeeded(true)) {
			$this->_flushTrackingInternal();
		}
	}
	public function _flushTrackingInternal() {
		apptimize_ABTLogger::v("Posting results...", _hx_anonymous(array("fileName" => "ABTDataStore.hx", "lineNumber" => 723, "className" => "apptimize.ABTDataStore", "methodName" => "_flushTrackingInternal")));
		{
			apptimize_ABTDataStore::$resultsLock->acquire();
			try {
				$this->resultLogs->clear((property_exists($this, "_submitResultLog") ? $this->_submitResultLog: array($this, "_submitResultLog")), $this->resultDispatchQueue);
				$this->_saveResultLogs();
			}catch(Exception $__hx__e) {
				$_ex_ = ($__hx__e instanceof HException) && $__hx__e->getCode() == null ? $__hx__e->e : $__hx__e;
				$e = $_ex_;
				{
					apptimize_ABTDataStore::$resultsLock->release();
					throw new HException($e);
				}
			}
			apptimize_ABTDataStore::$resultsLock->release();
		}
	}
	public function incrementVariantRunCount($params, $variant) {
		if((is_object($_t = Type::getClass($variant)) && ($_t instanceof Enum) ? $_t == _hx_qtype("apptimize.models.ABTHotfixVariant") : _hx_equal($_t, _hx_qtype("apptimize.models.ABTHotfixVariant")))) {
			return;
		}
		$variantStickyString = "v" . _hx_string_rec($variant->getVariantID(), "") . "_";
		$variantStickyString1 = _hx_string_or_null($variantStickyString) . _hx_string_rec($variant->getCycle(), "");
		$experimentStickyString = "e" . _hx_string_rec($variant->getExperimentID(), "") . "_";
		$experimentStickyString1 = _hx_string_or_null($experimentStickyString) . _hx_string_rec($variant->getCycle(), "");
		$phase = $variant->getPhase();
		$isFirstParticipation = false;
		$env = $this->makeEnvironment($params);
		$variantShownEntry = $variant->getVariantID();
		$variantShownEntry1 = new apptimize_models_results_ABTResultEntryVariantShown($env, $variantShownEntry, $variant->getCycle(), $phase);
		$tmp = "Incrementing variant run count for variant ID \"" . _hx_string_rec($variant->getVariantID(), "") . "\".";
		apptimize_ABTLogger::v($tmp, _hx_anonymous(array("fileName" => "ABTDataStore.hx", "lineNumber" => 758, "className" => "apptimize.ABTDataStore", "methodName" => "incrementVariantRunCount")));
		$variantInfo = apptimize_VariantInfo::initWithVariant($variant, $env->userID, $env->anonID);
		apptimize_events_ABTEventManager::dispatchOnParticipatedInExperiment($variantInfo, $isFirstParticipation);
		$this->addResultLogEntry($env, $variantShownEntry1);
	}
	public function generateEvent($eventName, $eventSource, $eventAttributes, $params) {
		$tmp = null;
		if(!(!apptimize_Apptimize::_isInitialized())) {
			$tmp = apptimize_ABTDataStore::sharedInstance()->getMetaData($params->appkey) === null;
		} else {
			$tmp = true;
		}
		if($tmp) {
			apptimize_ABTLogger::w("Event \"" . _hx_string_or_null($eventName) . "\" will not be tracked until Apptimize.setup() is called and MetaData available.", _hx_anonymous(array("fileName" => "ABTDataStore.hx", "lineNumber" => 769, "className" => "apptimize.ABTDataStore", "methodName" => "generateEvent")));
			return;
		}
		$env = $this->makeEnvironment($params);
		$eventEntry = new apptimize_models_results_ABTResultEntryEvent($env, $eventName, $eventSource, $eventAttributes);
		$logString = "Event \"" . _hx_string_or_null($eventName) . "\"";
		if($eventAttributes !== null) {
			$logString = _hx_string_or_null($logString) . " with attribute(s) " . Std::string($eventAttributes);
		}
		$logString = _hx_string_or_null($logString) . " tracked.";
		apptimize_ABTLogger::v($logString, _hx_anonymous(array("fileName" => "ABTDataStore.hx", "lineNumber" => 783, "className" => "apptimize.ABTDataStore", "methodName" => "generateEvent")));
		$this->addResultLogEntry($env, $eventEntry);
	}
	public function __call($m, $a) {
		if(isset($this->$m) && is_callable($this->$m))
			return call_user_func_array($this->$m, $a);
		else if(isset($this->__dynamics[$m]) && is_callable($this->__dynamics[$m]))
			return call_user_func_array($this->__dynamics[$m], $a);
		else if('toString' == $m)
			return $this->__toString();
		else
			throw new HException('Unable to call <'.$m.'>');
	}
	static $appKey;
	static $serverGuid;
	static $_instance;
	static $resultsLock;
	static function sharedInstance() {
		if(apptimize_ABTDataStore::$_instance === null) {
			apptimize_ABTDataStore::$_instance = new apptimize_ABTDataStore();
		}
		return apptimize_ABTDataStore::$_instance;
	}
	static function clear() {
		apptimize_support_persistence_ABTPersistence::clear();
		apptimize_ABTDataStore::$_instance = null;
	}
	static function shutdown() {
		apptimize_ABTDataStore::$_instance = null;
		apptimize_ABTDataStore::$appKey = null;
		apptimize_ABTDataStore::$serverGuid = null;
	}
	static function _getLastCheckTime() {
		$lastCheckTime = apptimize_support_persistence_ABTPersistence::loadString(apptimize_support_persistence_ABTPersistence::$kMetadataLastCheckTimeKey, null);
		if($lastCheckTime !== null) {
			return Std::parseFloat($lastCheckTime);
		}
		return -10000.0;
	}
	static function _updateLastCheckTime($checkTime) {
		$tmp = apptimize_support_persistence_ABTPersistence::$kMetadataLastCheckTimeKey;
		apptimize_support_persistence_ABTPersistence::saveString($tmp, Std::string($checkTime), null, null);
	}
	static function _resetCheckTimeIfNeeded() {
		$resetClock = false;
		{
			apptimize_util_ABTDataLock::$CHECK_TIME_LOCK->acquire();
			try {
				$timeout = Std::parseFloat(apptimize_support_properties_ABTConfigProperties::sharedInstance()->valueForProperty(apptimize_support_properties_ABTConfigProperties::$METADATA_POLLING_INTERVAL_MS_KEY));
				$currentTime = Date::now()->getTime();
				$timeSinceLastCheck = $currentTime - apptimize_ABTDataStore::_getLastCheckTime();
				if($timeSinceLastCheck > $timeout) {
					apptimize_ABTDataStore::_updateLastCheckTime($currentTime);
					$resetClock = true;
				}
			}catch(Exception $__hx__e) {
				$_ex_ = ($__hx__e instanceof HException) && $__hx__e->getCode() == null ? $__hx__e->e : $__hx__e;
				$e = $_ex_;
				{
					apptimize_util_ABTDataLock::$CHECK_TIME_LOCK->release();
					throw new HException($e);
				}
			}
			apptimize_util_ABTDataLock::$CHECK_TIME_LOCK->release();
		}
		return $resetClock;
	}
	static function _getLastSubmitTime() {
		$lastSubmitCheckTime = apptimize_support_persistence_ABTPersistence::loadString(apptimize_support_persistence_ABTPersistence::$kResultLastSubmitTimeKey, null);
		if($lastSubmitCheckTime !== null) {
			return Std::parseFloat($lastSubmitCheckTime);
		}
		return -10000.0;
	}
	static function _updateLastSubmitTime($checkTime) {
		$tmp = apptimize_support_persistence_ABTPersistence::$kResultLastSubmitTimeKey;
		apptimize_support_persistence_ABTPersistence::saveString($tmp, Std::string($checkTime), null, null);
	}
	static function getAppKey() {
		return apptimize_ABTDataStore::$appKey;
	}
	static function checkForUpdatedMetaData($checkImmediately = null) {
		if($checkImmediately === null) {
			$checkImmediately = false;
		}
		if(apptimize_ABTDataStore::shouldDisable()) {
			apptimize_ABTLogger::w("This SDK version disabled; not checking for updated metadata", _hx_anonymous(array("fileName" => "ABTDataStore.hx", "lineNumber" => 223, "className" => "apptimize.ABTDataStore", "methodName" => "checkForUpdatedMetaData")));
			return;
		}
		apptimize_ABTLogger::v("Checking for updated metadata...", _hx_anonymous(array("fileName" => "ABTDataStore.hx", "lineNumber" => 226, "className" => "apptimize.ABTDataStore", "methodName" => "checkForUpdatedMetaData")));
		$tmp = null;
		if(apptimize_Apptimize::_isInitialized()) {
			if(!apptimize_ABTDataStore::_resetCheckTimeIfNeeded()) {
				$tmp = $checkImmediately;
			} else {
				$tmp = true;
			}
		} else {
			$tmp = false;
		}
		if($tmp) {
			$tmp1 = apptimize_api_ABTApiClient::sharedInstance();
			$tmp2 = apptimize_ABTDataStore::getAppKey();
			$tmp3 = apptimize_ABTDataStore::sharedInstance();
			$tmp1->downloadMetaDataForKey($tmp2, $tmp3->_getCurrentEtag(apptimize_ABTDataStore::getAppKey()));
		}
	}
	static function _checkForUpdatedMetadataIfNecessary() {
		$tmp = null;
		if(!apptimize_api_ABTMetadataPoller::isPolling()) {
			$tmp = apptimize_support_properties_ABTConfigProperties::sharedInstance()->valueForProperty(apptimize_support_properties_ABTConfigProperties::$METADATA_POLLING_INTERVAL_MS_KEY) >= 0;
		} else {
			$tmp = false;
		}
		if($tmp) {
			apptimize_ABTDataStore::checkForUpdatedMetaData(null);
		}
		apptimize_ABTDataStore::sharedInstance()->_submitResultsIfNecessary();
	}
	static function getServerGUID() {
		apptimize_ABTDataStore::$serverGuid = apptimize_support_persistence_ABTPersistence::loadString(apptimize_support_persistence_ABTPersistence::$kServerInstanceGUIDKey, null);
		if(apptimize_ABTDataStore::$serverGuid === null) {
			apptimize_ABTDataStore::$serverGuid = apptimize_api_ABTUserGuid::generateUserGuid();
			apptimize_support_persistence_ABTPersistence::saveString(apptimize_support_persistence_ABTPersistence::$kServerInstanceGUIDKey, apptimize_ABTDataStore::$serverGuid, null, null);
		}
		return apptimize_ABTDataStore::$serverGuid;
	}
	static function shouldDisable() {
		$disabledVersions = apptimize_support_persistence_ABTPersistence::loadObject(apptimize_support_persistence_ABTPersistence::$kDisabledVersions, null);
		if($disabledVersions === null) {
			return false;
		}
		if($disabledVersions->indexOf(apptimize_Apptimize::getApptimizeSDKVersion(), null) > -1) {
			return true;
		}
		return false;
	}
	function __toString() { return 'apptimize.ABTDataStore'; }
}
apptimize_ABTDataStore::$resultsLock = apptimize_util_ABTDataLock::getNewLock("datastore_results_lock");
function apptimize_ABTDataStore_0(&$_gthis, &$md, &$urls, $values, $fetched) {
	{
		$currentUrls = $_gthis->getUrlsForMetadata($md);
		if($_gthis->newMdFetcher->needNewUrls($urls, $currentUrls)) {
			apptimize_ABTLogger::w("urls changed while fetching values, retrying", _hx_anonymous(array("fileName" => "ABTDataStore.hx", "lineNumber" => 312, "className" => "apptimize.ABTDataStore", "methodName" => "onMetadataLoaded")));
			$_gthis->onMetadataLoaded($md);
			return;
		}
		$md->setSecondaryValues($values);
		$_gthis->overrideMetadata($md, false, $fetched);
	}
}
function apptimize_ABTDataStore_1(&$_gthis, &$md, &$urls, $values, $fetched) {
	{
		$currentUrls = $_gthis->getUrlsForMetadata($md);
		if($_gthis->newMdFetcher->needNewUrls($urls, $currentUrls)) {
			apptimize_ABTLogger::w("urls changed while fetching values, retrying", _hx_anonymous(array("fileName" => "ABTDataStore.hx", "lineNumber" => 347, "className" => "apptimize.ABTDataStore", "methodName" => "onMetadataReceived")));
			$_gthis->onMetadataReceived($md);
			return;
		}
		$md->setSecondaryValues($values);
		$_gthis->overrideMetadata($md, true, $fetched);
	}
}
