<?php

// Copyright (c) Apptimize, Inc. | https://sdk.apptimize.com/license
class apptimize_ABTLogger {
	public function __construct(){}
	static $LOG_LEVEL_VERBOSE = 0;
	static $LOG_LEVEL_DEBUG = 1;
	static $LOG_LEVEL_INFO = 2;
	static $LOG_LEVEL_WARN = 3;
	static $LOG_LEVEL_ERROR = 4;
	static $LOG_LEVEL_NONE = 5;
	static $logLevel;
	static $useTraceForLogging = false;
	static function logLevelFromString($logLevel) {
		$level = strtoupper($logLevel);
		if($level === "LOG_LEVEL_VERBOSE") {
			return apptimize_ABTLogger::$LOG_LEVEL_VERBOSE;
		}
		if($level === "LOG_LEVEL_DEBUG") {
			return apptimize_ABTLogger::$LOG_LEVEL_DEBUG;
		}
		if($level === "LOG_LEVEL_INFO") {
			return apptimize_ABTLogger::$LOG_LEVEL_INFO;
		}
		if($level === "LOG_LEVEL_WARN") {
			return apptimize_ABTLogger::$LOG_LEVEL_WARN;
		}
		if($level === "LOG_LEVEL_ERROR") {
			return apptimize_ABTLogger::$LOG_LEVEL_ERROR;
		}
		if($level === "LOG_LEVEL_NONE") {
			return apptimize_ABTLogger::$LOG_LEVEL_NONE;
		}
		return apptimize_ABTLogger::$LOG_LEVEL_NONE;
	}
	static function setLogLevel($level) {
		apptimize_ABTLogger::$logLevel = $level;
	}
	static function c($msg, $infos = null) {
		apptimize_ABTLogger::log_out($msg, $infos);
		apptimize_util_ABTException::throwException($msg);
	}
	static function e($msg, $infos = null) {
		if(apptimize_ABTLogger::$logLevel <= apptimize_ABTLogger::$LOG_LEVEL_ERROR) {
			apptimize_ABTLogger::log_out($msg, $infos);
		}
	}
	static function w($msg, $infos = null) {
		if(apptimize_ABTLogger::$logLevel <= apptimize_ABTLogger::$LOG_LEVEL_WARN) {
			apptimize_ABTLogger::log_out($msg, $infos);
		}
	}
	static function i($msg, $infos = null) {
		if(apptimize_ABTLogger::$logLevel <= apptimize_ABTLogger::$LOG_LEVEL_INFO) {
			apptimize_ABTLogger::log_out($msg, $infos);
		}
	}
	static function d($msg, $infos = null) {
		if(apptimize_ABTLogger::$logLevel <= apptimize_ABTLogger::$LOG_LEVEL_DEBUG) {
			apptimize_ABTLogger::log_out($msg, $infos);
		}
	}
	static function v($msg, $infos = null) {
		if(apptimize_ABTLogger::$logLevel <= apptimize_ABTLogger::$LOG_LEVEL_VERBOSE) {
			apptimize_ABTLogger::log_out($msg, $infos);
		}
	}
	static function log_out($msg, $infos) {
		$tmp = null;
		if(apptimize_ABTLogger::$useTraceForLogging) {
			$tmp = (is_object($_t = haxe_Log::$trace) && ($_t instanceof Enum) ? $_t != apptimize_ABTLogger::$trace : !_hx_equal($_t, apptimize_ABTLogger::$trace));
		} else {
			$tmp = false;
		}
		if($tmp) {
			haxe_Log::trace($msg, $infos);
			return;
		}
		apptimize_native_php_Logging::error_log($msg);
	}
	static function redirectTraceStatements() {
		haxe_Log::$trace = (property_exists("apptimize_ABTLogger", "trace") ? apptimize_ABTLogger::$trace: array("apptimize_ABTLogger", "trace"));
	}
	static function trace($val, $infos = null) {
		$str = Std::string($val);
		apptimize_ABTLogger::v($str, $infos);
	}
	function __toString() { return 'apptimize.ABTLogger'; }
}
apptimize_ABTLogger::$logLevel = apptimize_ABTLogger::$LOG_LEVEL_VERBOSE;
