<?php

// Copyright (c) Apptimize, Inc. | https://sdk.apptimize.com/license
class apptimize_Apptimize {
	public function __construct(){}
	static function _isInitialized() {
		return apptimize_ApptimizeInternal::_isInitialized();
	}
	static function _getApptimizeAnonUserId() {
		$anonUserId = apptimize_support_persistence_ABTPersistence::loadString(apptimize_support_persistence_ABTPersistence::$kAnonymousGuidKey, null);
		$tmp = null;
		$tmp1 = null;
		if($anonUserId !== null) {
			$tmp1 = $anonUserId === "";
		} else {
			$tmp1 = true;
		}
		if(!$tmp1) {
			$tmp = !apptimize_api_ABTUserGuid::isValidGuid($anonUserId);
		} else {
			$tmp = true;
		}
		if($tmp) {
			$anonUserId = apptimize_api_ABTUserGuid::generateUserGuid();
			apptimize_support_persistence_ABTPersistence::saveString(apptimize_support_persistence_ABTPersistence::$kAnonymousGuidKey, $anonUserId, null, null);
		}
		return $anonUserId;
	}
	static function setAppVersion($version) {
		apptimize_support_properties_ABTApplicationProperties::sharedInstance()->setProperty("app_version", $version);
		$app_version = apptimize_support_properties_ABTApplicationProperties::sharedInstance()->valueForProperty("app_version");
		apptimize_ABTLogger::v("App Version set to: " . _hx_string_or_null($app_version), _hx_anonymous(array("fileName" => "Apptimize.hx", "lineNumber" => 237, "className" => "apptimize.Apptimize", "methodName" => "setAppVersion")));
	}
	static function setAppName($name) {
		apptimize_support_properties_ABTApplicationProperties::sharedInstance()->setProperty("app_name", $name);
		$app_name = apptimize_support_properties_ABTApplicationProperties::sharedInstance()->valueForProperty("app_name");
		apptimize_ABTLogger::v("App Name set to: " . _hx_string_or_null($app_name), _hx_anonymous(array("fileName" => "Apptimize.hx", "lineNumber" => 248, "className" => "apptimize.Apptimize", "methodName" => "setAppName")));
	}
	static function setOnParticipationCallback($callback) {
		apptimize_events_ABTEventManager::setOnParticipationCallback($callback);
		apptimize_ABTLogger::w("setOnParticipationCallback is deprecated - please use setOnParticipatedInExperimentCallback.", _hx_anonymous(array("fileName" => "Apptimize.hx", "lineNumber" => 269, "className" => "apptimize.Apptimize", "methodName" => "setOnParticipationCallback")));
	}
	static function setOnMetadataUpdatedCallback($callback) {
		apptimize_events_ABTEventManager::setOnMetadataUpdatedCallback($callback);
		apptimize_ABTLogger::v("OnMetadataProcessedCallback set!", _hx_anonymous(array("fileName" => "Apptimize.hx", "lineNumber" => 288, "className" => "apptimize.Apptimize", "methodName" => "setOnMetadataUpdatedCallback")));
	}
	static function setOnApptimizeInitializedCallback($callback) {
		apptimize_events_ABTEventManager::setOnApptimizeInitializedCallback($callback);
		apptimize_ABTLogger::v("OnApptimizeInitializedCallback set!", _hx_anonymous(array("fileName" => "Apptimize.hx", "lineNumber" => 307, "className" => "apptimize.Apptimize", "methodName" => "setOnApptimizeInitializedCallback")));
	}
	static function setOnParticipatedInExperimentCallback($callback) {
		apptimize_events_ABTEventManager::setOnParticipatedInExperimentCallback($callback);
		apptimize_ABTLogger::v("OnParticipatedInExperimentCallback set!", _hx_anonymous(array("fileName" => "Apptimize.hx", "lineNumber" => 325, "className" => "apptimize.Apptimize", "methodName" => "setOnParticipatedInExperimentCallback")));
	}
	static function setup($appKey, $configAttributes = null) {
		$tmp = null;
		if($appKey !== null) {
			$tmp = $appKey === "";
		} else {
			$tmp = true;
		}
		if($tmp) {
			apptimize_ABTLogger::c("Unable to initialize Apptimize due to missing app key.", _hx_anonymous(array("fileName" => "Apptimize.hx", "lineNumber" => 377, "className" => "apptimize.Apptimize", "methodName" => "setup")));
			return;
		} else {
			$tmp1 = null;
			if(apptimize_ABTDataStore::getAppKey() !== null) {
				$tmp2 = apptimize_ABTDataStore::getAppKey();
				$tmp1 = $tmp2 === $appKey;
			} else {
				$tmp1 = false;
			}
			if($tmp1) {
				apptimize_ABTLogger::w("Apptimize is already initialized with app key: \"" . _hx_string_or_null($appKey) . "\".", _hx_anonymous(array("fileName" => "Apptimize.hx", "lineNumber" => 380, "className" => "apptimize.Apptimize", "methodName" => "setup")));
				return;
			}
		}
		apptimize_ApptimizeInternal::_setup($appKey, $configAttributes, array(new _hx_lambda(array(&$appKey), "apptimize_Apptimize_0"), 'execute'));
	}
	static function shutdown() {
		apptimize_ApptimizeInternal::shutdown();
	}
	static function updateApptimizeMetadataOnce() {
		apptimize_ABTDataStore::checkForUpdatedMetaData(true);
	}
	static function flushTracking() {
		if(apptimize_Apptimize::_isInitialized()) {
			apptimize_ABTDataStore::sharedInstance()->flushTracking();
		} else {
			apptimize_ABTLogger::w("Tracking can only be flushed after setup().", _hx_anonymous(array("fileName" => "Apptimize.hx", "lineNumber" => 435, "className" => "apptimize.Apptimize", "methodName" => "flushTracking")));
		}
	}
	static function getApptimizeSDKVersion() {
		return "1.2.23";
	}
	static function getApptimizeSDKPlatform() {
		$sdkPlatform = "N/A";
		$sdkPlatform = "PHP";
		return $sdkPlatform;
	}
	static function _initialize($appKey) {
		apptimize_ABTDataStore::sharedInstance()->loadMetaData($appKey);
		apptimize_ApptimizeInternal::setState(2);
		$tmp = null;
		$tmp1 = apptimize_ABTDataStore::sharedInstance();
		if($tmp1->hasMetadata(apptimize_ABTDataStore::getAppKey())) {
			$tmp = apptimize_ApptimizeInternal::_trySetReady();
		} else {
			$tmp = false;
		}
		if($tmp) {
			apptimize_events_ABTEventManager::dispatchOnApptimizeInitialized();
		}
		apptimize_ABTLogger::i("Apptimize initialized with app key \"" . _hx_string_or_null($appKey) . "\".", _hx_anonymous(array("fileName" => "Apptimize.hx", "lineNumber" => 492, "className" => "apptimize.Apptimize", "methodName" => "_initialize")));
	}
	static function _getAlterations($userID, $customAttributes) {
		apptimize_ABTDataStore::_checkForUpdatedMetadataIfNecessary();
		if(apptimize_Apptimize::_isInitialized()) {
			$envParams = apptimize_Apptimize::_getApptimizeAnonUserId();
			$envParams1 = apptimize_ABTDataStore::getAppKey();
			$envParams2 = new apptimize_filter_ABTFilterEnvParams($userID, $envParams, $customAttributes, $envParams1, apptimize_support_properties_ABTApplicationProperties::sharedInstance());
			return apptimize_ApptimizeInternal::_getAlterations($envParams2);
		}
		return new _hx_array(array());
	}
	static function _getCodeBlockMethod($codeBlockVariableName, $userID, $customAttributes) {
		apptimize_ABTDataStore::_checkForUpdatedMetadataIfNecessary();
		$envParams = apptimize_Apptimize::_getApptimizeAnonUserId();
		$envParams1 = apptimize_ABTDataStore::getAppKey();
		$envParams2 = new apptimize_filter_ABTFilterEnvParams($userID, $envParams, $customAttributes, $envParams1, apptimize_support_properties_ABTApplicationProperties::sharedInstance());
		return apptimize_ApptimizeInternal::_getCodeBlockMethod($envParams2, $codeBlockVariableName);
	}
	static function runCodeBlock($codeBlockVariableName, $callback, $userID, $customAttributes = null) {
		$tmp = null;
		if($userID === null) {
			$tmp = false;
		} else {
			$tmp = false;
		}
		if($tmp) {
			apptimize_ABTLogger::c("The parameter " . _hx_string_rec(null, "") . " is required for " . "apptimize.Apptimize.runCodeBlock", _hx_anonymous(array("fileName" => "ABTClientMacro.hx", "lineNumber" => 41, "className" => "apptimize.Apptimize", "methodName" => "runCodeBlock")));
		}
		$tmp1 = null;
		if($customAttributes === null) {
			$tmp1 = false;
		} else {
			$tmp1 = false;
		}
		if($tmp1) {
			apptimize_ABTLogger::c("The parameter " . _hx_string_rec(null, "") . " is required for " . "apptimize.Apptimize.runCodeBlock", _hx_anonymous(array("fileName" => "ABTClientMacro.hx", "lineNumber" => 41, "className" => "apptimize.Apptimize", "methodName" => "runCodeBlock")));
		}
		$attrs = apptimize_util_ABTUtilDictionary::nativeObjectToStringMap($customAttributes);
		$methodName = apptimize_Apptimize::_getCodeBlockMethod($codeBlockVariableName, $userID, $attrs);
		$callbackMap = apptimize_util_ABTUtilDictionary::nativeObjectToStringMap($callback);
		$tmp2 = null;
		if($methodName !== null) {
			$tmp2 = $methodName === "";
		} else {
			$tmp2 = true;
		}
		if($tmp2) {
			apptimize_ABTLogger::w("No Code Block with variable name " . _hx_string_or_null($codeBlockVariableName) . " found, skipping callback.", _hx_anonymous(array("fileName" => "Apptimize.hx", "lineNumber" => 586, "className" => "apptimize.Apptimize", "methodName" => "runCodeBlock")));
			return;
		} else {
			$tmp3 = null;
			if($callback !== null) {
				$tmp3 = $callbackMap->get($methodName) === null;
			} else {
				$tmp3 = true;
			}
			if($tmp3) {
				$method = Reflect::getProperty($callback, $methodName);
				if($method !== null) {
					Reflect::callMethod($callback, $method, (new _hx_array(array())));
				} else {
					apptimize_ABTLogger::w("Supplied callbacks do not include method: " . _hx_string_or_null($methodName), _hx_anonymous(array("fileName" => "Apptimize.hx", "lineNumber" => 594, "className" => "apptimize.Apptimize", "methodName" => "runCodeBlock")));
				}
			} else {
				apptimize_ABTLogger::v("Calling callback method: " . _hx_string_or_null($methodName), _hx_anonymous(array("fileName" => "Apptimize.hx", "lineNumber" => 597, "className" => "apptimize.Apptimize", "methodName" => "runCodeBlock")));
				$func = $callbackMap->get($methodName);
				if(!Reflect::isFunction($func)) {
					apptimize_ABTLogger::e("runCodeBlock() called with callback that isn't a function/method.", _hx_anonymous(array("fileName" => "Apptimize.hx", "lineNumber" => 601, "className" => "apptimize.Apptimize", "methodName" => "runCodeBlock")));
					return;
				}
				call_user_func($func);
			}
		}
	}
	static function isFeatureFlagEnabled($name, $userID, $customAttributes = null) {
		return apptimize_Apptimize::getBool($name, false, $userID, $customAttributes);
	}
	static function getString($name, $defaultValue, $userID, $customAttributes = null) {
		$stringValue = apptimize_Apptimize::_getValue($name, $userID, apptimize_ABTApptimizeVariableType::$String, null, $customAttributes);
		if($stringValue === null) {
			return $defaultValue;
		}
		return $stringValue;
	}
	static function getBool($name, $defaultValue, $userID, $customAttributes = null) {
		$boolValue = apptimize_Apptimize::_getValue($name, $userID, apptimize_ABTApptimizeVariableType::$Boolean, null, $customAttributes);
		if($boolValue === null) {
			return $defaultValue;
		}
		return $boolValue;
	}
	static function getInt($name, $defaultValue, $userID, $customAttributes = null) {
		$intValue = apptimize_Apptimize::_getValue($name, $userID, apptimize_ABTApptimizeVariableType::$Integer, null, $customAttributes);
		if($intValue === null) {
			return $defaultValue;
		}
		return $intValue;
	}
	static function getDouble($name, $defaultValue, $userID, $customAttributes = null) {
		$floatValue = apptimize_Apptimize::_getValue($name, $userID, apptimize_ABTApptimizeVariableType::$Double, null, $customAttributes);
		if($floatValue === null) {
			return $defaultValue;
		}
		return $floatValue;
	}
	static function getStringArray($name, $defaultValue, $userID, $customAttributes = null) {
		$stringArrayValue = apptimize_Apptimize::_getValue($name, $userID, apptimize_ABTApptimizeVariableType::$hArray, apptimize_ABTApptimizeVariableType::$String, $customAttributes);
		if($stringArrayValue === null) {
			return $defaultValue;
		}
		return apptimize_util_ABTUtilArray::toNativeArray($stringArrayValue, apptimize_util_ArrayType::$String);
	}
	static function getBoolArray($name, $defaultValue, $userID, $customAttributes = null) {
		$boolArrayValue = apptimize_Apptimize::_getValue($name, $userID, apptimize_ABTApptimizeVariableType::$hArray, apptimize_ABTApptimizeVariableType::$Boolean, $customAttributes);
		if($boolArrayValue === null) {
			return $defaultValue;
		}
		return apptimize_util_ABTUtilArray::toNativeArray($boolArrayValue, apptimize_util_ArrayType::$Bool);
	}
	static function getIntArray($name, $defaultValue, $userID, $customAttributes = null) {
		$intArrayValue = apptimize_Apptimize::_getValue($name, $userID, apptimize_ABTApptimizeVariableType::$hArray, apptimize_ABTApptimizeVariableType::$Integer, $customAttributes);
		if($intArrayValue === null) {
			return $defaultValue;
		}
		return apptimize_util_ABTUtilArray::toNativeArray($intArrayValue, apptimize_util_ArrayType::$Int);
	}
	static function getDoubleArray($name, $defaultValue, $userID, $customAttributes = null) {
		$doubleArrayValue = apptimize_Apptimize::_getValue($name, $userID, apptimize_ABTApptimizeVariableType::$hArray, apptimize_ABTApptimizeVariableType::$Double, $customAttributes);
		if($doubleArrayValue === null) {
			return $defaultValue;
		}
		return apptimize_util_ABTUtilArray::toNativeArray($doubleArrayValue, apptimize_util_ArrayType::$Double);
	}
	static function getStringDictionary($name, $defaultValue, $userID, $customAttributes = null) {
		$stringDictionaryValue = apptimize_Apptimize::_getValue($name, $userID, apptimize_ABTApptimizeVariableType::$Dictionary, apptimize_ABTApptimizeVariableType::$String, $customAttributes);
		if($stringDictionaryValue === null) {
			return $defaultValue;
		}
		return $stringDictionaryValue;
	}
	static function getBoolDictionary($name, $defaultValue, $userID, $customAttributes = null) {
		$boolDictionaryValue = apptimize_Apptimize::_getValue($name, $userID, apptimize_ABTApptimizeVariableType::$Dictionary, apptimize_ABTApptimizeVariableType::$Boolean, $customAttributes);
		if($boolDictionaryValue === null) {
			return $defaultValue;
		}
		return $boolDictionaryValue;
	}
	static function getIntDictionary($name, $defaultValue, $userID, $customAttributes = null) {
		$intDictionaryValue = apptimize_Apptimize::_getValue($name, $userID, apptimize_ABTApptimizeVariableType::$Dictionary, apptimize_ABTApptimizeVariableType::$Integer, $customAttributes);
		if($intDictionaryValue === null) {
			return $defaultValue;
		}
		return $intDictionaryValue;
	}
	static function getDoubleDictionary($name, $defaultValue, $userID, $customAttributes = null) {
		$doubleDictionaryValue = apptimize_Apptimize::_getValue($name, $userID, apptimize_ABTApptimizeVariableType::$Dictionary, apptimize_ABTApptimizeVariableType::$Double, $customAttributes);
		if($doubleDictionaryValue === null) {
			return $defaultValue;
		}
		return $doubleDictionaryValue;
	}
	static function _getValue($name, $userID, $type, $nestedType, $customAttributes = null) {
		if(!apptimize_Apptimize::_isInitialized()) {
			return null;
		}
		$tmp = null;
		if($userID === null) {
			$tmp = false;
		} else {
			$tmp = false;
		}
		if($tmp) {
			apptimize_ABTLogger::c("The parameter " . _hx_string_rec(null, "") . " is required for " . "apptimize.Apptimize._getValue", _hx_anonymous(array("fileName" => "ABTClientMacro.hx", "lineNumber" => 41, "className" => "apptimize.Apptimize", "methodName" => "_getValue")));
		}
		$tmp1 = null;
		if($customAttributes === null) {
			$tmp1 = false;
		} else {
			$tmp1 = false;
		}
		if($tmp1) {
			apptimize_ABTLogger::c("The parameter " . _hx_string_rec(null, "") . " is required for " . "apptimize.Apptimize._getValue", _hx_anonymous(array("fileName" => "ABTClientMacro.hx", "lineNumber" => 41, "className" => "apptimize.Apptimize", "methodName" => "_getValue")));
		}
		$attrMap = apptimize_util_ABTUtilDictionary::nativeObjectToStringMap($customAttributes);
		$envParams = apptimize_Apptimize::_getApptimizeAnonUserId();
		$envParams1 = apptimize_ABTDataStore::getAppKey();
		$envParams2 = new apptimize_filter_ABTFilterEnvParams($userID, $envParams, $attrMap, $envParams1, apptimize_support_properties_ABTApplicationProperties::sharedInstance());
		return apptimize_ABTApptimizeVariable::getValue($envParams2, $name, $type, $nestedType);
	}
	static function getVariantInfo($userID, $customAttributes = null) {
		$tmp = null;
		if($userID === null) {
			$tmp = false;
		} else {
			$tmp = false;
		}
		if($tmp) {
			apptimize_ABTLogger::c("The parameter " . _hx_string_rec(null, "") . " is required for " . "apptimize.Apptimize.getVariantInfo", _hx_anonymous(array("fileName" => "ABTClientMacro.hx", "lineNumber" => 41, "className" => "apptimize.Apptimize", "methodName" => "getVariantInfo")));
		}
		$tmp1 = null;
		if($customAttributes === null) {
			$tmp1 = false;
		} else {
			$tmp1 = false;
		}
		if($tmp1) {
			apptimize_ABTLogger::c("The parameter " . _hx_string_rec(null, "") . " is required for " . "apptimize.Apptimize.getVariantInfo", _hx_anonymous(array("fileName" => "ABTClientMacro.hx", "lineNumber" => 41, "className" => "apptimize.Apptimize", "methodName" => "getVariantInfo")));
		}
		$variantInfos = new _hx_array(array());
		$anonID = apptimize_Apptimize::_getApptimizeAnonUserId();
		$attrMap = apptimize_util_ABTUtilDictionary::nativeObjectToStringMap($customAttributes);
		$envParams = apptimize_ABTDataStore::getAppKey();
		$envParams1 = new apptimize_filter_ABTFilterEnvParams($userID, $anonID, $attrMap, $envParams, apptimize_support_properties_ABTApplicationProperties::sharedInstance());
		{
			$_g = 0;
			$_g1 = apptimize_ApptimizeInternal::_getVariants($envParams1);
			while($_g < $_g1->length) {
				$variant = $_g1[$_g];
				$_g = $_g + 1;
				$variantInfos->push(apptimize_VariantInfo::initWithVariant($variant, $userID, $anonID));
				unset($variant);
			}
		}
		return apptimize_util_ABTUtilArray::toNativeArray($variantInfos, apptimize_util_ArrayType::$VariantInfo);
	}
	static function _getVariantInfoForAlteration($name, $userID, $customAttributes) {
		$anonID = apptimize_Apptimize::_getApptimizeAnonUserId();
		{
			$_g = 0;
			$_g1 = apptimize_Apptimize::_getAlterations($userID, $customAttributes);
			while($_g < $_g1->length) {
				$alteration = $_g1[$_g];
				$_g = $_g + 1;
				if($alteration->getKey() === $name) {
					return apptimize_VariantInfo::initWithVariant($alteration->getVariant(), $userID, $anonID);
				}
				unset($alteration);
			}
		}
		return null;
	}
	static function _getVariantInfoForDynamicVariable($name, $userID, $customAttributes = null) {
		$tmp = null;
		if($userID === null) {
			$tmp = false;
		} else {
			$tmp = false;
		}
		if($tmp) {
			apptimize_ABTLogger::c("The parameter " . _hx_string_rec(null, "") . " is required for " . "apptimize.Apptimize._getVariantInfoForDynamicVariable", _hx_anonymous(array("fileName" => "ABTClientMacro.hx", "lineNumber" => 41, "className" => "apptimize.Apptimize", "methodName" => "_getVariantInfoForDynamicVariable")));
		}
		$tmp1 = null;
		if($customAttributes === null) {
			$tmp1 = false;
		} else {
			$tmp1 = false;
		}
		if($tmp1) {
			apptimize_ABTLogger::c("The parameter " . _hx_string_rec(null, "") . " is required for " . "apptimize.Apptimize._getVariantInfoForDynamicVariable", _hx_anonymous(array("fileName" => "ABTClientMacro.hx", "lineNumber" => 41, "className" => "apptimize.Apptimize", "methodName" => "_getVariantInfoForDynamicVariable")));
		}
		$attrMap = apptimize_util_ABTUtilDictionary::nativeObjectToStringMap($customAttributes);
		return apptimize_Apptimize::_getVariantInfoForAlteration($name, $userID, $attrMap);
	}
	static function _getVariantInfoForExperiment($name, $userID, $customAttributes = null) {
		$tmp = null;
		if($userID === null) {
			$tmp = false;
		} else {
			$tmp = false;
		}
		if($tmp) {
			apptimize_ABTLogger::c("The parameter " . _hx_string_rec(null, "") . " is required for " . "apptimize.Apptimize._getVariantInfoForExperiment", _hx_anonymous(array("fileName" => "ABTClientMacro.hx", "lineNumber" => 41, "className" => "apptimize.Apptimize", "methodName" => "_getVariantInfoForExperiment")));
		}
		$tmp1 = null;
		if($customAttributes === null) {
			$tmp1 = false;
		} else {
			$tmp1 = false;
		}
		if($tmp1) {
			apptimize_ABTLogger::c("The parameter " . _hx_string_rec(null, "") . " is required for " . "apptimize.Apptimize._getVariantInfoForExperiment", _hx_anonymous(array("fileName" => "ABTClientMacro.hx", "lineNumber" => 41, "className" => "apptimize.Apptimize", "methodName" => "_getVariantInfoForExperiment")));
		}
		$anonID = apptimize_Apptimize::_getApptimizeAnonUserId();
		$attrMap = apptimize_util_ABTUtilDictionary::nativeObjectToStringMap($customAttributes);
		$envParams = apptimize_ABTDataStore::getAppKey();
		$envParams1 = new apptimize_filter_ABTFilterEnvParams($userID, $anonID, $attrMap, $envParams, apptimize_support_properties_ABTApplicationProperties::sharedInstance());
		{
			$_g = 0;
			$_g1 = apptimize_ApptimizeInternal::_getVariants($envParams1);
			while($_g < $_g1->length) {
				$variant = $_g1[$_g];
				$_g = $_g + 1;
				if($variant->getExperimentName() === $name) {
					return apptimize_VariantInfo::initWithVariant($variant, $userID, $anonID);
				}
				unset($variant);
			}
		}
		return null;
	}
	static function track($eventName, $userID, $customAttributes = null) {
		if(apptimize_Apptimize::_isInitialized()) {
			$tmp = null;
			if($userID === null) {
				$tmp = false;
			} else {
				$tmp = false;
			}
			if($tmp) {
				apptimize_ABTLogger::c("The parameter " . _hx_string_rec(null, "") . " is required for " . "apptimize.Apptimize.track", _hx_anonymous(array("fileName" => "ABTClientMacro.hx", "lineNumber" => 41, "className" => "apptimize.Apptimize", "methodName" => "track")));
			}
			$tmp1 = null;
			if($customAttributes === null) {
				$tmp1 = false;
			} else {
				$tmp1 = false;
			}
			if($tmp1) {
				apptimize_ABTLogger::c("The parameter " . _hx_string_rec(null, "") . " is required for " . "apptimize.Apptimize.track", _hx_anonymous(array("fileName" => "ABTClientMacro.hx", "lineNumber" => 41, "className" => "apptimize.Apptimize", "methodName" => "track")));
			}
			$attrMap = apptimize_util_ABTUtilDictionary::nativeObjectToStringMap($customAttributes);
			$envParams = apptimize_Apptimize::_getApptimizeAnonUserId();
			$envParams1 = apptimize_ABTDataStore::getAppKey();
			$envParams2 = new apptimize_filter_ABTFilterEnvParams($userID, $envParams, $attrMap, $envParams1, apptimize_support_properties_ABTApplicationProperties::sharedInstance());
			apptimize_ApptimizeInternal::generateTrackEvent($envParams2, $eventName, null);
		} else {
			apptimize_ABTLogger::w("Events can only be tracked after setup() has been called.", _hx_anonymous(array("fileName" => "Apptimize.hx", "lineNumber" => 1187, "className" => "apptimize.Apptimize", "methodName" => "track")));
		}
	}
	static function trackValue($eventName, $value, $userID, $customAttributes = null) {
		if(apptimize_Apptimize::_isInitialized()) {
			$tmp = null;
			if($userID === null) {
				$tmp = false;
			} else {
				$tmp = false;
			}
			if($tmp) {
				apptimize_ABTLogger::c("The parameter " . _hx_string_rec(null, "") . " is required for " . "apptimize.Apptimize.trackValue", _hx_anonymous(array("fileName" => "ABTClientMacro.hx", "lineNumber" => 41, "className" => "apptimize.Apptimize", "methodName" => "trackValue")));
			}
			$tmp1 = null;
			if($customAttributes === null) {
				$tmp1 = false;
			} else {
				$tmp1 = false;
			}
			if($tmp1) {
				apptimize_ABTLogger::c("The parameter " . _hx_string_rec(null, "") . " is required for " . "apptimize.Apptimize.trackValue", _hx_anonymous(array("fileName" => "ABTClientMacro.hx", "lineNumber" => 41, "className" => "apptimize.Apptimize", "methodName" => "trackValue")));
			}
			$tmp2 = null;
			if(!Std::is($value, _hx_qtype("Float"))) {
				$tmp2 = !Std::is($value, apptimize_util_ArrayType::$Int);
			} else {
				$tmp2 = false;
			}
			if($tmp2) {
				apptimize_ABTLogger::w("trackValue() called with a non-float value. Event not logged.", _hx_anonymous(array("fileName" => "Apptimize.hx", "lineNumber" => 1218, "className" => "apptimize.Apptimize", "methodName" => "trackValue")));
				return;
			}
			$attrMap = apptimize_util_ABTUtilDictionary::nativeObjectToStringMap($customAttributes);
			$envParams = apptimize_Apptimize::_getApptimizeAnonUserId();
			$envParams1 = apptimize_ABTDataStore::getAppKey();
			$envParams2 = new apptimize_filter_ABTFilterEnvParams($userID, $envParams, $attrMap, $envParams1, apptimize_support_properties_ABTApplicationProperties::sharedInstance());
			apptimize_ApptimizeInternal::generateTrackEvent($envParams2, $eventName, $value);
		} else {
			apptimize_ABTLogger::w("Events can only be tracked after setup() has been called.", _hx_anonymous(array("fileName" => "Apptimize.hx", "lineNumber" => 1226, "className" => "apptimize.Apptimize", "methodName" => "trackValue")));
		}
	}
	function __toString() { return 'apptimize.Apptimize'; }
}
function apptimize_Apptimize_0(&$appKey) {
	{
		$tmp3 = null;
		if(apptimize_ABTDataStore::getAppKey() !== null) {
			$tmp4 = apptimize_ABTDataStore::getAppKey();
			$tmp3 = $tmp4 !== $appKey;
		} else {
			$tmp3 = false;
		}
		if($tmp3) {
			apptimize_ABTDataStore::clear();
		}
		$tmp5 = "Set Anonymous User ID: " . _hx_string_or_null(apptimize_Apptimize::_getApptimizeAnonUserId());
		apptimize_ABTLogger::v($tmp5, _hx_anonymous(array("fileName" => "Apptimize.hx", "lineNumber" => 391, "className" => "apptimize.Apptimize", "methodName" => "setup")));
		$tmp6 = "Apptimize " . _hx_string_or_null(apptimize_Apptimize::getApptimizeSDKPlatform()) . " SDK initialized.\x0AApptimize SDK Version: ";
		$tmp7 = _hx_string_or_null($tmp6) . _hx_string_or_null(apptimize_Apptimize::getApptimizeSDKVersion());
		apptimize_ABTLogger::i($tmp7, _hx_anonymous(array("fileName" => "Apptimize.hx", "lineNumber" => 392, "className" => "apptimize.Apptimize", "methodName" => "setup")));
		apptimize_Apptimize::_initialize($appKey);
	}
}
