<?php

// Copyright (c) Apptimize, Inc. | https://sdk.apptimize.com/license
class apptimize_ApptimizeInternal {
	public function __construct(){}
	static $_state;
	static function _isInitialized() {
		$result = false;
		{
			apptimize_util_ABTDataLock::$INITIALIZATION->acquire();
			try {
				if(apptimize_ApptimizeInternal::$_state !== 2) {
					$result = apptimize_ApptimizeInternal::$_state === 3;
				} else {
					$result = true;
				}
			}catch(Exception $__hx__e) {
				$_ex_ = ($__hx__e instanceof HException) && $__hx__e->getCode() == null ? $__hx__e->e : $__hx__e;
				$e = $_ex_;
				{
					apptimize_util_ABTDataLock::$INITIALIZATION->release();
					throw new HException($e);
				}
			}
			apptimize_util_ABTDataLock::$INITIALIZATION->release();
		}
		return $result;
	}
	static function setState($state) {
		apptimize_util_ABTDataLock::$INITIALIZATION->acquire();
		try {
			apptimize_ApptimizeInternal::$_state = $state;
		}catch(Exception $__hx__e) {
			$_ex_ = ($__hx__e instanceof HException) && $__hx__e->getCode() == null ? $__hx__e->e : $__hx__e;
			$e = $_ex_;
			{
				apptimize_util_ABTDataLock::$INITIALIZATION->release();
				throw new HException($e);
			}
		}
		apptimize_util_ABTDataLock::$INITIALIZATION->release();
	}
	static function _trySetReady() {
		$result = false;
		{
			apptimize_util_ABTDataLock::$INITIALIZATION->acquire();
			try {
				if(apptimize_ApptimizeInternal::$_state === 2) {
					$result = true;
					apptimize_ApptimizeInternal::$_state = 3;
				}
			}catch(Exception $__hx__e) {
				$_ex_ = ($__hx__e instanceof HException) && $__hx__e->getCode() == null ? $__hx__e->e : $__hx__e;
				$e = $_ex_;
				{
					apptimize_util_ABTDataLock::$INITIALIZATION->release();
					throw new HException($e);
				}
			}
			apptimize_util_ABTDataLock::$INITIALIZATION->release();
		}
		return $result;
	}
	static $kABTEventSourceApptimize = "a";
	static $kABTValueEventKey = "value";
	static function _setup($appKey, $configAttributes, $setupComplete) {
		$canInitialize = true;
		{
			apptimize_util_ABTDataLock::$INITIALIZATION->acquire();
			try {
				if(apptimize_ApptimizeInternal::$_state !== 0) {
					apptimize_ABTLogger::w("Apptimize setup has already been called.", _hx_anonymous(array("fileName" => "ApptimizeInternal.hx", "lineNumber" => 68, "className" => "apptimize.ApptimizeInternal", "methodName" => "_setup")));
					$canInitialize = false;
				} else {
					apptimize_ApptimizeInternal::$_state = 1;
				}
			}catch(Exception $__hx__e) {
				$_ex_ = ($__hx__e instanceof HException) && $__hx__e->getCode() == null ? $__hx__e->e : $__hx__e;
				$e = $_ex_;
				{
					apptimize_util_ABTDataLock::$INITIALIZATION->release();
					throw new HException($e);
				}
			}
			apptimize_util_ABTDataLock::$INITIALIZATION->release();
		}
		if($canInitialize === false) {
			return;
		}
		apptimize_ABTLogger::redirectTraceStatements();
		$configProps = apptimize_support_properties_ABTConfigProperties::sharedInstance();
		if($configAttributes !== null) {
			$configProps->setProperties(apptimize_util_ABTUtilDictionary::nativeObjectToStringMap($configAttributes));
		}
		if($configProps->isPropertyAvailable(apptimize_support_properties_ABTConfigProperties::$LOG_LEVEL_KEY)) {
			$logLevel = $configProps->valueForProperty(apptimize_support_properties_ABTConfigProperties::$LOG_LEVEL_KEY);
			apptimize_ABTLogger::setLogLevel(apptimize_ABTLogger::logLevelFromString($logLevel));
		}
		$tmp = null;
		if(!$configProps->isPropertyAvailable(apptimize_support_properties_ABTConfigProperties::$APPTIMIZE_ENVIRONMENT_KEY)) {
			$tmp = $configProps->isPropertyAvailable(apptimize_support_properties_ABTConfigProperties::$APPTIMIZE_REGION_KEY);
		} else {
			$tmp = true;
		}
		if($tmp) {
			$environment = $configProps->valueForProperty(apptimize_support_properties_ABTConfigProperties::$APPTIMIZE_ENVIRONMENT_KEY);
			if($environment === null) {
				$environment = "prod";
			}
			$region = $configProps->valueForProperty(apptimize_support_properties_ABTConfigProperties::$APPTIMIZE_REGION_KEY);
			if($region === null) {
				$region = "default";
			}
			switch($region) {
			case "eucs":{
				switch($environment) {
				case "local":{
					$configProps->setProperty(apptimize_support_properties_ABTConfigProperties::$META_DATA_URL_KEY, "https://local.apptimize.co/api/metadata/v4/");
					$configProps->setProperty(apptimize_support_properties_ABTConfigProperties::$GROUPS_BASE_URL_KEY, "https://local.apptimize.co");
				}break;
				case "prod":{
					$configProps->setProperty(apptimize_support_properties_ABTConfigProperties::$META_DATA_URL_LL_KEY, "https://md-a-c.apptimize.eu/api/metadata/v4/");
					$configProps->setProperty(apptimize_support_properties_ABTConfigProperties::$META_DATA_URL_HL_KEY, "https://md-a-s.apptimize.eu/api/metadata/v4/");
					$configProps->setProperty(apptimize_support_properties_ABTConfigProperties::$GROUPS_BASE_URL_KEY, "https://mapi.apptimize.eu");
				}break;
				case "staging":{
					if($region !== "default") {
						apptimize_ABTLogger::v("Apptimize region '" . _hx_string_or_null($region) . "' does not have a staging environment. Falling back to default region.", _hx_anonymous(array("fileName" => "ApptimizeInternal.hx", "lineNumber" => 109, "className" => "apptimize.ApptimizeInternal", "methodName" => "_setup")));
					}
					$configProps->setProperty(apptimize_support_properties_ABTConfigProperties::$META_DATA_URL_KEY, "https://staging-md.apptimize.co/api/metadata/v4/");
					$configProps->setProperty(apptimize_support_properties_ABTConfigProperties::$GROUPS_BASE_URL_KEY, "https://staging-mapi.apptimize.co");
				}break;
				default:{}break;
				}
			}break;
			case "gcp":{
				switch($environment) {
				case "local":{
					$configProps->setProperty(apptimize_support_properties_ABTConfigProperties::$META_DATA_URL_KEY, "https://local.apptimize.co/api/metadata/v4/");
					$configProps->setProperty(apptimize_support_properties_ABTConfigProperties::$GROUPS_BASE_URL_KEY, "https://local.apptimize.co");
				}break;
				case "staging":{
					$configProps->setProperty(apptimize_support_properties_ABTConfigProperties::$META_DATA_URL_KEY, "https://gcp-stag-md.apptimize.co/api/metadata/v4/");
					$configProps->setProperty(apptimize_support_properties_ABTConfigProperties::$GROUPS_BASE_URL_KEY, "https://gcp-stag-mapi.apptimize.co");
				}break;
				default:{}break;
				}
			}break;
			default:{
				switch($environment) {
				case "local":{
					$configProps->setProperty(apptimize_support_properties_ABTConfigProperties::$META_DATA_URL_KEY, "https://local.apptimize.co/api/metadata/v4/");
					$configProps->setProperty(apptimize_support_properties_ABTConfigProperties::$GROUPS_BASE_URL_KEY, "https://local.apptimize.co");
				}break;
				case "staging":{
					if($region !== "default") {
						apptimize_ABTLogger::v("Apptimize region '" . _hx_string_or_null($region) . "' does not have a staging environment. Falling back to default region.", _hx_anonymous(array("fileName" => "ApptimizeInternal.hx", "lineNumber" => 109, "className" => "apptimize.ApptimizeInternal", "methodName" => "_setup")));
					}
					$configProps->setProperty(apptimize_support_properties_ABTConfigProperties::$META_DATA_URL_KEY, "https://staging-md.apptimize.co/api/metadata/v4/");
					$configProps->setProperty(apptimize_support_properties_ABTConfigProperties::$GROUPS_BASE_URL_KEY, "https://staging-mapi.apptimize.co");
				}break;
				default:{}break;
				}
			}break;
			}
		}
		if($appKey !== null) {
			apptimize_ABTLogger::v("Initializing Apptimize with app key: \"" . _hx_string_or_null($appKey) . "\".", _hx_anonymous(array("fileName" => "ApptimizeInternal.hx", "lineNumber" => 120, "className" => "apptimize.ApptimizeInternal", "methodName" => "_setup")));
		}
		apptimize_ABTDataStore::sharedInstance()->initialize();
		apptimize_support_initialize_ABTPlatformInitialize::initialize();
		$threadCount = 8;
		if($configProps->isPropertyAvailable(apptimize_support_properties_ABTConfigProperties::$RESULT_POST_THREAD_POOL_SIZE_KEY)) {
			$threadCount = $configProps->valueForProperty(apptimize_support_properties_ABTConfigProperties::$RESULT_POST_THREAD_POOL_SIZE_KEY);
		}
		apptimize_support_persistence_ABTPersistence::loadFromHighLatency(array(new _hx_lambda(array(&$setupComplete, &$threadCount), "apptimize_ApptimizeInternal_0"), 'execute'));
	}
	static function shutdown() {
		apptimize_util_ABTDataLock::$INITIALIZATION->acquire();
		try {
			$tmp = null;
			if(apptimize_ApptimizeInternal::$_state !== 2) {
				$tmp = apptimize_ApptimizeInternal::$_state === 3;
			} else {
				$tmp = true;
			}
			if($tmp) {
				apptimize_api_ABTApiResultsPost::savePendingLogs();
				apptimize_support_persistence_ABTPersistence::saveToHighLatency();
				apptimize_support_initialize_ABTPlatformInitialize::shutdownPlatform();
				apptimize_ABTDataStore::shutdown();
				apptimize_support_persistence_ABTPersistence::shutdown();
				apptimize_ApptimizeInternal::$_state = 0;
				apptimize_ABTLogger::i("Apptimize has shutdown", _hx_anonymous(array("fileName" => "ApptimizeInternal.hx", "lineNumber" => 151, "className" => "apptimize.ApptimizeInternal", "methodName" => "shutdown")));
			} else {
				apptimize_ABTLogger::w("Apptimize is not initialized. Unable to shutdown().", _hx_anonymous(array("fileName" => "ApptimizeInternal.hx", "lineNumber" => 153, "className" => "apptimize.ApptimizeInternal", "methodName" => "shutdown")));
			}
		}catch(Exception $__hx__e) {
			$_ex_ = ($__hx__e instanceof HException) && $__hx__e->getCode() == null ? $__hx__e->e : $__hx__e;
			$e = $_ex_;
			{
				apptimize_util_ABTDataLock::$INITIALIZATION->release();
				throw new HException($e);
			}
		}
		apptimize_util_ABTDataLock::$INITIALIZATION->release();
	}
	static function generateTrackEvent($envParams, $eventName, $eventValue) {
		$value = null;
		if($eventValue !== null) {
			$_g = new haxe_ds_StringMap();
			$_g->set(apptimize_ApptimizeInternal::$kABTValueEventKey, $eventValue);
			$value = $_g;
		}
		apptimize_ABTDataStore::sharedInstance()->generateEvent($eventName, apptimize_ApptimizeInternal::$kABTEventSourceApptimize, $value, $envParams);
	}
	static function _getCodeBlockMethod($envParams, $codeBlockVariableName) {
		$cbVarName = $codeBlockVariableName;
		$tmp = null;
		if($cbVarName !== null) {
			$tmp = $cbVarName === "";
		} else {
			$tmp = true;
		}
		if($tmp) {
			apptimize_ABTLogger::w("Attempting to runCodeBlock() without specifying a code block name! Returning baseline original variant.", _hx_anonymous(array("fileName" => "ApptimizeInternal.hx", "lineNumber" => 170, "className" => "apptimize.ApptimizeInternal", "methodName" => "_getCodeBlockMethod")));
		} else {
			{
				$_g = 0;
				$_g1 = apptimize_ApptimizeInternal::_getAlterations($envParams);
				while($_g < $_g1->length) {
					$alteration = $_g1[$_g];
					$_g = $_g + 1;
					$tmp1 = null;
					if($alteration !== null) {
						$tmp1 = (is_object($_t = Type::getClass($alteration)) && ($_t instanceof Enum) ? $_t == _hx_qtype("apptimize.models.ABTBlockAlteration") : _hx_equal($_t, _hx_qtype("apptimize.models.ABTBlockAlteration")));
						unset($_t);
					} else {
						$tmp1 = false;
					}
					if($tmp1) {
						$block = $alteration;
						$variant = $block->getVariant();
						if($variant->getCodeBlockName() !== $cbVarName) {
							continue;
						}
						$tmp2 = apptimize_ABTDataStore::sharedInstance();
						$tmp2->incrementVariantRunCount($envParams, $block->getVariant());
						return $block->methodName;
						unset($variant,$tmp2,$block);
					}
					unset($tmp1,$alteration);
				}
			}
			apptimize_ABTLogger::w("Not participating in any code block experiments with name \"" . _hx_string_or_null($codeBlockVariableName) . "\". Returning baseline original variant.", _hx_anonymous(array("fileName" => "ApptimizeInternal.hx", "lineNumber" => 185, "className" => "apptimize.ApptimizeInternal", "methodName" => "_getCodeBlockMethod")));
		}
		return "baseline";
	}
	static function _getVariants($envParams) {
		apptimize_ABTDataStore::_checkForUpdatedMetadataIfNecessary();
		$alterations = apptimize_ApptimizeInternal::_getAlterations($envParams);
		$variants = new haxe_ds_IntMap();
		{
			$_g = 0;
			while($_g < $alterations->length) {
				$alteration = $alterations[$_g];
				$_g = $_g + 1;
				$variant = $alteration->getVariant();
				$tmp = null;
				if((is_object($_t = Type::getClass($variant)) && ($_t instanceof Enum) ? $_t != _hx_qtype("apptimize.models.ABTHotfixVariant") : !_hx_equal($_t, _hx_qtype("apptimize.models.ABTHotfixVariant")))) {
					$tmp = !$variants->exists($variant->getVariantID());
				} else {
					$tmp = false;
				}
				if($tmp) {
					$variants->set($variant->getVariantID(), $variant);
				}
				unset($variant,$tmp,$alteration,$_t);
			}
		}
		return Lambda::harray($variants);
	}
	static function _getAlterations($envParams) {
		$alterations = (new _hx_array(array()));
		$metadata = apptimize_ABTDataStore::sharedInstance()->getMetaData($envParams->appkey);
		if($metadata !== null) {
			$alterations = $metadata->selectAlterationsIntoArray($metadata->makeEnvironment($envParams));
		}
		return $alterations;
	}
	function __toString() { return 'apptimize.ApptimizeInternal'; }
}
apptimize_ApptimizeInternal::$_state = 0;
function apptimize_ApptimizeInternal_0(&$setupComplete, &$threadCount) {
	{
		apptimize_api_ABTApiResultsPost::loadPendingLogs();
		call_user_func($setupComplete);
		apptimize_api_ABTApiResultsPost::startDispatching($threadCount);
	}
}
