<?php

// Copyright (c) Apptimize, Inc. | https://sdk.apptimize.com/license
class apptimize_VariantInfo {
	public function __construct($variantId, $variantName, $experimentId, $experimentName, $experimentType, $cycle, $currentPhase, $participationPhase, $userId, $anonymousUserId, $userHasParticipated) {
		if(!php_Boot::$skip_constructor) {
		$this->_variantId = $variantId;
		$this->_variantName = $variantName;
		$this->_experimentId = $experimentId;
		$this->_experimentName = $experimentName;
		$this->_experimentType = apptimize_VariantInfo::apptimizeExperimentTypeForString($experimentType);
		$this->_experimentTypeName = $experimentType;
		$this->_cycle = $cycle;
		$this->_currentPhase = $currentPhase;
		$this->_participationPhase = $participationPhase;
		$this->_userId = $userId;
		$this->_anonymousUserId = $anonymousUserId;
		$this->_userHasParticipated = $userHasParticipated;
	}}
	public $_variantId;
	public $_variantName;
	public $_experimentId;
	public $_experimentName;
	public $_experimentType;
	public $_experimentTypeName;
	public $_currentPhase;
	public $_participationPhase;
	public $_cycle;
	public $_userId;
	public $_anonymousUserId;
	public $_userHasParticipated;
	public function getVariantId() {
		return $this->_variantId;
	}
	public function getVariantName() {
		return $this->_variantName;
	}
	public function getExperimentId() {
		return $this->_experimentId;
	}
	public function getExperimentName() {
		return $this->_experimentName;
	}
	public function getExperimentType() {
		return $this->_experimentType;
	}
	public function getExperimentTypeName() {
		return $this->_experimentTypeName;
	}
	public function getCurrentPhase() {
		return $this->_currentPhase;
	}
	public function getParticipationPhase() {
		return $this->_participationPhase;
	}
	public function getCycle() {
		return $this->_cycle;
	}
	public function getUserId() {
		return $this->_userId;
	}
	public function getAnonymousUserId() {
		return $this->_anonymousUserId;
	}
	public function __call($m, $a) {
		if(isset($this->$m) && is_callable($this->$m))
			return call_user_func_array($this->$m, $a);
		else if(isset($this->__dynamics[$m]) && is_callable($this->__dynamics[$m]))
			return call_user_func_array($this->__dynamics[$m], $a);
		else if('toString' == $m)
			return $this->__toString();
		else
			throw new HException('Unable to call <'.$m.'>');
	}
	static function initWithVariant($variant, $userId, $anonymousUserId) {
		$participationPhase = 0;
		$variantString = "v" . _hx_string_rec($variant->getVariantID(), "") . "_";
		$variantString1 = _hx_string_or_null($variantString) . _hx_string_rec($variant->getCycle(), "");
		$userHasParticipated = false;
		$tmp = $variant->getVariantID();
		$tmp1 = $variant->getVariantName();
		$tmp2 = $variant->getExperimentID();
		$tmp3 = $variant->getExperimentName();
		$tmp4 = $variant->getExperimentType();
		$tmp5 = $variant->getCycle();
		return new apptimize_VariantInfo($tmp, $tmp1, $tmp2, $tmp3, $tmp4, $tmp5, $variant->getPhase(), $participationPhase, $userId, $anonymousUserId, $userHasParticipated);
	}
	static function apptimizeExperimentTypeForString($stringType) {
		$type = strtolower($stringType);
		switch($type) {
		case "code-block":{
			return apptimize_ApptimizeExperimentType::$CodeBlock;
		}break;
		case "double-value":{
			return apptimize_ApptimizeExperimentType::$DynamicVariables;
		}break;
		case "feature-config":{
			return apptimize_ApptimizeExperimentType::$FeatureVariables;
		}break;
		case "feature-flag":{
			return apptimize_ApptimizeExperimentType::$FeatureFlag;
		}break;
		case "int-value":{
			return apptimize_ApptimizeExperimentType::$DynamicVariables;
		}break;
		case "string-value":{
			return apptimize_ApptimizeExperimentType::$DynamicVariables;
		}break;
		case "variables":{
			return apptimize_ApptimizeExperimentType::$DynamicVariables;
		}break;
		case "wysiwyg":{
			return apptimize_ApptimizeExperimentType::$Visual;
		}break;
		default:{
			return apptimize_ApptimizeExperimentType::$Unknown;
		}break;
		}
	}
	function __toString() { return 'apptimize.VariantInfo'; }
}
