<?php

// Copyright (c) Apptimize, Inc. | https://sdk.apptimize.com/license
class apptimize_api_ABTApiMetadataRequest {
	public function __construct($client, $applicationKey, $etag, $success, $failure) {
		if(!php_Boot::$skip_constructor) {
		$_gthis = $this;
		$this->apiClient = $client;
		$this->appKey = $applicationKey;
		$this->successCallback = $success;
		$this->failureCallback = $failure;
		$url = $this->_getMetadataUrl();
		$url = _hx_string_or_null($url) . _hx_string_or_null($applicationKey);
		apptimize_ABTLogger::v("Checking for new metadata from url: " . _hx_string_or_null($url), _hx_anonymous(array("fileName" => "ABTApiMetadataRequest.hx", "lineNumber" => 27, "className" => "apptimize.api.ABTApiMetadataRequest", "methodName" => "new")));
		apptimize_http_ABTHttpRequest::get($url, $this->_headersForRequest($etag), array(new _hx_lambda(array(&$_gthis), "apptimize_api_ABTApiMetadataRequest_0"), 'execute'), array(new _hx_lambda(array(&$_gthis), "apptimize_api_ABTApiMetadataRequest_1"), 'execute'));
	}}
	public $apiClient;
	public $appKey;
	public $successCallback;
	public $failureCallback;
	public function _apiSuccess($response) {
		if($response->responseCode === 304) {
			apptimize_ABTLogger::v("Got HTTP response 304, metadata not updated.", _hx_anonymous(array("fileName" => "ABTApiMetadataRequest.hx", "lineNumber" => 38, "className" => "apptimize.api.ABTApiMetadataRequest", "methodName" => "_apiSuccess")));
			return;
		}
		$json = apptimize_api_ABTMetadataProcessor::jsonFromMetadataDownload($response->bytes);
		if($json !== null) {
			apptimize_ABTLogger::v("Request for metadata completed successfully.", _hx_anonymous(array("fileName" => "ABTApiMetadataRequest.hx", "lineNumber" => 45, "className" => "apptimize.api.ABTApiMetadataRequest", "methodName" => "_apiSuccess")));
			$this->successCallback($json, $response->etag);
		} else {
			$errorString = "Failed to download metadata with error: response was empty.";
			apptimize_ABTLogger::w($errorString, _hx_anonymous(array("fileName" => "ABTApiMetadataRequest.hx", "lineNumber" => 49, "className" => "apptimize.api.ABTApiMetadataRequest", "methodName" => "_apiSuccess")));
			$this->failureCallback($errorString);
		}
	}
	public function _getMetadataUrl() {
		$metadataUrl = apptimize_support_properties_ABTConfigProperties::sharedInstance()->valueForProperty(apptimize_support_properties_ABTConfigProperties::$META_DATA_URL_KEY);
		if($metadataUrl !== null) {
			return $metadataUrl;
		} else {
			if(apptimize_ABTDataStore::sharedInstance()->hasMetadata($this->appKey)) {
				return apptimize_support_properties_ABTConfigProperties::sharedInstance()->valueForProperty(apptimize_support_properties_ABTConfigProperties::$META_DATA_URL_HL_KEY);
			} else {
				return apptimize_support_properties_ABTConfigProperties::sharedInstance()->valueForProperty(apptimize_support_properties_ABTConfigProperties::$META_DATA_URL_LL_KEY);
			}
		}
	}
	public function _headersForRequest($etag) {
		if($etag !== null) {
			$_g = new haxe_ds_StringMap();
			$_g->set("ETag", $etag);
			$_g->set("If-None-Match", $etag);
			return $_g;
		} else {
			return null;
		}
	}
	public function __call($m, $a) {
		if(isset($this->$m) && is_callable($this->$m))
			return call_user_func_array($this->$m, $a);
		else if(isset($this->__dynamics[$m]) && is_callable($this->__dynamics[$m]))
			return call_user_func_array($this->__dynamics[$m], $a);
		else if('toString' == $m)
			return $this->__toString();
		else
			throw new HException('Unable to call <'.$m.'>');
	}
	function __toString() { return 'apptimize.api.ABTApiMetadataRequest'; }
}
function apptimize_api_ABTApiMetadataRequest_0(&$_gthis, $response) {
	{
		$_gthis->_apiSuccess($response);
	}
}
function apptimize_api_ABTApiMetadataRequest_1(&$_gthis, $response1) {
	{
		$_gthis->failureCallback($response1->text);
	}
}
