<?php

// Copyright (c) Apptimize, Inc. | https://sdk.apptimize.com/license
class apptimize_api_ABTApiResultsPost {
	public function __construct($client, $applicationKey, $log, $success, $failure) {
		if(!php_Boot::$skip_constructor) {
		$this->_failureCount = 0;
		$this->_apiClient = $client;
		$this->_appKey = $applicationKey;
		$this->_success = $success;
		$this->_failure = $failure;
		$this->_uniqueID = $log->getUniqueUserKey();
		$this->_url = $this->_getUrl($applicationKey);
		$jsonBytes = haxe_io_Bytes::ofString($log->toJSON());
		$this->_requestBytes = $jsonBytes;
	}}
	public $_apiClient;
	public $_appKey;
	public $_uniqueID;
	public $_requestBytes;
	public $_success;
	public $_failure;
	public $_failureCount;
	public $_url;
	public function _getUrl($appKey) {
		$metadata = apptimize_ABTDataStore::sharedInstance()->getMetaData($appKey);
		if($metadata === null) {
			return null;
		}
		$urls = $metadata->getCheckinUrls();
		$tmp = null;
		if($urls !== null) {
			$tmp = $urls->length < 1;
		} else {
			$tmp = true;
		}
		if($tmp) {
			return null;
		}
		$index = $urls->length - 1 + 1;
		$index1 = Math::floor($index * Math::random());
		$endpoint = "server/v4/";
		return _hx_string_or_null($urls[$index1]) . _hx_string_or_null($endpoint);
	}
	public function _post() {
		$_gthis = $this;
		if(!apptimize_ApptimizeInternal::_isInitialized()) {
			return;
		}
		if($this->_url === null) {
			$this->_url = $this->_getUrl($this->_appKey);
			if($this->_url === null) {
				apptimize_ABTLogger::e("Unable to post results until metadata is available.", _hx_anonymous(array("fileName" => "ABTApiResultsPost.hx", "lineNumber" => 155, "className" => "apptimize.api.ABTApiResultsPost", "methodName" => "_post")));
				apptimize_api_ABTApiResultsPost::onFailure($this, null);
				return;
			}
		}
		apptimize_ABTLogger::v("Posting results to: " . _hx_string_or_null($this->_url), _hx_anonymous(array("fileName" => "ABTApiResultsPost.hx", "lineNumber" => 161, "className" => "apptimize.api.ABTApiResultsPost", "methodName" => "_post")));
		apptimize_http_ABTHttpRequest::post($this->_url, $this->_requestBytes, $this->_appKey, array(new _hx_lambda(array(&$_gthis), "apptimize_api_ABTApiResultsPost_0"), 'execute'), array(new _hx_lambda(array(&$_gthis), "apptimize_api_ABTApiResultsPost_1"), 'execute'));
	}
	public function incrementFailureCountForCode($status) {
		if($status >= 400) {
			$this->_failureCount++;
		}
	}
	public function hxSerialize($s) {
		$s->serialize($this->_appKey);
		$s->serialize($this->_requestBytes);
		$s->serialize($this->_failureCount);
		$s->serialize($this->_url);
		$s->serialize($this->_uniqueID);
	}
	public function hxUnserialize($u) {
		$this->_appKey = $u->unserialize();
		$this->_requestBytes = $u->unserialize();
		$this->_failureCount = $u->unserialize();
		$this->_url = $u->unserialize();
		$this->_uniqueID = $u->unserialize();
	}
	public function __call($m, $a) {
		if(isset($this->$m) && is_callable($this->$m))
			return call_user_func_array($this->$m, $a);
		else if(isset($this->__dynamics[$m]) && is_callable($this->__dynamics[$m]))
			return call_user_func_array($this->__dynamics[$m], $a);
		else if('toString' == $m)
			return $this->__toString();
		else
			throw new HException('Unable to call <'.$m.'>');
	}
	static $MAX_FAILURE_DELAY_MS = 60000;
	static $DEFAULT_FAILURE_DELAY_MS = 1000;
	static $_failureDelayMs;
	static $_pendingMap;
	static $_pendingResults;
	static $_postDispatch;
	static $_loadedPending = false;
	static $PENDING_LOCK;
	static function _getPendingResultsCount() {
		$count = 0;
		{
			apptimize_api_ABTApiResultsPost::$PENDING_LOCK->acquire();
			try {
				$_this = apptimize_api_ABTApiResultsPost::$_pendingResults;
				$_gthis = $_this;
				$count = $_this->_sync->execute(array(new _hx_lambda(array(&$_gthis), "apptimize_api_ABTApiResultsPost_2"), 'execute'), null);
			}catch(Exception $__hx__e) {
				$_ex_ = ($__hx__e instanceof HException) && $__hx__e->getCode() == null ? $__hx__e->e : $__hx__e;
				$e = $_ex_;
				{
					apptimize_api_ABTApiResultsPost::$PENDING_LOCK->release();
					throw new HException($e);
				}
			}
			apptimize_api_ABTApiResultsPost::$PENDING_LOCK->release();
		}
		return $count;
	}
	static function onSuccess($request, $response) {
		apptimize_api_ABTApiResultsPost::clearFailureDelay();
		{
			apptimize_api_ABTApiResultsPost::$PENDING_LOCK->acquire();
			try {
				apptimize_api_ABTApiResultsPost::$_pendingResults->remove($request);
				$count = apptimize_api_ABTApiResultsPost::decrementPendingCount($request->_uniqueID);
				if($count > 0) {
					apptimize_api_ABTApiResultsPost::postNextRequestForID($request->_uniqueID);
				}
			}catch(Exception $__hx__e) {
				$_ex_ = ($__hx__e instanceof HException) && $__hx__e->getCode() == null ? $__hx__e->e : $__hx__e;
				$e = $_ex_;
				{
					apptimize_api_ABTApiResultsPost::$PENDING_LOCK->release();
					throw new HException($e);
				}
			}
			apptimize_api_ABTApiResultsPost::$PENDING_LOCK->release();
		}
		$tmp = null;
		if($request !== null) {
			$tmp = $request->_success !== null;
		} else {
			$tmp = false;
		}
		if($tmp) {
			$request->_success($response);
		}
	}
	static function postNextRequestForID($id) {
		apptimize_api_ABTApiResultsPost::$PENDING_LOCK->acquire();
		try {
			$request = apptimize_api_ABTApiResultsPost::$_pendingResults->iterator();
			while($request->hasNext()) {
				$request1 = $request->next();
				if($request1->_uniqueID === $id) {
					{
						$task = array(new _hx_lambda(array(&$request1), "apptimize_api_ABTApiResultsPost_3"), 'execute');
						if(apptimize_api_ABTApiResultsPost::$_postDispatch !== null) {
							apptimize_api_ABTApiResultsPost::$_postDispatch->dispatch($task, 0);
						} else {
							apptimize_util_ABTDispatch::dispatchImmediately($task);
						}
						unset($task);
					}
					break;
				}
				unset($request1);
			}
		}catch(Exception $__hx__e) {
			$_ex_ = ($__hx__e instanceof HException) && $__hx__e->getCode() == null ? $__hx__e->e : $__hx__e;
			$e = $_ex_;
			{
				apptimize_api_ABTApiResultsPost::$PENDING_LOCK->release();
				throw new HException($e);
			}
		}
		apptimize_api_ABTApiResultsPost::$PENDING_LOCK->release();
	}
	static function decrementPendingCount($id) {
		$count = 0;
		{
			apptimize_api_ABTApiResultsPost::$PENDING_LOCK->acquire();
			try {
				$count = apptimize_api_ABTApiResultsPost::$_pendingMap->get($id);
				$count = $count - 1;
				if($count === 0) {
					apptimize_api_ABTApiResultsPost::$_pendingMap->remove($id);
				} else {
					apptimize_api_ABTApiResultsPost::$_pendingMap->set($id, $count);
				}
			}catch(Exception $__hx__e) {
				$_ex_ = ($__hx__e instanceof HException) && $__hx__e->getCode() == null ? $__hx__e->e : $__hx__e;
				$e = $_ex_;
				{
					apptimize_api_ABTApiResultsPost::$PENDING_LOCK->release();
					throw new HException($e);
				}
			}
			apptimize_api_ABTApiResultsPost::$PENDING_LOCK->release();
		}
		return $count;
	}
	static function incrementFailureDelay() {
		$delay = apptimize_api_ABTApiResultsPost::$_failureDelayMs->get_value() * 2;
		if($delay > apptimize_api_ABTApiResultsPost::$MAX_FAILURE_DELAY_MS) {
			$delay = apptimize_api_ABTApiResultsPost::$MAX_FAILURE_DELAY_MS;
		}
		apptimize_api_ABTApiResultsPost::$_failureDelayMs->set_value($delay);
		return apptimize_api_ABTApiResultsPost::$_failureDelayMs->get_value();
	}
	static function clearFailureDelay() {
		apptimize_api_ABTApiResultsPost::$_failureDelayMs->set_value(apptimize_api_ABTApiResultsPost::$DEFAULT_FAILURE_DELAY_MS);
	}
	static function onFailure($request, $response) {
		$request1 = $request->_failureCount;
		if($request1 > apptimize_support_properties_ABTConfigProperties::sharedInstance()->valueForProperty(apptimize_support_properties_ABTConfigProperties::$MAXIMUM_RESULT_POST_FAILURE_KEY)) {
			apptimize_ABTLogger::e("Dropping result post after repeated failure.", _hx_anonymous(array("fileName" => "ABTApiResultsPost.hx", "lineNumber" => 265, "className" => "apptimize.api.ABTApiResultsPost", "methodName" => "onFailure")));
			{
				apptimize_api_ABTApiResultsPost::$PENDING_LOCK->acquire();
				try {
					apptimize_api_ABTApiResultsPost::$_pendingResults->remove($request);
					$count = apptimize_api_ABTApiResultsPost::decrementPendingCount($request->_uniqueID);
					if($count > 0) {
						apptimize_api_ABTApiResultsPost::postNextRequestForID($request->_uniqueID);
					}
				}catch(Exception $__hx__e) {
					$_ex_ = ($__hx__e instanceof HException) && $__hx__e->getCode() == null ? $__hx__e->e : $__hx__e;
					$e = $_ex_;
					{
						apptimize_api_ABTApiResultsPost::$PENDING_LOCK->release();
						throw new HException($e);
					}
				}
				apptimize_api_ABTApiResultsPost::$PENDING_LOCK->release();
			}
		} else {
			$task = array(new _hx_lambda(array(&$request), "apptimize_api_ABTApiResultsPost_4"), 'execute');
			if(apptimize_api_ABTApiResultsPost::$_postDispatch !== null) {
				$tmp = apptimize_api_ABTApiResultsPost::$_postDispatch;
				$tmp->dispatch($task, apptimize_api_ABTApiResultsPost::incrementFailureDelay());
			} else {
				apptimize_util_ABTDispatch::dispatchImmediately($task);
			}
		}
		if($request->_failure !== null) {
			$request->_failure($response);
		}
	}
	static function pushRequest($resultRequest, $savePending = null) {
		if($savePending === null) {
			$savePending = true;
		}
		apptimize_api_ABTApiResultsPost::$PENDING_LOCK->acquire();
		try {
			apptimize_api_ABTApiResultsPost::$_pendingResults->add($resultRequest);
			if(!apptimize_api_ABTApiResultsPost::$_pendingMap->exists($resultRequest->_uniqueID)) {
				apptimize_api_ABTApiResultsPost::$_pendingMap->set($resultRequest->_uniqueID, 1);
				{
					$task = array(new _hx_lambda(array(&$resultRequest), "apptimize_api_ABTApiResultsPost_5"), 'execute');
					if(apptimize_api_ABTApiResultsPost::$_postDispatch !== null) {
						apptimize_api_ABTApiResultsPost::$_postDispatch->dispatch($task, 0);
					} else {
						apptimize_util_ABTDispatch::dispatchImmediately($task);
					}
				}
			} else {
				$tmp = apptimize_api_ABTApiResultsPost::$_pendingMap;
				$resultRequest1 = $resultRequest->_uniqueID;
				$tmp->set($resultRequest1, apptimize_api_ABTApiResultsPost::$_pendingMap->get($resultRequest->_uniqueID) + 1);
			}
		}catch(Exception $__hx__e) {
			$_ex_ = ($__hx__e instanceof HException) && $__hx__e->getCode() == null ? $__hx__e->e : $__hx__e;
			$e = $_ex_;
			{
				apptimize_api_ABTApiResultsPost::$PENDING_LOCK->release();
				throw new HException($e);
			}
		}
		apptimize_api_ABTApiResultsPost::$PENDING_LOCK->release();
	}
	static function savePendingLogs() {
		apptimize_api_ABTApiResultsPost::$PENDING_LOCK->acquire();
		try {
			$tmp = apptimize_support_persistence_ABTPersistence::$kResultPostsListKey;
			apptimize_support_persistence_ABTPersistence::saveObject($tmp, apptimize_api_ABTApiResultsPost::$_pendingResults->toArray(), null, null);
		}catch(Exception $__hx__e) {
			$_ex_ = ($__hx__e instanceof HException) && $__hx__e->getCode() == null ? $__hx__e->e : $__hx__e;
			$e = $_ex_;
			{
				apptimize_api_ABTApiResultsPost::$PENDING_LOCK->release();
				throw new HException($e);
			}
		}
		apptimize_api_ABTApiResultsPost::$PENDING_LOCK->release();
	}
	static function loadPendingLogs() {
		apptimize_api_ABTApiResultsPost::$PENDING_LOCK->acquire();
		try {
			if(apptimize_api_ABTApiResultsPost::$_loadedPending === false) {
				$pendingObject = apptimize_support_persistence_ABTPersistence::loadObject(apptimize_support_persistence_ABTPersistence::$kResultPostsListKey, null);
				try {
					$pendingArray = null;
					if($pendingObject === null) {
						$pendingArray = new _hx_array(array());
					} else {
						$pendingArray = $pendingObject;
					}
					{
						$_g = 0;
						while($_g < $pendingArray->length) {
							$p = $pendingArray[$_g];
							$_g = $_g + 1;
							apptimize_api_ABTApiResultsPost::pushRequest($p, false);
							unset($p);
						}
					}
				}catch(Exception $__hx__e) {
					$_ex_ = ($__hx__e instanceof HException) && $__hx__e->getCode() == null ? $__hx__e->e : $__hx__e;
					$e = $_ex_;
					{
						$tmp = "Unable to load pending results posts: " . Std::string($e);
						apptimize_ABTLogger::e($tmp, _hx_anonymous(array("fileName" => "ABTApiResultsPost.hx", "lineNumber" => 333, "className" => "apptimize.api.ABTApiResultsPost", "methodName" => "loadPendingLogs")));
					}
				}
			}
			apptimize_api_ABTApiResultsPost::$_loadedPending = true;
		}catch(Exception $__hx__e) {
			$_ex_ = ($__hx__e instanceof HException) && $__hx__e->getCode() == null ? $__hx__e->e : $__hx__e;
			$e1 = $_ex_;
			{
				apptimize_api_ABTApiResultsPost::$PENDING_LOCK->release();
				throw new HException($e1);
			}
		}
		apptimize_api_ABTApiResultsPost::$PENDING_LOCK->release();
	}
	static function startDispatching($threadCount) {
		apptimize_api_ABTApiResultsPost::$_postDispatch->start($threadCount);
	}
	function __toString() { return 'apptimize.api.ABTApiResultsPost'; }
}
apptimize_api_ABTApiResultsPost::$_failureDelayMs = apptimize_api_ABTApiResultsPost_6();
apptimize_api_ABTApiResultsPost::$_pendingMap = new haxe_ds_StringMap();
apptimize_api_ABTApiResultsPost::$_pendingResults = hx_concurrent_collection__SynchronizedLinkedList_SynchronizedLinkedList_Impl_::_new(null);
apptimize_api_ABTApiResultsPost::$_postDispatch = new apptimize_util_ABTDispatch("Results Post Dispatch Queue");
apptimize_api_ABTApiResultsPost::$PENDING_LOCK = apptimize_util_ABTDataLock::getNewLock("pending_results_key");
function apptimize_api_ABTApiResultsPost_0(&$_gthis, $response) {
	{
		apptimize_ABTLogger::d("Successfully posted results.", _hx_anonymous(array("fileName" => "ABTApiResultsPost.hx", "lineNumber" => 171, "className" => "apptimize.api.ABTApiResultsPost", "methodName" => "_post")));
		$tmp = "Results JSON:\x0A" . Std::string($_gthis->_requestBytes);
		apptimize_ABTLogger::d($tmp, _hx_anonymous(array("fileName" => "ABTApiResultsPost.hx", "lineNumber" => 172, "className" => "apptimize.api.ABTApiResultsPost", "methodName" => "_post")));
		apptimize_api_ABTApiResultsPost::onSuccess($_gthis, $response);
	}
}
function apptimize_api_ABTApiResultsPost_1(&$_gthis, $response1) {
	{
		$_gthis->incrementFailureCountForCode($response1->responseCode);
		apptimize_ABTLogger::e("Failed to post results, queuing for retry later: " . _hx_string_rec($response1->responseCode, "") . " " . _hx_string_or_null($response1->text), _hx_anonymous(array("fileName" => "ABTApiResultsPost.hx", "lineNumber" => 179, "className" => "apptimize.api.ABTApiResultsPost", "methodName" => "_post")));
		$tmp1 = "Results JSON:\x0A" . Std::string($_gthis->_requestBytes);
		apptimize_ABTLogger::e($tmp1, _hx_anonymous(array("fileName" => "ABTApiResultsPost.hx", "lineNumber" => 180, "className" => "apptimize.api.ABTApiResultsPost", "methodName" => "_post")));
		apptimize_api_ABTApiResultsPost::onFailure($_gthis, $response1);
	}
}
function apptimize_api_ABTApiResultsPost_2(&$_gthis) {
	{
		$len = 0;
		{
			$item = $_gthis->_items->iterator();
			while($item->hasNext()) {
				$item1 = $item->next();
				$len = $len + 1;
				unset($item1);
			}
		}
		return $len;
	}
}
function apptimize_api_ABTApiResultsPost_3(&$request1) {
	{
		$request1->_post();
	}
}
function apptimize_api_ABTApiResultsPost_4(&$request) {
	{
		$request->_post();
	}
}
function apptimize_api_ABTApiResultsPost_5(&$resultRequest) {
	{
		$resultRequest->_post();
	}
}
function apptimize_api_ABTApiResultsPost_6() {
	{
		$this1 = new hx_concurrent_atomic__AtomicInt_AtomicIntImpl(apptimize_api_ABTApiResultsPost::$DEFAULT_FAILURE_DELAY_MS);
		return $this1;
	}
}
