<?php

// Copyright (c) Apptimize, Inc. | https://sdk.apptimize.com/license
class apptimize_filter_ABTFilter {
	public function __construct() {
		;
	}
	public $property;
	public $propertySource;
	public $value;
	public $filterType;
	public $filterOperator;
	public $callServerURLKey;
	public function fromJSON($json) {
		$jsonProperty = Reflect::field($json, apptimize_filter_ABTFilter::$kABTFilterKeyProperty);
		if($jsonProperty !== null) {
			$this->property = $jsonProperty;
			$this->propertySource = apptimize_filter_ABTFilterPropertySource::$ABTFilterPropertySourceDevice;
		} else {
			$jsonProperty = Reflect::field($json, apptimize_filter_ABTFilter::$kABTFilterKeyUserAttribute);
			if($jsonProperty !== null) {
				$this->property = $jsonProperty;
				$this->propertySource = apptimize_filter_ABTFilterPropertySource::$ABTFilterPropertySourceUser;
			} else {
				$jsonProperty = Reflect::field($json, apptimize_filter_ABTFilter::$kABTFilterKeyPrefixedAttribute);
				if($jsonProperty !== null) {
					$this->property = $jsonProperty;
					$this->propertySource = apptimize_filter_ABTFilterPropertySource::$ABTFilterPropertySourcePrefixed;
				}
			}
		}
		$this->filterOperator = apptimize_filter_ABTFilter::operatorFromString(Reflect::field($json, apptimize_filter_ABTFilter::$kABTFilterKeyOperator));
		$this->filterType = apptimize_filter_ABTFilter::filterForTypeFromJSON($json);
		if((is_object($_t = $this->filterType) && ($_t instanceof Enum) ? $_t == apptimize_filter_ABTFilterType::$ABTFilterTypeUnknown : _hx_equal($_t, apptimize_filter_ABTFilterType::$ABTFilterTypeUnknown))) {
			apptimize_ABTLogger::w("Unknown filter type: setting value without type checking.", _hx_anonymous(array("fileName" => "ABTFilter.hx", "lineNumber" => 149, "className" => "apptimize.filter.ABTFilter", "methodName" => "fromJSON")));
			$this->value = Reflect::field($json, apptimize_filter_ABTFilter::$kABTFilterKeyValue);
		}
		$this->callServerURLKey = Reflect::field($json, apptimize_filter_ABTFilter::$kABTFilterKeyCallURLKey);
	}
	public function isSupportedOperator($operator) {
		return (is_object($_t = apptimize_filter_ABTFilter::operatorFromString($operator)) && ($_t instanceof Enum) ? $_t != apptimize_filter_ABTFilterOperator::$ABTFilterOperatorUnknown : !_hx_equal($_t, apptimize_filter_ABTFilterOperator::$ABTFilterOperatorUnknown));
	}
	public function isSupportedProperty($env, $property, $source) {
		$found = null !== $env->valueForProperty($property, $source);
		if(!$found) {
			apptimize_ABTLogger::d("Property \"" . _hx_string_or_null($property) . "\" not found which is expected by a filter.", _hx_anonymous(array("fileName" => "ABTFilter.hx", "lineNumber" => 166, "className" => "apptimize.filter.ABTFilter", "methodName" => "isSupportedProperty")));
		}
		return $found;
	}
	public function currentDeviceValue($env) {
		return $env->valueForProperty($this->property, $this->propertySource);
	}
	public function hasSupportedProperty($env) {
		return $this->isSupportedProperty($env, $this->property, $this->propertySource);
	}
	public function filterMatchesEnvironment($env) {
		apptimize_ABTLogger::e("Unknown filter type. Filter match is unknown.", _hx_anonymous(array("fileName" => "ABTFilter.hx", "lineNumber" => 181, "className" => "apptimize.filter.ABTFilter", "methodName" => "filterMatchesEnvironment")));
		return apptimize_filter_ABTFilterResult::$ABTFilterResultUnknown;
	}
	public function getUrlKeys() {
		if($this->callServerURLKey === null) {
			return (new _hx_array(array()));
		}
		return (new _hx_array(array($this->callServerURLKey)));
	}
	public function __call($m, $a) {
		if(isset($this->$m) && is_callable($this->$m))
			return call_user_func_array($this->$m, $a);
		else if(isset($this->__dynamics[$m]) && is_callable($this->__dynamics[$m]))
			return call_user_func_array($this->__dynamics[$m], $a);
		else if('toString' == $m)
			return $this->__toString();
		else
			throw new HException('Unable to call <'.$m.'>');
	}
	static $kABTFilterKeyValue = "value";
	static $kABTFilterKeyType = "type";
	static $kABTFilterKeyProperty = "property";
	static $kABTFilterKeyOperator = "operator";
	static $kABTFilterKeyPropertySource = "propertySource";
	static $kABTFilterKeyCallServerInputs = "callServerInputs";
	static $kABTFilterKeyCallURLKey = "callServerUrlKey";
	static $kABTFilterKeyUserAttribute = "userAttribute";
	static $kABTFilterKeyPrefixedAttribute = "prefixedAttribute";
	static $kABTFilterKeyNamedFilter = "namedFilter";
	static function filterFromJSON($json) {
		$filterType = apptimize_filter_ABTFilter::filterForTypeFromJSON($json);
		$classType = apptimize_filter_ABTFilter::classForType($filterType);
		if($classType === null) {
			$tmp = "Unable to find filter type: " . Std::string($filterType);
			apptimize_ABTLogger::e($tmp, _hx_anonymous(array("fileName" => "ABTFilter.hx", "lineNumber" => 110, "className" => "apptimize.filter.ABTFilter", "methodName" => "filterFromJSON")));
			return null;
		}
		$abtFilter = Type::createInstance($classType, (new _hx_array(array())));
		$abtFilter->fromJSON($json);
		return $abtFilter;
	}
	static function classForType($filterType) {
		if($filterType === apptimize_filter_ABTFilterType::$ABTFilterTypeSimple) {
			return _hx_qtype("apptimize.filter.ABTSimpleFilter");
		}
		if($filterType === apptimize_filter_ABTFilterType::$ABTFilterTypeCompound) {
			return _hx_qtype("apptimize.filter.ABTCompoundFilter");
		}
		if($filterType === apptimize_filter_ABTFilterType::$ABTFilterTypeList) {
			return _hx_qtype("apptimize.filter.ABTListFilter");
		}
		if($filterType === apptimize_filter_ABTFilterType::$ABTFilterTypeSet) {
			return _hx_qtype("apptimize.filter.ABTSetFilter");
		}
		if($filterType === apptimize_filter_ABTFilterType::$ABTFilterTypeNamed) {
			return _hx_qtype("apptimize.filter.ABTNamedFilter");
		}
		return _hx_qtype("apptimize.filter.ABTUnknownFilter");
	}
	static function filterForTypeFromJSON($json) {
		$operator = apptimize_filter_ABTFilter::operatorFromString(Reflect::field($json, apptimize_filter_ABTFilter::$kABTFilterKeyOperator));
		$type = apptimize_filter_ABTFilter::typeFromOperator($operator);
		return $type;
	}
	static function operatorFromString($string) {
		if("=" === $string) {
			return apptimize_filter_ABTFilterOperator::$ABTFilterOperatorEquals;
		}
		if("!=" === $string) {
			return apptimize_filter_ABTFilterOperator::$ABTFilterOperatorNotEquals;
		}
		if("regex" === $string) {
			return apptimize_filter_ABTFilterOperator::$ABTFilterOperatorRegex;
		}
		if("not_regex" === $string) {
			return apptimize_filter_ABTFilterOperator::$ABTFilterOperatorNotRegex;
		}
		if(">" === $string) {
			return apptimize_filter_ABTFilterOperator::$ABTFilterOperatorGreaterThan;
		}
		if(">=" === $string) {
			return apptimize_filter_ABTFilterOperator::$ABTFilterOperatorGreaterThanOrEqual;
		}
		if("<" === $string) {
			return apptimize_filter_ABTFilterOperator::$ABTFilterOperatorLessThan;
		}
		if("<=" === $string) {
			return apptimize_filter_ABTFilterOperator::$ABTFilterOperatorLessThanOrEqual;
		}
		if("in" === $string) {
			return apptimize_filter_ABTFilterOperator::$ABTFilterOperatorInList;
		}
		if("not_in" === $string) {
			return apptimize_filter_ABTFilterOperator::$ABTFilterOperatorNotInList;
		}
		if("intersection" === $string) {
			return apptimize_filter_ABTFilterOperator::$ABTFilterOperatorIntersection;
		}
		if("or" === $string) {
			return apptimize_filter_ABTFilterOperator::$ABTFilterOperatorCompoundOr;
		}
		if("and" === $string) {
			return apptimize_filter_ABTFilterOperator::$ABTFilterOperatorCompoundAnd;
		}
		if("not" === $string) {
			return apptimize_filter_ABTFilterOperator::$ABTFilterOperatorCompoundSingleNot;
		}
		if("is_null" === $string) {
			return apptimize_filter_ABTFilterOperator::$ABTFilterOperatorCompoundSingleIsNull;
		}
		if("is_not_null" === $string) {
			return apptimize_filter_ABTFilterOperator::$ABTFilterOperatorCompoundSingleIsNotNull;
		}
		if("is_property_null" === $string) {
			return apptimize_filter_ABTFilterOperator::$ABTFilterOperatorPropertyIsNull;
		}
		if("is_property_not_null" === $string) {
			return apptimize_filter_ABTFilterOperator::$ABTFilterOperatorPropertyIsNotNull;
		}
		if("is_recognized_property" === $string) {
			return apptimize_filter_ABTFilterOperator::$ABTFilterOperatorPropertyIsRecognized;
		}
		if("is_not_recognized_property" === $string) {
			return apptimize_filter_ABTFilterOperator::$ABTFilterOperatorPropertyIsNotRecognized;
		}
		if("is_recognized_operator" === $string) {
			return apptimize_filter_ABTFilterOperator::$ABTFilterOperatorOperatorIsRecognized;
		}
		if("is_not_recognized_operator" === $string) {
			return apptimize_filter_ABTFilterOperator::$ABTFilterOperatorOperatorIsNotRecognized;
		}
		if("value_of" === $string) {
			return apptimize_filter_ABTFilterOperator::$ABTFilterOperatorValueOf;
		}
		return apptimize_filter_ABTFilterOperator::$ABTFilterOperatorUnknown;
	}
	static function typeFromOperator($operator) {
		switch($operator->index) {
		case 0:{
		}break;
		case 1:{
			return apptimize_filter_ABTFilterType::$ABTFilterTypeSimple;
		}break;
		case 2:{
			return apptimize_filter_ABTFilterType::$ABTFilterTypeSimple;
		}break;
		case 3:{
			return apptimize_filter_ABTFilterType::$ABTFilterTypeSimple;
		}break;
		case 4:{
			return apptimize_filter_ABTFilterType::$ABTFilterTypeSimple;
		}break;
		case 5:{
			return apptimize_filter_ABTFilterType::$ABTFilterTypeSimple;
		}break;
		case 6:{
			return apptimize_filter_ABTFilterType::$ABTFilterTypeSimple;
		}break;
		case 7:{
			return apptimize_filter_ABTFilterType::$ABTFilterTypeSimple;
		}break;
		case 8:{
			return apptimize_filter_ABTFilterType::$ABTFilterTypeSimple;
		}break;
		case 9:{
			return apptimize_filter_ABTFilterType::$ABTFilterTypeList;
		}break;
		case 10:{
			return apptimize_filter_ABTFilterType::$ABTFilterTypeList;
		}break;
		case 11:{
			return apptimize_filter_ABTFilterType::$ABTFilterTypeSet;
		}break;
		case 12:{
			return apptimize_filter_ABTFilterType::$ABTFilterTypeCompound;
		}break;
		case 13:{
			return apptimize_filter_ABTFilterType::$ABTFilterTypeCompound;
		}break;
		case 14:{
			return apptimize_filter_ABTFilterType::$ABTFilterTypeCompound;
		}break;
		case 15:{
			return apptimize_filter_ABTFilterType::$ABTFilterTypeCompound;
		}break;
		case 16:{
			return apptimize_filter_ABTFilterType::$ABTFilterTypeCompound;
		}break;
		case 17:{
			return apptimize_filter_ABTFilterType::$ABTFilterTypePropertyless;
		}break;
		case 18:{
			return apptimize_filter_ABTFilterType::$ABTFilterTypePropertyless;
		}break;
		case 19:{
			return apptimize_filter_ABTFilterType::$ABTFilterTypePropertyless;
		}break;
		case 20:{
			return apptimize_filter_ABTFilterType::$ABTFilterTypePropertyless;
		}break;
		case 21:{
			return apptimize_filter_ABTFilterType::$ABTFilterTypePropertyless;
		}break;
		case 22:{
			return apptimize_filter_ABTFilterType::$ABTFilterTypePropertyless;
		}break;
		case 23:{
			return apptimize_filter_ABTFilterType::$ABTFilterTypeNamed;
		}break;
		}
		apptimize_ABTLogger::e("Unknown filter type. Filter match is unknown.", _hx_anonymous(array("fileName" => "ABTFilter.hx", "lineNumber" => 298, "className" => "apptimize.filter.ABTFilter", "methodName" => "typeFromOperator")));
		return apptimize_filter_ABTFilterType::$ABTFilterTypeUnknown;
	}
	function __toString() { return 'apptimize.filter.ABTFilter'; }
}
