<?php

// Copyright (c) Apptimize, Inc. | https://sdk.apptimize.com/license
class apptimize_filter_ABTFilterEnvironment {
	public function __construct($params, $urlTemplates, $valueLists, $sequenceNumber) {
		if(!php_Boot::$skip_constructor) {
		$this->userID = $params->userID;
		$this->anonID = $params->anonID;
		$this->customProperties = new apptimize_support_properties_ABTCustomProperties();
		$this->secondaryValueUrlTemplates = $urlTemplates;
		$this->secondaryValueLists = $valueLists;
		$this->applicationProperties = $params->appProps;
		$this->appkey = $params->appkey;
		$this->sequenceNumber = $sequenceNumber;
		if($params->customAttrs !== null) {
			$this->customProperties->setProperties($params->customAttrs);
		}
		$this->customProperties->setPropertyForNamespace("app_key", $params->appkey, apptimize_support_properties_CustomPropertyNamespace::$ApptimizeLocal);
	}}
	public $userID;
	public $anonID;
	public $customProperties;
	public $applicationProperties;
	public $sequenceNumber;
	public $appkey;
	public $secondaryValueUrlTemplates;
	public $secondaryValueLists;
	public function getUniqueUserID() {
		$tmp = _hx_string_or_null($this->appkey) . "_";
		return _hx_string_or_null($tmp) . _hx_string_or_null($this->getUserOrAnonID());
	}
	public function getUserOrAnonID() {
		if($this->userID !== null) {
			return $this->userID;
		}
		return $this->anonID;
	}
	public function valueForProperty($property, $source) {
		if($source === apptimize_filter_ABTFilterPropertySource::$ABTFilterPropertySourceDevice) {
			return $this->applicationProperties->valueForProperty($property);
		}
		if($source === apptimize_filter_ABTFilterPropertySource::$ABTFilterPropertySourceUser) {
			return $this->customProperties->valueForNamespacedProperty($property, apptimize_support_properties_CustomPropertyNamespace::$UserAttribute);
		}
		if($source === apptimize_filter_ABTFilterPropertySource::$ABTFilterPropertySourcePrefixed) {
			$value = $this->customProperties->valueForProperty($property);
			return $value;
		}
		return null;
	}
	public function secondaryUrlForKey($key) {
		$tmp = null;
		if($key !== null) {
			$tmp = $key === "";
		} else {
			$tmp = true;
		}
		if($tmp) {
			return null;
		}
		$urlTemplate = $this->secondaryValueUrlTemplates->get($key);
		if($urlTemplate === null) {
			apptimize_ABTLogger::e("unknown secondary url key " . _hx_string_or_null($key), _hx_anonymous(array("fileName" => "ABTFilterEnvironment.hx", "lineNumber" => 114, "className" => "apptimize.filter.ABTFilterEnvironment", "methodName" => "secondaryUrlForKey")));
			return null;
		}
		$url = $this->injectPropsInUrlTemplate($urlTemplate);
		if($url === null) {
			return null;
		}
		$paramSep = "&";
		if(_hx_index_of($url, "?", null) === -1) {
			$paramSep = "?";
		}
		$fullUrl = "" . _hx_string_or_null($url) . _hx_string_or_null($paramSep) . "metadataSequenceNumber=" . _hx_string_rec($this->sequenceNumber, "");
		return $fullUrl;
	}
	public function injectPropsInUrlTemplate($template) {
		$_gthis = $this;
		$regex = new EReg("\\{([^}]+)}", "g");
		$missingSome = false;
		$mapped = $regex->map($template, array(new _hx_lambda(array(&$_gthis, &$missingSome), "apptimize_filter_ABTFilterEnvironment_0"), 'execute'));
		if($missingSome) {
			return null;
		}
		return $mapped;
	}
	public function __call($m, $a) {
		if(isset($this->$m) && is_callable($this->$m))
			return call_user_func_array($this->$m, $a);
		else if(isset($this->__dynamics[$m]) && is_callable($this->__dynamics[$m]))
			return call_user_func_array($this->__dynamics[$m], $a);
		else if('toString' == $m)
			return $this->__toString();
		else
			throw new HException('Unable to call <'.$m.'>');
	}
	function __toString() { return 'apptimize.filter.ABTFilterEnvironment'; }
}
function apptimize_filter_ABTFilterEnvironment_0(&$_gthis, &$missingSome, $subregex) {
	{
		$key = $subregex->matched(1);
		$value = $_gthis->valueForProperty($key, apptimize_filter_ABTFilterPropertySource::$ABTFilterPropertySourcePrefixed);
		if($value === null) {
			$missingSome = true;
			return "<MISSING:" . _hx_string_or_null($key) . "}>";
		} else {
			return rawurlencode($value);
		}
	}
}
