<?php

// Copyright (c) Apptimize, Inc. | https://sdk.apptimize.com/license
class apptimize_filter_ABTSimpleFilter extends apptimize_filter_ABTFilter {
	public function __construct() { if(!php_Boot::$skip_constructor) {
		parent::__construct();
	}}
	public function fromJSON($json) {
		parent::fromJSON($json);
		$this->value = Reflect::field($json, apptimize_filter_ABTFilter::$kABTFilterKeyValue);
	}
	public function filterMatchesEnvironment($env) {
		if(!$this->hasSupportedProperty($env)) {
			return apptimize_filter_ABTFilterResult::$ABTFilterResultUnknown;
		}
		$currentValue = $this->currentDeviceValue($env);
		$filterValue = $this->value;
		$tmp = null;
		if($currentValue !== null) {
			$tmp = $filterValue === null;
		} else {
			$tmp = true;
		}
		if($tmp) {
			apptimize_ABTLogger::w("Filter has null value type. Filter match is unknown.", _hx_anonymous(array("fileName" => "ABTFilter.hx", "lineNumber" => 329, "className" => "apptimize.filter.ABTSimpleFilter", "methodName" => "filterMatchesEnvironment")));
			return apptimize_filter_ABTFilterResult::$ABTFilterResultUnknown;
		}
		if((is_object($_t = Type::getClass($currentValue)) && ($_t instanceof Enum) ? $_t == _hx_qtype("String") : _hx_equal($_t, _hx_qtype("String")))) {
			$tmp1 = null;
			if((is_object($_t2 = Type::typeof($filterValue)) && ($_t2 instanceof Enum) ? $_t2 != ValueType::$TFloat : !_hx_equal($_t2, ValueType::$TFloat))) {
				$tmp1 = (is_object($_t3 = Type::typeof($filterValue)) && ($_t3 instanceof Enum) ? $_t3 == ValueType::$TInt : _hx_equal($_t3, ValueType::$TInt));
			} else {
				$tmp1 = true;
			}
			if($tmp1) {
				return apptimize_filter_ABTFilterUtils::ABTEvaluateNumber($currentValue, $this->filterOperator, $filterValue);
			}
			if((is_object($_t3 = Type::getClass($filterValue)) && ($_t3 instanceof Enum) ? $_t3 != _hx_qtype("String") : !_hx_equal($_t3, _hx_qtype("String")))) {
				apptimize_ABTLogger::w("Filter value does not match property type of string. Filter match is unknown.", _hx_anonymous(array("fileName" => "ABTFilter.hx", "lineNumber" => 340, "className" => "apptimize.filter.ABTSimpleFilter", "methodName" => "filterMatchesEnvironment")));
				return apptimize_filter_ABTFilterResult::$ABTFilterResultUnknown;
			}
			$tmp2 = null;
			$tmp3 = null;
			$tmp4 = null;
			if($this->property !== "apptimize_version") {
				$tmp4 = $this->property === "system_version";
			} else {
				$tmp4 = true;
			}
			if(!$tmp4) {
				$tmp3 = $this->property === "app_version";
			} else {
				$tmp3 = true;
			}
			if(!$tmp3) {
				$tmp2 = $this->property === "operating_system_version";
			} else {
				$tmp2 = true;
			}
			if($tmp2) {
				return apptimize_filter_ABTFilterUtils::ABTEvaluateVersionString($currentValue, $this->filterOperator, $filterValue);
			}
			return apptimize_filter_ABTFilterUtils::ABTEvaluateString($currentValue, $this->filterOperator, $filterValue);
		}
		$tmp5 = null;
		if((is_object($_t2 = Type::typeof($currentValue)) && ($_t2 instanceof Enum) ? $_t2 != ValueType::$TFloat : !_hx_equal($_t2, ValueType::$TFloat))) {
			$tmp5 = (is_object($_t3 = Type::typeof($currentValue)) && ($_t3 instanceof Enum) ? $_t3 == ValueType::$TInt : _hx_equal($_t3, ValueType::$TInt));
		} else {
			$tmp5 = true;
		}
		if($tmp5) {
			if((is_object($_t3 = Type::getClass($filterValue)) && ($_t3 instanceof Enum) ? $_t3 == _hx_qtype("String") : _hx_equal($_t3, _hx_qtype("String")))) {
				return apptimize_filter_ABTFilterUtils::ABTEvaluateNumber($currentValue, $this->filterOperator, $filterValue);
			}
			$tmp6 = null;
			if((is_object($_t4 = Type::typeof($filterValue)) && ($_t4 instanceof Enum) ? $_t4 != ValueType::$TFloat : !_hx_equal($_t4, ValueType::$TFloat))) {
				$tmp6 = (is_object($_t5 = Type::typeof($filterValue)) && ($_t5 instanceof Enum) ? $_t5 != ValueType::$TInt : !_hx_equal($_t5, ValueType::$TInt));
			} else {
				$tmp6 = false;
			}
			if($tmp6) {
				apptimize_ABTLogger::w("Filter value does not match property type of number. Filter match is unknown.", _hx_anonymous(array("fileName" => "ABTFilter.hx", "lineNumber" => 358, "className" => "apptimize.filter.ABTSimpleFilter", "methodName" => "filterMatchesEnvironment")));
				return apptimize_filter_ABTFilterResult::$ABTFilterResultUnknown;
			}
			return apptimize_filter_ABTFilterUtils::ABTEvaluateNumber($currentValue, $this->filterOperator, $filterValue);
		}
		if((is_object($_t3 = Type::typeof($currentValue)) && ($_t3 instanceof Enum) ? $_t3 == ValueType::$TBool : _hx_equal($_t3, ValueType::$TBool))) {
			if((is_object($_t4 = Type::getClass($filterValue)) && ($_t4 instanceof Enum) ? $_t4 == _hx_qtype("String") : _hx_equal($_t4, _hx_qtype("String")))) {
				if(_hx_equal(_hx_string_call($filterValue, "toLowerCase", array()), "true")) {
					$filterValue = true;
				} else {
					if(_hx_equal(_hx_string_call($filterValue, "toLowerCase", array()), "false")) {
						$filterValue = false;
					}
				}
			}
			return apptimize_filter_ABTFilterUtils::ABTEvaluateBool($currentValue, $this->filterOperator, $filterValue);
		}
		apptimize_ABTLogger::w("Simple filter match is unknown.", _hx_anonymous(array("fileName" => "ABTFilter.hx", "lineNumber" => 378, "className" => "apptimize.filter.ABTSimpleFilter", "methodName" => "filterMatchesEnvironment")));
		return apptimize_filter_ABTFilterResult::$ABTFilterResultUnknown;
	}
	function __toString() { return 'apptimize.filter.ABTSimpleFilter'; }
}
