<?php

// Copyright (c) Apptimize, Inc. | https://sdk.apptimize.com/license
class apptimize_models_ABTMetadata {
	public function __construct() {
		if(!php_Boot::$skip_constructor) {
		$this->_alterationCache = new apptimize_util_ABTLRUCache(apptimize_support_properties_ABTConfigProperties::sharedInstance()->valueForProperty(apptimize_support_properties_ABTConfigProperties::$ALTERATION_CACHE_SIZE_KEY));
	}}
	public $_jsonData;
	public $_seedGroups;
	public $_hotfixes;
	public $_alterationCache;
	public $_etag;
	public $_secondaryValues;
	public function makeEnvironment($params) {
		$valueLists = $this->_secondaryValues;
		$_g = new haxe_ds_StringMap();
		$_g->set("groupsApiUrl", $this->getGroupsUrlTemplate());
		$templates = $_g;
		return new apptimize_filter_ABTFilterEnvironment($params, $templates, $valueLists, $this->getSequenceNumber());
	}
	public function getGroupsUrlTemplate() {
		$groupsBaseUrl = apptimize_support_properties_ABTConfigProperties::sharedInstance()->valueForProperty(apptimize_support_properties_ABTConfigProperties::$GROUPS_BASE_URL_KEY);
		$groupsFullUrl = _hx_string_or_null($groupsBaseUrl) . "/api/pilot-groups/?appKey={lapp_key}&pilotTargetingId={lpilot_targeting_id}";
		return $groupsFullUrl;
	}
	public function _load_data($content) {
		$this->_alterationCache = new apptimize_util_ABTLRUCache(apptimize_support_properties_ABTConfigProperties::sharedInstance()->valueForProperty(apptimize_support_properties_ABTConfigProperties::$ALTERATION_CACHE_SIZE_KEY));
		$this->_jsonData = _hx_deref(new haxe_format_JsonParser($content))->parseRec();
		$this->_seedGroups = new _hx_array(array());
		if($this->_jsonData->seedGroups !== null) {
			$_g = 0;
			$_g1 = $this->_jsonData->seedGroups;
			while($_g < $_g1->length) {
				$sg = $_g1[$_g];
				$_g = $_g + 1;
				$tmp = $this->_seedGroups;
				$tmp->push(new apptimize_models_ABTSeedGroup($sg));
				unset($tmp,$sg);
			}
		}
		$this->_hotfixes = new _hx_array(array());
		if($this->_jsonData->hotfixes !== null) {
			$_g2 = 0;
			$_g11 = $this->_jsonData->hotfixes;
			while($_g2 < $_g11->length) {
				$hf = $_g11[$_g2];
				$_g2 = $_g2 + 1;
				$tmp1 = $this->_hotfixes;
				$tmp1->push(new apptimize_models_ABTHotfixVariant($hf));
				unset($tmp1,$hf);
			}
		}
	}
	public function uncachedSelectAlterationsIntoArray($env, $checkCache = null) {
		if($checkCache === null) {
			$checkCache = true;
		}
		$alterations = new _hx_array(array());
		{
			$_g = 0;
			$_g1 = $this->_seedGroups;
			while($_g < $_g1->length) {
				$seedgroup = $_g1[$_g];
				$_g = $_g + 1;
				$seedgroup->selectAlterationsIntoArray($env, $alterations, false);
				unset($seedgroup);
			}
		}
		{
			$_g2 = 0;
			$_g11 = $this->_hotfixes;
			while($_g2 < $_g11->length) {
				$hotfix = $_g11[$_g2];
				$_g2 = $_g2 + 1;
				$hotfix->selectAlterationsIntoArray($env, $alterations, false);
				unset($hotfix);
			}
		}
		return $alterations;
	}
	public function selectAlterationsIntoArray($env) {
		$alterations = $this->uncachedSelectAlterationsIntoArray($env, false);
		$this->metadataProcessed($env, $alterations);
		return $alterations;
	}
	public function extractNeededSecondaryUrls($env) {
		$keys = new _hx_array(array());
		{
			$_g = 0;
			$_g1 = $this->_seedGroups;
			while($_g < $_g1->length) {
				$seedgroup = $_g1[$_g];
				$_g = $_g + 1;
				$keys = $keys->concat($seedgroup->getUrlKeys());
				unset($seedgroup);
			}
		}
		{
			$_g2 = 0;
			$_g11 = $this->_hotfixes;
			while($_g2 < $_g11->length) {
				$hotfix = $_g11[$_g2];
				$_g2 = $_g2 + 1;
				$keys = $keys->concat($hotfix->getUrlKeys());
				unset($hotfix);
			}
		}
		$ret = new _hx_array(array());
		$map = new haxe_ds_StringMap();
		{
			$_g3 = 0;
			while($_g3 < $keys->length) {
				$key = $keys[$_g3];
				$_g3 = $_g3 + 1;
				if(!$map->exists($key)) {
					$value = $env->secondaryUrlForKey($key);
					$map->set($key, $value);
					if($value !== null) {
						$ret->push($value);
					}
					unset($value);
				}
				unset($key);
			}
		}
		return $ret;
	}
	public function extractSdkParameters($env) {
		$ret = new apptimize_models_ABTSdkParameters(null);
		if($this->_seedGroups !== null) {
			$_g = 0;
			$_g1 = $this->_seedGroups;
			while($_g < $_g1->length) {
				$seedGroup = $_g1[$_g];
				$_g = $_g + 1;
				$seedGroup->applySdkParameters($ret, $env);
				unset($seedGroup);
			}
		}
		return $ret;
	}
	public function metadataProcessed($env, $alterations) {
		$metadataProcessedEntry = $this->getSequenceNumber();
		$metadataProcessedEntry1 = new apptimize_models_results_ABTResultEntryMetadataProcessed($env, $metadataProcessedEntry, $this->getVariantsCyclesPhases($alterations));
		apptimize_ABTDataStore::sharedInstance()->addResultLogEntry($env, $metadataProcessedEntry1);
	}
	public function getVariantsCyclesPhases($alterations) {
		$variantsCyclesPhases = new haxe_ds_IntMap();
		{
			$_g = 0;
			while($_g < $alterations->length) {
				$alteration = $alterations[$_g];
				$_g = $_g + 1;
				$variant = $alteration->getVariant();
				$phase = $variant->getPhase();
				$variantStickyString = "v" . _hx_string_rec($variant->getVariantID(), "") . "_";
				$variantStickyString1 = _hx_string_or_null($variantStickyString) . _hx_string_rec($variant->getCycle(), "");
				$tmp = null;
				if((is_object($_t = Type::getClass($variant)) && ($_t instanceof Enum) ? $_t != _hx_qtype("apptimize.models.ABTHotfixVariant") : !_hx_equal($_t, _hx_qtype("apptimize.models.ABTHotfixVariant")))) {
					$tmp = !$variantsCyclesPhases->exists($variant->getVariantID());
				} else {
					$tmp = false;
				}
				if($tmp) {
					$k = $variant->getVariantID();
					$v = $variant->getVariantID();
					$v1 = _hx_anonymous(array("v" => $v, "c" => $variant->getCycle(), "p" => $phase));
					$variantsCyclesPhases->set($k, $v1);
					unset($v1,$v,$k);
				}
				unset($variantStickyString1,$variantStickyString,$variant,$tmp,$phase,$alteration,$_t);
			}
		}
		return Lambda::harray($variantsCyclesPhases);
	}
	public function getMetaData() {
		return $this->_jsonData;
	}
	public function getSequenceNumber() {
		return $this->_jsonData->sequenceNumber;
	}
	public function getCheckinUrls() {
		return $this->_jsonData->checkinUrls;
	}
	public function getAppKey() {
		return $this->_jsonData->appKey;
	}
	public function getEtag() {
		return $this->_etag;
	}
	public function setEtag($etag) {
		$this->_etag = $etag;
	}
	public function setSecondaryValues($values) {
		$this->_secondaryValues = $values;
	}
	public function getSecondaryValues() {
		return $this->_secondaryValues;
	}
	public function getDisabledVersions() {
		$disableAll = Reflect::field($this->_jsonData, "disableAllVersions");
		$disableVersions = Reflect::field($this->_jsonData, "disabledCrossPlatformVersions");
		$ret = new _hx_array(array());
		if($disableAll) {
			$ret->push(apptimize_Apptimize::getApptimizeSDKVersion());
		}
		if($disableVersions !== null) {
			$ret = $ret->concat($this->_jsonData->disabledCrossPlatformVersions);
		}
		return $ret;
	}
	public function hxSerialize($s) {
		$this->serializeV1($s);
		$s->serialize($this->_secondaryValues);
	}
	public function serializeV1($s) {
		$s->serialize(haxe_format_JsonPrinter::hprint($this->_jsonData, null, null));
		$s->serialize($this->_etag);
	}
	public function hxUnserialize($u) {
		$this->_load_data($u->unserialize());
		$this->_etag = $u->unserialize();
		try {
			$this->_secondaryValues = $u->unserialize();
		}catch(Exception $__hx__e) {
			$_ex_ = ($__hx__e instanceof HException) && $__hx__e->getCode() == null ? $__hx__e->e : $__hx__e;
			$e = $_ex_;
			{
				$this->_secondaryValues = null;
			}
		}
	}
	public function __call($m, $a) {
		if(isset($this->$m) && is_callable($this->$m))
			return call_user_func_array($this->$m, $a);
		else if(isset($this->__dynamics[$m]) && is_callable($this->__dynamics[$m]))
			return call_user_func_array($this->__dynamics[$m], $a);
		else if('toString' == $m)
			return $this->__toString();
		else
			throw new HException('Unable to call <'.$m.'>');
	}
	static function loadFromString($content) {
		$m = new apptimize_models_ABTMetadata();
		$m->_load_data($content);
		return $m;
	}
	function __toString() { return 'apptimize.models.ABTMetadata'; }
}
