<?php

// Copyright (c) Apptimize, Inc. | https://sdk.apptimize.com/license
class apptimize_models_ABTRangeGroup extends apptimize_filter_ABTFilterableObject {
	public function __construct($group) {
		if(!php_Boot::$skip_constructor) {
		parent::__construct();
		$this->fromJSON($group);
	}}
	public $ranges;
	public $sdkParameters;
	public $seedGroups;
	public $variants;
	public function fromJSON($group) {
		parent::fromJSON($group);
		$rangeGroup = $group;
		$this->ranges = new _hx_array(array());
		if($rangeGroup->ranges !== null) {
			$_g = 0;
			$_g1 = $rangeGroup->ranges;
			while($_g < $_g1->length) {
				$range = $_g1[$_g];
				$_g = $_g + 1;
				$tmp = $this->ranges;
				$tmp->push(new apptimize_models_ABTRange($range));
				unset($tmp,$range);
			}
		}
		$this->seedGroups = new _hx_array(array());
		if($rangeGroup->seedGroups !== null) {
			$_g2 = 0;
			$_g11 = $rangeGroup->seedGroups;
			while($_g2 < $_g11->length) {
				$sg = $_g11[$_g2];
				$_g2 = $_g2 + 1;
				$tmp1 = $this->seedGroups;
				$tmp1->push(new apptimize_models_ABTSeedGroup($sg));
				unset($tmp1,$sg);
			}
		}
		$this->variants = new _hx_array(array());
		if($rangeGroup->variants !== null) {
			$_g3 = 0;
			$_g12 = $rangeGroup->variants;
			while($_g3 < $_g12->length) {
				$variant = $_g12[$_g3];
				$_g3 = $_g3 + 1;
				$tmp2 = $this->variants;
				$tmp2->push(new apptimize_models_ABTVariant($variant));
				unset($variant,$tmp2);
			}
		}
		if(_hx_has_field($group, "sdkParameters")) {
			$this->sdkParameters = new apptimize_models_ABTSdkParameters(_hx_field($group, "sdkParameters"));
		}
	}
	public function selectAlterationsIntoArray($env, $target, $overrideOnly) {
		$match = $this->performFilterMatchingWithEnvironment($env);
		if((is_object($_t = $match->result) && ($_t instanceof Enum) ? $_t != apptimize_filter_ABTFilterResult::$ABTFilterResultTrue : !_hx_equal($_t, apptimize_filter_ABTFilterResult::$ABTFilterResultTrue))) {
			return;
		}
		$newOverrideOnly = $this->computeNewOverrideState($overrideOnly, $match);
		{
			$_g = 0;
			$_g1 = $this->variants;
			while($_g < $_g1->length) {
				$variant = $_g1[$_g];
				$_g = $_g + 1;
				$variant->selectAlterationsIntoArray($env, $target, $newOverrideOnly);
				unset($variant);
			}
		}
		{
			$_g2 = 0;
			$_g11 = $this->seedGroups;
			while($_g2 < $_g11->length) {
				$seedgroup = $_g11[$_g2];
				$_g2 = $_g2 + 1;
				$seedgroup->selectAlterationsIntoArray($env, $target, $newOverrideOnly);
				unset($seedgroup);
			}
		}
	}
	public function isSelectedBySeed($seed) {
		{
			$_g = 0;
			$_g1 = $this->ranges;
			while($_g < $_g1->length) {
				$range = $_g1[$_g];
				$_g = $_g + 1;
				$tmp = null;
				if($seed >= $range->start) {
					$tmp = $seed < $range->end;
				} else {
					$tmp = false;
				}
				if($tmp) {
					return true;
				}
				unset($tmp,$range);
			}
		}
		return false;
	}
	public function getUrlKeyProviders() {
		$tmp = $this->asUrlProviders($this->seedGroups);
		return $tmp->concat($this->asUrlProviders($this->variants));
	}
	public function applySdkParameters($to, $env) {
		if($this->sdkParameters !== null) {
			$to->mergeOther($this->sdkParameters);
		}
		{
			$_g = 0;
			$_g1 = $this->seedGroups;
			while($_g < $_g1->length) {
				$seedGroup = $_g1[$_g];
				$_g = $_g + 1;
				$seedGroup->applySdkParameters($to, $env);
				unset($seedGroup);
			}
		}
	}
	public function __call($m, $a) {
		if(isset($this->$m) && is_callable($this->$m))
			return call_user_func_array($this->$m, $a);
		else if(isset($this->__dynamics[$m]) && is_callable($this->__dynamics[$m]))
			return call_user_func_array($this->__dynamics[$m], $a);
		else if('toString' == $m)
			return $this->__toString();
		else
			throw new HException('Unable to call <'.$m.'>');
	}
	function __toString() { return 'apptimize.models.ABTRangeGroup'; }
}
