<?php

// Copyright (c) Apptimize, Inc. | https://sdk.apptimize.com/license
class apptimize_models_ABTSeed {
	public function __construct($seed) {
		if(!php_Boot::$skip_constructor) {
		$this->fromDef($seed);
	}}
	public $type;
	public $value;
	public function fromDef($seed) {
		$this->type = $seed->type;
		$this->value = $seed->value;
	}
	public function computedSeedMaterial($userID) {
		if($this->type === "guid") {
			$base = haxe_io_Bytes::ofString("0123456789abcdef");
			$resultStr = strtolower(str_replace("-", "", $userID));
			try {
				if(strlen($resultStr) === 32) {
					$tmp = new haxe_crypto_BaseCode($base);
					return apptimize_util_ABTHash::Sha1($tmp->decodeBytes(haxe_io_Bytes::ofString($resultStr)));
				}
			}catch(Exception $__hx__e) {
				$_ex_ = ($__hx__e instanceof HException) && $__hx__e->getCode() == null ? $__hx__e->e : $__hx__e;
				if(is_string($baseCodeError = $_ex_)){
					apptimize_ABTLogger::w("Invalid GUID supplied - treating as string user ID.", _hx_anonymous(array("fileName" => "ABTSeed.hx", "lineNumber" => 33, "className" => "apptimize.models.ABTSeed", "methodName" => "computedSeedMaterial")));
				} else throw $__hx__e;;
			}
			return apptimize_util_ABTHash::Sha1(haxe_io_Bytes::ofString($userID));
		} else {
			if($this->value !== null) {
				return apptimize_util_ABTHash::Sha1(haxe_io_Bytes::ofString($this->value));
			} else {
				apptimize_ABTLogger::e("Unable to calculate seed for supplied user ID of type: " . _hx_string_or_null($this->type) . ".", _hx_anonymous(array("fileName" => "ABTSeed.hx", "lineNumber" => 41, "className" => "apptimize.models.ABTSeed", "methodName" => "computedSeedMaterial")));
				return null;
			}
		}
	}
	public function __call($m, $a) {
		if(isset($this->$m) && is_callable($this->$m))
			return call_user_func_array($this->$m, $a);
		else if(isset($this->__dynamics[$m]) && is_callable($this->__dynamics[$m]))
			return call_user_func_array($this->__dynamics[$m], $a);
		else if('toString' == $m)
			return $this->__toString();
		else
			throw new HException('Unable to call <'.$m.'>');
	}
	function __toString() { return 'apptimize.models.ABTSeed'; }
}
