<?php

// Copyright (c) Apptimize, Inc. | https://sdk.apptimize.com/license
class apptimize_models_ABTSeedGroup extends apptimize_filter_ABTFilterableObject {
	public function __construct($group) {
		if(!php_Boot::$skip_constructor) {
		parent::__construct();
		$this->fromJSON($group);
	}}
	public $rangeGroups;
	public $seeds;
	public function fromJSON($group) {
		parent::fromJSON($group);
		$jsonSeedGroup = $group;
		$this->rangeGroups = new _hx_array(array());
		if($jsonSeedGroup->rangeGroups !== null) {
			$_g = 0;
			$_g1 = $jsonSeedGroup->rangeGroups;
			while($_g < $_g1->length) {
				$range = $_g1[$_g];
				$_g = $_g + 1;
				$tmp = $this->rangeGroups;
				$tmp->push(new apptimize_models_ABTRangeGroup($range));
				unset($tmp,$range);
			}
		}
		$this->seeds = new _hx_array(array());
		if($jsonSeedGroup->seeds !== null) {
			$_g2 = 0;
			$_g11 = $jsonSeedGroup->seeds;
			while($_g2 < $_g11->length) {
				$seed = $_g11[$_g2];
				$_g2 = $_g2 + 1;
				$tmp1 = $this->seeds;
				$tmp1->push(new apptimize_models_ABTSeed($seed));
				unset($tmp1,$seed);
			}
		}
	}
	public function computedSeedMaterial($userID) {
		$buffer = new haxe_io_BytesBuffer();
		{
			$_g = 0;
			$_g1 = $this->seeds;
			while($_g < $_g1->length) {
				$seed = $_g1[$_g];
				$_g = $_g + 1;
				$b = $seed->computedSeedMaterial($userID);
				{
					$len = $b->length;
					$tmp = null;
					if($len >= 0) {
						$tmp = $len > $b->length;
					} else {
						$tmp = true;
					}
					if($tmp) {
						throw new HException(haxe_io_Error::$OutsideBounds);
					}
					$buffer1 = $buffer;
					$buffer2 = $buffer1->b;
					$this1 = $b->b;
					$x = new php__BytesData_Wrapper(substr($this1->s, 0, $len));
					$this2 = $x;
					$buffer1->b = _hx_string_or_null($buffer2) . _hx_string_or_null($this2->s);
					unset($x,$tmp,$this2,$this1,$len,$buffer2,$buffer1);
				}
				unset($seed,$b);
			}
		}
		return apptimize_util_ABTHash::Sha1($buffer->getBytes());
	}
	public function seed($userID) {
		$data = $this->computedSeedMaterial($userID);
		$len = $data->length;
		if($len < 4) {
			apptimize_ABTLogger::e("User ID length too short for seed: " . _hx_string_rec($len, "") . ".", _hx_anonymous(array("fileName" => "ABTSeedGroup.hx", "lineNumber" => 64, "className" => "apptimize.models.ABTSeedGroup", "methodName" => "seed")));
			return 0;
		}
		$l = $len - 4;
		$this1 = $data->b;
		$seed = ord($this1->s[$l + 3]);
		$this2 = $data->b;
		$seed1 = $seed | ord($this2->s[$l + 2]) << 8;
		$this3 = $data->b;
		$seed2 = $seed1 | ord($this3->s[$l + 1]) << 16;
		$this4 = $data->b;
		$seed3 = $seed2 | ord($this4->s[$l]) << 24;
		$seed3 = $seed3 & 1073741823;
		return $seed3;
	}
	public function selectAlterationsIntoArray($env, $target, $overrideOnly) {
		$match = $this->performFilterMatchingWithEnvironment($env);
		if((is_object($_t = $match->result) && ($_t instanceof Enum) ? $_t != apptimize_filter_ABTFilterResult::$ABTFilterResultTrue : !_hx_equal($_t, apptimize_filter_ABTFilterResult::$ABTFilterResultTrue))) {
			return;
		}
		$newOverrideOnly = $this->computeNewOverrideState($overrideOnly, $match);
		$seed = $this->seed($env->getUserOrAnonID());
		$tmp = "Calculated seed for user " . _hx_string_or_null($env->getUserOrAnonID()) . ": " . _hx_string_rec($seed, "") . ".";
		apptimize_ABTLogger::v($tmp, _hx_anonymous(array("fileName" => "ABTSeedGroup.hx", "lineNumber" => 89, "className" => "apptimize.models.ABTSeedGroup", "methodName" => "selectAlterationsIntoArray")));
		{
			$_g = 0;
			$_g1 = $this->rangeGroups;
			while($_g < $_g1->length) {
				$rangeGroup = $_g1[$_g];
				$_g = $_g + 1;
				if($rangeGroup->isSelectedBySeed($seed)) {
					$rangeGroup->selectAlterationsIntoArray($env, $target, $newOverrideOnly);
				} else {
					$rangeGroup->selectAlterationsIntoArray($env, $target, true);
				}
				unset($rangeGroup);
			}
		}
	}
	public function getUrlKeyProviders() {
		return $this->asUrlProviders($this->rangeGroups);
	}
	public function applySdkParameters($to, $env) {
		$match = $this->performFilterMatchingWithEnvironment($env);
		if((is_object($_t = $match->result) && ($_t instanceof Enum) ? $_t == apptimize_filter_ABTFilterResult::$ABTFilterResultTrue : _hx_equal($_t, apptimize_filter_ABTFilterResult::$ABTFilterResultTrue))) {
			$seed = $this->seed($env->getUserOrAnonID());
			{
				$_g = 0;
				$_g1 = $this->rangeGroups;
				while($_g < $_g1->length) {
					$rangeGroup = $_g1[$_g];
					$_g = $_g + 1;
					if($rangeGroup->isSelectedBySeed($seed)) {
						$rangeGroup->applySdkParameters($to, $env);
					}
					unset($rangeGroup);
				}
			}
		}
	}
	public function __call($m, $a) {
		if(isset($this->$m) && is_callable($this->$m))
			return call_user_func_array($this->$m, $a);
		else if(isset($this->__dynamics[$m]) && is_callable($this->__dynamics[$m]))
			return call_user_func_array($this->__dynamics[$m], $a);
		else if('toString' == $m)
			return $this->__toString();
		else
			throw new HException('Unable to call <'.$m.'>');
	}
	function __toString() { return 'apptimize.models.ABTSeedGroup'; }
}
