<?php

// Copyright (c) Apptimize, Inc. | https://sdk.apptimize.com/license
class apptimize_models_results_ABTResultEntry extends apptimize_models_ABTJSONObject {
	public function __construct($env) {
		if(!php_Boot::$skip_constructor) {
		{
			apptimize_models_results_ABTResultEntry::$RESULT_ENTRY_CREATION_LOCK->acquire();
			try {
				$this->_id = $this->_getNextSequenceNumber();
				$this->_deviceTimestamp = haxe_Int64Helper::fromFloat(Date::now()->getTime());
				$this->_monotonicTimestamp = $this->_getMonotonicTimestamp($this->_deviceTimestamp);
			}catch(Exception $__hx__e) {
				$_ex_ = ($__hx__e instanceof HException) && $__hx__e->getCode() == null ? $__hx__e->e : $__hx__e;
				$e = $_ex_;
				{
					apptimize_models_results_ABTResultEntry::$RESULT_ENTRY_CREATION_LOCK->release();
					throw new HException($e);
				}
			}
			apptimize_models_results_ABTResultEntry::$RESULT_ENTRY_CREATION_LOCK->release();
		}
		$this->_prefixedAttributes = new haxe_ds_StringMap();
		$tmp = null;
		if($env !== null) {
			$tmp = $env->customProperties->availableProperties !== null;
		} else {
			$tmp = false;
		}
		if($tmp) {
			$env->customProperties->addJSONProperties($this->_prefixedAttributes);
		}
		apptimize_support_properties_ABTInternalProperties::sharedInstance()->addJSONProperties($this->_prefixedAttributes);
		$env->applicationProperties->addJSONProperties($this->_prefixedAttributes);
	}}
	public $_id;
	public $_monotonicTimestamp;
	public $_deviceTimestamp;
	public $_userAttributes;
	public $_prefixedAttributes;
	public function _getNextSequenceNumber() {
		$sequenceString = apptimize_support_persistence_ABTPersistence::loadString(apptimize_support_persistence_ABTPersistence::$kResultEntrySequenceKey, null);
		$x = new haxe__Int64____Int64(0, 0);
		$this1 = $x;
		$sequence = $this1;
		if($sequenceString !== null) {
			$sequence = haxe_Int64Helper::parseString($sequenceString);
		}
		{
			$ret = $sequence;
			{
				$x1 = new haxe__Int64____Int64($sequence->high, $sequence->low);
				$this2 = $x1;
				$sequence = $this2;
				{
					$ret1 = $sequence->low++;
					$sequence->low = $sequence->low << haxe__Int32_Int32_Impl_::$extraBits >> haxe__Int32_Int32_Impl_::$extraBits;
				}
				if($sequence->low === 0) {
					$ret2 = $sequence->high++;
					$sequence->high = $sequence->high << haxe__Int32_Int32_Impl_::$extraBits >> haxe__Int32_Int32_Impl_::$extraBits;
				}
			}
		}
		$tmp = apptimize_support_persistence_ABTPersistence::$kResultEntrySequenceKey;
		apptimize_support_persistence_ABTPersistence::saveString($tmp, haxe__Int64_Int64_Impl_::toString($sequence), null, null);
		return $sequence;
	}
	public function _getMonotonicTimestamp($deviceTime) {
		$timestamp = $deviceTime;
		$x = new haxe__Int64____Int64(0, 0);
		$this1 = $x;
		$lastTimestamp = $this1;
		$lastTimestampString = apptimize_support_persistence_ABTPersistence::loadString(apptimize_support_persistence_ABTPersistence::$kResultEntryTimestampKey, null);
		if($lastTimestampString !== null) {
			$lastTimestamp = haxe_Int64Helper::parseString($lastTimestampString);
		}
		$v = $lastTimestamp->high - $deviceTime->high << haxe__Int32_Int32_Impl_::$extraBits >> haxe__Int32_Int32_Impl_::$extraBits;
		if($v !== 0) {
			$v = $v;
		} else {
			$v = haxe__Int32_Int32_Impl_::ucompare($lastTimestamp->low, $deviceTime->low);
		}
		$tmp = null;
		if($lastTimestamp->high < 0) {
			if($deviceTime->high < 0) {
				$tmp = $v;
			} else {
				$tmp = -1;
			}
		} else {
			if($deviceTime->high >= 0) {
				$tmp = $v;
			} else {
				$tmp = 1;
			}
		}
		if($tmp >= 0) {
			$x1 = new haxe__Int64____Int64(0, 1);
			$this2 = $x1;
			$b = $this2;
			$high = $lastTimestamp->high + $b->high << haxe__Int32_Int32_Impl_::$extraBits >> haxe__Int32_Int32_Impl_::$extraBits;
			$low = $lastTimestamp->low + $b->low << haxe__Int32_Int32_Impl_::$extraBits >> haxe__Int32_Int32_Impl_::$extraBits;
			if(haxe__Int32_Int32_Impl_::ucompare($low, $lastTimestamp->low) < 0) {
				$high = $high + 1;
				$ret = $high - 1;
				$high = $high << haxe__Int32_Int32_Impl_::$extraBits >> haxe__Int32_Int32_Impl_::$extraBits;
			}
			$x2 = new haxe__Int64____Int64($high, $low);
			$this3 = $x2;
			$timestamp = $this3;
		}
		$tmp1 = apptimize_support_persistence_ABTPersistence::$kResultEntryTimestampKey;
		apptimize_support_persistence_ABTPersistence::saveString($tmp1, haxe__Int64_Int64_Impl_::toString($timestamp), null, null);
		return $timestamp;
	}
	public function JSONRepresentation() {
		$_g = new haxe_ds_StringMap();
		$_g->set("ei", apptimize_util_ABTInt64Utils::toPreprocessedString($this->_id));
		$_g->set("mt", apptimize_util_ABTInt64Utils::toPreprocessedString($this->_monotonicTimestamp));
		$_g->set("dt", apptimize_util_ABTInt64Utils::toPreprocessedString($this->_deviceTimestamp));
		$_g->set("pa", apptimize_util_ABTUtilDictionary::filterNullValues($this->_prefixedAttributes));
		$jsonDict = $_g;
		if($this->_userAttributes !== null) {
			$v = apptimize_util_ABTUtilDictionary::filterNullValues($this->_userAttributes);
			$jsonDict->set("ua", $v);
		}
		return $jsonDict;
	}
	public function hxSerialize($s) {
		apptimize_util_ABTInt64Utils::_serializeInt64($this->_id, $s);
		apptimize_util_ABTInt64Utils::_serializeInt64($this->_monotonicTimestamp, $s);
		apptimize_util_ABTInt64Utils::_serializeInt64($this->_deviceTimestamp, $s);
		$s->serialize($this->_userAttributes);
		$s->serialize($this->_prefixedAttributes);
	}
	public function hxUnserialize($u) {
		$this->_id = apptimize_util_ABTInt64Utils::_deserializeInt64($u);
		$this->_monotonicTimestamp = apptimize_util_ABTInt64Utils::_deserializeInt64($u);
		$this->_deviceTimestamp = apptimize_util_ABTInt64Utils::_deserializeInt64($u);
		$this->_userAttributes = $u->unserialize();
		$this->_prefixedAttributes = $u->unserialize();
	}
	public function __call($m, $a) {
		if(isset($this->$m) && is_callable($this->$m))
			return call_user_func_array($this->$m, $a);
		else if(isset($this->__dynamics[$m]) && is_callable($this->__dynamics[$m]))
			return call_user_func_array($this->__dynamics[$m], $a);
		else if('toString' == $m)
			return $this->__toString();
		else
			throw new HException('Unable to call <'.$m.'>');
	}
	static $RESULT_ENTRY_CREATION_LOCK;
	function __toString() { return 'apptimize.models.results.ABTResultEntry'; }
}
apptimize_models_results_ABTResultEntry::$RESULT_ENTRY_CREATION_LOCK = apptimize_util_ABTDataLock::getNewLock("result_entry_creation_lock_key");
