<?php

// Copyright (c) Apptimize, Inc. | https://sdk.apptimize.com/license
class apptimize_support_persistence_ABTPICacheStorage extends apptimize_support_persistence_ABTPersistentInterface {
	public function __construct() {
		if(!php_Boot::$skip_constructor) {
		$this->cacheMap = new haxe_ds_StringMap();
	}}
	public $cacheMap;
	public function save($key, $value, $latency = null, $compress = null) {
		if($compress === null) {
			$compress = false;
		}
		if($latency === null) {
			$latency = 0;
		}
		if($value !== null) {
			$this->cacheMap->set($key, $value);
		} else {
			$this->cacheMap->remove($key);
		}
	}
	public function saveObject($key, $value, $latency = null, $compress = null) {
		if($compress === null) {
			$compress = false;
		}
		if($latency === null) {
			$latency = 0;
		}
		if($value !== null) {
			$this->cacheMap->set($key, $value);
		} else {
			$this->cacheMap->remove($key);
		}
	}
	public function loadObject($key, $latency = null, $callback = null) {
		if($latency === null) {
			$latency = 0;
		}
		$value = $this->cacheMap->get($key);
		if($callback !== null) {
			call_user_func_array($callback, array($key, $value));
		}
		return $value;
	}
	public function load($key, $latency = null, $callback = null) {
		if($latency === null) {
			$latency = 0;
		}
		$value = $this->cacheMap->get($key);
		if($callback !== null) {
			call_user_func_array($callback, array($key, $value));
		}
		return $value;
	}
	public function clear($latency = null) {
		if($latency === null) {
			$latency = 0;
		}
		$this->cacheMap = new haxe_ds_StringMap();
	}
	public function sync($key, $fromLatency, $toLatency, $callback = null) {
		if($callback !== null) {
			call_user_func_array($callback, array($key, $this->load($key, null, null)));
		}
	}
	public function __call($m, $a) {
		if(isset($this->$m) && is_callable($this->$m))
			return call_user_func_array($this->$m, $a);
		else if(isset($this->__dynamics[$m]) && is_callable($this->__dynamics[$m]))
			return call_user_func_array($this->__dynamics[$m], $a);
		else if('toString' == $m)
			return $this->__toString();
		else
			throw new HException('Unable to call <'.$m.'>');
	}
	function __toString() { return 'apptimize.support.persistence.ABTPICacheStorage'; }
}
