<?php

// Copyright (c) Apptimize, Inc. | https://sdk.apptimize.com/license
class apptimize_support_persistence_ABTPersistence {
	public function __construct(){}
	static $LOW_LATENCY = 0;
	static $HIGH_LATENCY = 1;
	static $ALL_LATENCY = 2;
	static $kMetadataKey = "METADATA_KEY";
	static $kUserIDKey = "USER_ID_KEY";
	static $kAnonymousGuidKey = "ANONYMOUS_GUID_KEY";
	static $kCustomPropertiesKey = "CUSTOM_PROPERTIES_KEY";
	static $kInternalPropertiesKey = "INTERNAL_PROPERTIES_KEY";
	static $kResultLogsKey = "RESULT_LOGS_KEY";
	static $kResultPostsKey = "RESULT_POSTS_KEY";
	static $kResultPostsListKey = "RESULT_POSTS_LIST_KEY";
	static $kResultEntrySequenceKey = "RESULT_ENTRY_SEQUENCE_KEY";
	static $kResultEntryTimestampKey = "RESULT_ENTRY_TIMESTAMP_KEY";
	static $kApptimizeVersionKey = "APPTIMIZE_VERSION_KEY";
	static $kLockAccessKey = "LOCK_ACCESS_KEY";
	static $kPostManagementKey = "POST_MANAGEMENT_KEY";
	static $kResultLastSubmitTimeKey = "RESULT_LAST_SUBMIT_TIME_KEY";
	static $kMetadataLastCheckTimeKey = "METADATA_LAST_CHECK_TIME_KEY";
	static $kDisabledVersions = "DISABLED_VERSIONS_KEY";
	static $kServerInstanceGUIDKey = "SERVER_INSTANCE_GUID_KEY";
	static $_persistentInterface;
	static function getPersistentInterface() {
		if(apptimize_support_persistence_ABTPersistence::$_persistentInterface === null) {
			if(apptimize_support_properties_ABTConfigProperties::sharedInstance()->isPropertyAvailable(apptimize_support_properties_ABTConfigProperties::$STORAGE_TYPE_KEY)) {
				if(_hx_equal(apptimize_support_properties_ABTConfigProperties::sharedInstance()->valueForProperty(apptimize_support_properties_ABTConfigProperties::$STORAGE_TYPE_KEY), "memory")) {
					apptimize_support_persistence_ABTPersistence::$_persistentInterface = new apptimize_support_persistence_ABTPICacheStorage();
					return apptimize_support_persistence_ABTPersistence::$_persistentInterface;
				}
			}
			apptimize_support_persistence_ABTPersistence::$_persistentInterface = new apptimize_support_persistence_ABTPIDiskStorage();
		}
		return apptimize_support_persistence_ABTPersistence::$_persistentInterface;
	}
	static function shutdown() {
		apptimize_support_persistence_ABTPersistence::$_persistentInterface = null;
	}
	static function loadFromHighLatency($callback) {
		$keys = (new _hx_array(array(apptimize_support_persistence_ABTPersistence::$kMetadataKey, apptimize_support_persistence_ABTPersistence::$kUserIDKey, apptimize_support_persistence_ABTPersistence::$kAnonymousGuidKey, apptimize_support_persistence_ABTPersistence::$kCustomPropertiesKey, apptimize_support_persistence_ABTPersistence::$kInternalPropertiesKey, apptimize_support_persistence_ABTPersistence::$kResultLogsKey, apptimize_support_persistence_ABTPersistence::$kResultPostsKey, apptimize_support_persistence_ABTPersistence::$kResultEntrySequenceKey, apptimize_support_persistence_ABTPersistence::$kResultEntryTimestampKey, apptimize_support_persistence_ABTPersistence::$kApptimizeVersionKey, apptimize_support_persistence_ABTPersistence::$kLockAccessKey, apptimize_support_persistence_ABTPersistence::$kPostManagementKey, apptimize_support_persistence_ABTPersistence::$kResultLastSubmitTimeKey, apptimize_support_persistence_ABTPersistence::$kMetadataLastCheckTimeKey, apptimize_support_persistence_ABTPersistence::$kResultPostsListKey)));
		$syncedKeys = $keys->copy();
		$onSync = array(new _hx_lambda(array(&$callback, &$syncedKeys), "apptimize_support_persistence_ABTPersistence_0"), 'execute');
		{
			apptimize_util_ABTDataLock::$SYSTEM_DATA_LOCK->acquire();
			try {
				$_g = 0;
				while($_g < $keys->length) {
					$key1 = $keys[$_g];
					$_g = $_g + 1;
					apptimize_support_persistence_ABTPersistence::getPersistentInterface()->sync($key1, apptimize_support_persistence_ABTPersistence::$HIGH_LATENCY, apptimize_support_persistence_ABTPersistence::$LOW_LATENCY, $onSync);
					unset($key1);
				}
			}catch(Exception $__hx__e) {
				$_ex_ = ($__hx__e instanceof HException) && $__hx__e->getCode() == null ? $__hx__e->e : $__hx__e;
				$e = $_ex_;
				{
					apptimize_util_ABTDataLock::$SYSTEM_DATA_LOCK->release();
					throw new HException($e);
				}
			}
			apptimize_util_ABTDataLock::$SYSTEM_DATA_LOCK->release();
		}
	}
	static function saveToHighLatency() {
		$keys = (new _hx_array(array(apptimize_support_persistence_ABTPersistence::$kMetadataKey, apptimize_support_persistence_ABTPersistence::$kUserIDKey, apptimize_support_persistence_ABTPersistence::$kAnonymousGuidKey, apptimize_support_persistence_ABTPersistence::$kCustomPropertiesKey, apptimize_support_persistence_ABTPersistence::$kInternalPropertiesKey, apptimize_support_persistence_ABTPersistence::$kResultLogsKey, apptimize_support_persistence_ABTPersistence::$kResultPostsKey, apptimize_support_persistence_ABTPersistence::$kResultEntrySequenceKey, apptimize_support_persistence_ABTPersistence::$kResultEntryTimestampKey, apptimize_support_persistence_ABTPersistence::$kApptimizeVersionKey, apptimize_support_persistence_ABTPersistence::$kLockAccessKey, apptimize_support_persistence_ABTPersistence::$kPostManagementKey, apptimize_support_persistence_ABTPersistence::$kResultLastSubmitTimeKey, apptimize_support_persistence_ABTPersistence::$kMetadataLastCheckTimeKey, apptimize_support_persistence_ABTPersistence::$kResultPostsListKey)));
		{
			apptimize_util_ABTDataLock::$SYSTEM_DATA_LOCK->acquire();
			try {
				$_g = 0;
				while($_g < $keys->length) {
					$key = $keys[$_g];
					$_g = $_g + 1;
					apptimize_support_persistence_ABTPersistence::getPersistentInterface()->sync($key, apptimize_support_persistence_ABTPersistence::$LOW_LATENCY, apptimize_support_persistence_ABTPersistence::$HIGH_LATENCY, null);
					unset($key);
				}
			}catch(Exception $__hx__e) {
				$_ex_ = ($__hx__e instanceof HException) && $__hx__e->getCode() == null ? $__hx__e->e : $__hx__e;
				$e = $_ex_;
				{
					apptimize_util_ABTDataLock::$SYSTEM_DATA_LOCK->release();
					throw new HException($e);
				}
			}
			apptimize_util_ABTDataLock::$SYSTEM_DATA_LOCK->release();
		}
	}
	static function clear() {
		apptimize_util_ABTDataLock::$SYSTEM_DATA_LOCK->acquire();
		try {
			apptimize_support_persistence_ABTPersistence::getPersistentInterface()->clear(apptimize_support_persistence_ABTPersistence::$ALL_LATENCY);
		}catch(Exception $__hx__e) {
			$_ex_ = ($__hx__e instanceof HException) && $__hx__e->getCode() == null ? $__hx__e->e : $__hx__e;
			$e = $_ex_;
			{
				apptimize_util_ABTDataLock::$SYSTEM_DATA_LOCK->release();
				throw new HException($e);
			}
		}
		apptimize_util_ABTDataLock::$SYSTEM_DATA_LOCK->release();
	}
	static function saveString($key, $value, $latency = null, $compress = null) {
		if($compress === null) {
			$compress = false;
		}
		if($latency === null) {
			$latency = 0;
		}
		apptimize_util_ABTDataLock::$SYSTEM_DATA_LOCK->acquire();
		try {
			try {
				apptimize_support_persistence_ABTPersistence::getPersistentInterface()->save($key, $value, $latency, $compress);
			}catch(Exception $__hx__e) {
				$_ex_ = ($__hx__e instanceof HException) && $__hx__e->getCode() == null ? $__hx__e->e : $__hx__e;
				$unknown = $_ex_;
				{
					$tmp = "Unable to store \"" . _hx_string_or_null($key) . "\" to persistent storage. Submitting all pending results data. Error: " . Std::string($unknown);
					apptimize_ABTLogger::e($tmp, _hx_anonymous(array("fileName" => "ABTPersistence.hx", "lineNumber" => 226, "className" => "apptimize.support.persistence.ABTPersistence", "methodName" => "saveString")));
					apptimize_Apptimize::flushTracking();
				}
			}
		}catch(Exception $__hx__e) {
			$_ex_ = ($__hx__e instanceof HException) && $__hx__e->getCode() == null ? $__hx__e->e : $__hx__e;
			$e = $_ex_;
			{
				apptimize_util_ABTDataLock::$SYSTEM_DATA_LOCK->release();
				throw new HException($e);
			}
		}
		apptimize_util_ABTDataLock::$SYSTEM_DATA_LOCK->release();
	}
	static function saveObject($key, $value, $latency = null, $compress = null) {
		if($compress === null) {
			$compress = false;
		}
		if($latency === null) {
			$latency = 0;
		}
		apptimize_util_ABTDataLock::$SYSTEM_DATA_LOCK->acquire();
		try {
			try {
				apptimize_support_persistence_ABTPersistence::getPersistentInterface()->saveObject($key, $value, $latency, $compress);
			}catch(Exception $__hx__e) {
				$_ex_ = ($__hx__e instanceof HException) && $__hx__e->getCode() == null ? $__hx__e->e : $__hx__e;
				$unknown = $_ex_;
				{
					$tmp = "Unable to store \"" . _hx_string_or_null($key) . "\" to persistent storage. Submitting all pending results data. Error: " . Std::string($unknown);
					apptimize_ABTLogger::e($tmp, _hx_anonymous(array("fileName" => "ABTPersistence.hx", "lineNumber" => 237, "className" => "apptimize.support.persistence.ABTPersistence", "methodName" => "saveObject")));
					apptimize_Apptimize::flushTracking();
				}
			}
		}catch(Exception $__hx__e) {
			$_ex_ = ($__hx__e instanceof HException) && $__hx__e->getCode() == null ? $__hx__e->e : $__hx__e;
			$e = $_ex_;
			{
				apptimize_util_ABTDataLock::$SYSTEM_DATA_LOCK->release();
				throw new HException($e);
			}
		}
		apptimize_util_ABTDataLock::$SYSTEM_DATA_LOCK->release();
	}
	static function loadString($key, $latency = null) {
		if($latency === null) {
			$latency = 0;
		}
		$result = null;
		{
			apptimize_util_ABTDataLock::$SYSTEM_DATA_LOCK->acquire();
			try {
				try {
					$result = apptimize_support_persistence_ABTPersistence::getPersistentInterface()->load($key, $latency, null);
				}catch(Exception $__hx__e) {
					$_ex_ = ($__hx__e instanceof HException) && $__hx__e->getCode() == null ? $__hx__e->e : $__hx__e;
					$unknown = $_ex_;
					{
						$tmp = "Unable to retrieve \"" . _hx_string_or_null($key) . "\" from persistent storage. Error: " . Std::string($unknown);
						apptimize_ABTLogger::e($tmp, _hx_anonymous(array("fileName" => "ABTPersistence.hx", "lineNumber" => 253, "className" => "apptimize.support.persistence.ABTPersistence", "methodName" => "loadString")));
						return null;
					}
				}
			}catch(Exception $__hx__e) {
				$_ex_ = ($__hx__e instanceof HException) && $__hx__e->getCode() == null ? $__hx__e->e : $__hx__e;
				$e = $_ex_;
				{
					apptimize_util_ABTDataLock::$SYSTEM_DATA_LOCK->release();
					throw new HException($e);
				}
			}
			apptimize_util_ABTDataLock::$SYSTEM_DATA_LOCK->release();
		}
		return $result;
	}
	static function loadObject($key, $latency = null) {
		if($latency === null) {
			$latency = 0;
		}
		$obj = null;
		{
			apptimize_util_ABTDataLock::$SYSTEM_DATA_LOCK->acquire();
			try {
				try {
					$obj = apptimize_support_persistence_ABTPersistence::getPersistentInterface()->loadObject($key, $latency, null);
				}catch(Exception $__hx__e) {
					$_ex_ = ($__hx__e instanceof HException) && $__hx__e->getCode() == null ? $__hx__e->e : $__hx__e;
					$unknown = $_ex_;
					{
						$tmp = "Unable to retrieve \"" . _hx_string_or_null($key) . "\" from persistent storage. Error: " . Std::string($unknown);
						apptimize_ABTLogger::e($tmp, _hx_anonymous(array("fileName" => "ABTPersistence.hx", "lineNumber" => 266, "className" => "apptimize.support.persistence.ABTPersistence", "methodName" => "loadObject")));
						return null;
					}
				}
			}catch(Exception $__hx__e) {
				$_ex_ = ($__hx__e instanceof HException) && $__hx__e->getCode() == null ? $__hx__e->e : $__hx__e;
				$e = $_ex_;
				{
					apptimize_util_ABTDataLock::$SYSTEM_DATA_LOCK->release();
					throw new HException($e);
				}
			}
			apptimize_util_ABTDataLock::$SYSTEM_DATA_LOCK->release();
		}
		return $obj;
	}
	function __toString() { return 'apptimize.support.persistence.ABTPersistence'; }
}
function apptimize_support_persistence_ABTPersistence_0(&$callback, &$syncedKeys, $key, $value) {
	{
		$syncedKeys->remove($key);
		if($syncedKeys->length === 0) {
			call_user_func($callback);
		}
	}
}
