<?php

// Copyright (c) Apptimize, Inc. | https://sdk.apptimize.com/license
class apptimize_util_ABTDispatch {
	public function __construct($name) {
		if(!php_Boot::$skip_constructor) {
		$this->delayedTasks = new HList();
		$this->started = false;
		$this->name = $name;
	}}
	public $started;
	public $delayedTasks;
	public $name;
	public function dispatch($task, $delay = null) {
		if($delay === null) {
			$delay = 0;
		}
		if($this->started) {
			apptimize_util_ABTDispatch::dispatchImmediately($task);
		} else {
			$tmp = $this->delayedTasks;
			$tmp->add(new apptimize_util_ABTDispatchTask($task, $delay));
		}
	}
	public function start($maxThreads = null) {
		if($maxThreads === null) {
			$maxThreads = 1;
		}
		if($this->started) {
			return;
		}
		$errors = new HList();
		{
			$task = $this->delayedTasks->iterator();
			while($task->hasNext()) {
				$task1 = $task->next();
				try {
					apptimize_util_ABTDispatch::dispatchImmediately((property_exists($task1, "task") ? $task1->task: array($task1, "task")));
				}catch(Exception $__hx__e) {
					$_ex_ = ($__hx__e instanceof HException) && $__hx__e->getCode() == null ? $__hx__e->e : $__hx__e;
					$e = $_ex_;
					{
						$errors->add($e);
					}
				}
				unset($task1,$e);
			}
		}
		$this->delayedTasks->clear();
		if(!$errors->isEmpty()) {
			apptimize_ABTLogger::e("One or more errors occurred starting dispatcher '" . _hx_string_or_null($this->name) . "':", _hx_anonymous(array("fileName" => "ABTDispatch.hx", "lineNumber" => 121, "className" => "apptimize.util.ABTDispatch", "methodName" => "start")));
			{
				$error = $errors->iterator();
				while($error->hasNext()) {
					$error1 = $error->next();
					apptimize_ABTLogger::e("Dispatcher '" . _hx_string_or_null($this->name) . "' threw an exception executing a task: " . _hx_string_or_null($error1), _hx_anonymous(array("fileName" => "ABTDispatch.hx", "lineNumber" => 123, "className" => "apptimize.util.ABTDispatch", "methodName" => "start")));
					unset($error1);
				}
			}
		}
		$this->started = true;
	}
	public function __call($m, $a) {
		if(isset($this->$m) && is_callable($this->$m))
			return call_user_func_array($this->$m, $a);
		else if(isset($this->__dynamics[$m]) && is_callable($this->__dynamics[$m]))
			return call_user_func_array($this->__dynamics[$m], $a);
		else if('toString' == $m)
			return $this->__toString();
		else
			throw new HException('Unable to call <'.$m.'>');
	}
	static function dispatchImmediately($task) {
		call_user_func($task);
	}
	function __toString() { return 'apptimize.util.ABTDispatch'; }
}
