<?php

// Copyright (c) Apptimize, Inc. | https://sdk.apptimize.com/license
class apptimize_util_ABTLRUCache {
	public function __construct($cacheSize) {
		if(!php_Boot::$skip_constructor) {
		$this->cacheLock = apptimize_util_ABTDataLock::getNewLock("ABTLRUCache_lock");
		$this->_cacheSize = $cacheSize;
		$this->clear(null, null);
	}}
	public $_cacheSize;
	public $_list;
	public $_map;
	public $cacheLock;
	public function clear($callback = null, $dispatchQueue = null) {
		$this->cacheLock->acquire();
		try {
			if($callback !== null) {
				$_g = 0;
				$_g1 = $this->_list;
				while($_g < $_g1->length) {
					$id = $_g1[$_g];
					$_g = $_g + 1;
					$value = $this->_map->get($id);
					{
						$task = array(new _hx_lambda(array(&$callback, &$value), "apptimize_util_ABTLRUCache_0"), 'execute');
						if($dispatchQueue !== null) {
							$dispatchQueue->dispatch($task, 0);
						} else {
							apptimize_util_ABTDispatch::dispatchImmediately($task);
						}
						unset($task);
					}
					unset($value,$id);
				}
			}
			$this->_list = new _hx_array(array());
			$this->_map = new haxe_ds_StringMap();
		}catch(Exception $__hx__e) {
			$_ex_ = ($__hx__e instanceof HException) && $__hx__e->getCode() == null ? $__hx__e->e : $__hx__e;
			$e = $_ex_;
			{
				$this->cacheLock->release();
				throw new HException($e);
			}
		}
		$this->cacheLock->release();
	}
	public function hasKey($key) {
		$result = false;
		{
			$this->cacheLock->acquire();
			try {
				$result = $this->_map->get($key) !== null;
			}catch(Exception $__hx__e) {
				$_ex_ = ($__hx__e instanceof HException) && $__hx__e->getCode() == null ? $__hx__e->e : $__hx__e;
				$e = $_ex_;
				{
					$this->cacheLock->release();
					throw new HException($e);
				}
			}
			$this->cacheLock->release();
		}
		return $result;
	}
	public function getValue($key) {
		$result = null;
		{
			$this->cacheLock->acquire();
			try {
				if($this->hasKey($key)) {
					$result = $this->_map->get($key);
				}
			}catch(Exception $__hx__e) {
				$_ex_ = ($__hx__e instanceof HException) && $__hx__e->getCode() == null ? $__hx__e->e : $__hx__e;
				$e = $_ex_;
				{
					$this->cacheLock->release();
					throw new HException($e);
				}
			}
			$this->cacheLock->release();
		}
		return $result;
	}
	public function remove($key, $callback = null, $dispatchQueue = null) {
		$this->cacheLock->acquire();
		try {
			if(!$this->hasKey($key)) {
				return;
			}
			if($callback !== null) {
				$value = $this->_map->get($key);
				{
					$task = array(new _hx_lambda(array(&$callback, &$value), "apptimize_util_ABTLRUCache_1"), 'execute');
					if($dispatchQueue !== null) {
						$dispatchQueue->dispatch($task, 0);
					} else {
						apptimize_util_ABTDispatch::dispatchImmediately($task);
					}
				}
			}
			$this->_list->remove($key);
			$this->_map->remove($key);
		}catch(Exception $__hx__e) {
			$_ex_ = ($__hx__e instanceof HException) && $__hx__e->getCode() == null ? $__hx__e->e : $__hx__e;
			$e = $_ex_;
			{
				$this->cacheLock->release();
				throw new HException($e);
			}
		}
		$this->cacheLock->release();
	}
	public function insert($key, $value, $callback = null, $dispatchQueue = null) {
		$this->cacheLock->acquire();
		try {
			if($this->hasKey($key)) {
				$this->_map->set($key, $value);
				$this->_list->remove($key);
				$this->_list->push($key);
			} else {
				$this->_map->set($key, $value);
				$this->_list->push($key);
				if($this->_list->length > $this->_cacheSize) {
					$id = $this->_list->shift();
					if($callback !== null) {
						$value1 = $this->_map->get($id);
						{
							$task = array(new _hx_lambda(array(&$callback, &$value1), "apptimize_util_ABTLRUCache_2"), 'execute');
							if($dispatchQueue !== null) {
								$dispatchQueue->dispatch($task, 0);
							} else {
								apptimize_util_ABTDispatch::dispatchImmediately($task);
							}
						}
					}
					$this->_map->remove($id);
				}
			}
		}catch(Exception $__hx__e) {
			$_ex_ = ($__hx__e instanceof HException) && $__hx__e->getCode() == null ? $__hx__e->e : $__hx__e;
			$e = $_ex_;
			{
				$this->cacheLock->release();
				throw new HException($e);
			}
		}
		$this->cacheLock->release();
	}
	public function hxSerialize($s) {
		$_g = new haxe_ds_StringMap();
		$_g->set("_cacheSize", $this->_cacheSize);
		$_g->set("_list", $this->_list);
		$_g->set("_map", $this->_map);
		$values = $_g;
		$s->serialize($values);
	}
	public function hxUnserialize($u) {
		$deserialized = $u->unserialize();
		$this->_cacheSize = $deserialized->get("_cacheSize");
		$this->_list = $deserialized->get("_list");
		$this->_map = $deserialized->get("_map");
		$this->initMissingFields();
	}
	public function didUnserialize() {
		$this->initMissingFields();
	}
	public function initMissingFields() {
		if($this->cacheLock === null) {
			$this->cacheLock = apptimize_util_ABTDataLock::getNewLock("ABTLRUCache_lock");
		}
	}
	public function __call($m, $a) {
		if(isset($this->$m) && is_callable($this->$m))
			return call_user_func_array($this->$m, $a);
		else if(isset($this->__dynamics[$m]) && is_callable($this->__dynamics[$m]))
			return call_user_func_array($this->__dynamics[$m], $a);
		else if('toString' == $m)
			return $this->__toString();
		else
			throw new HException('Unable to call <'.$m.'>');
	}
	function __toString() { return 'apptimize.util.ABTLRUCache'; }
}
function apptimize_util_ABTLRUCache_0(&$callback, &$value) {
	{
		call_user_func_array($callback, array($value));
	}
}
function apptimize_util_ABTLRUCache_1(&$callback, &$value) {
	{
		call_user_func_array($callback, array($value));
	}
}
function apptimize_util_ABTLRUCache_2(&$callback, &$value1) {
	{
		call_user_func_array($callback, array($value1));
	}
}
