<?php

// Copyright (c) Apptimize, Inc. | https://sdk.apptimize.com/license
class format_gz_Reader {
	public function __construct($i) {
		if(!php_Boot::$skip_constructor) {
		$this->i = $i;
	}}
	public $i;
	public function read() {
		$h = $this->readHeader();
		$o = new haxe_io_BytesOutput();
		$this->readData($o, null);
		$h1 = $h->fileName;
		return _hx_anonymous(array("file" => $h1, "data" => $o->getBytes()));
	}
	public function readHeader() {
		$tmp = null;
		if($this->i->readByte() === 31) {
			$tmp = $this->i->readByte() !== 139;
		} else {
			$tmp = true;
		}
		if($tmp) {
			throw new HException("Invalid GZ header");
		}
		if($this->i->readByte() !== 8) {
			throw new HException("Invalid compression method");
		}
		$flags = $this->i->readByte();
		$mtime = $this->i->read(4);
		$xflags = $this->i->readByte();
		$os = $this->i->readByte();
		$fname = null;
		$comments = null;
		$xdata = null;
		if(($flags & 4) !== 0) {
			$xlen = $this->i->readUInt16();
			$xdata = $this->i->read($xlen);
		}
		if(($flags & 8) !== 0) {
			$fname = $this->i->readUntil(0);
		}
		if(($flags & 16) !== 0) {
			$comments = $this->i->readUntil(0);
		}
		if(($flags & 2) !== 0) {
			$hcrc = $this->i->readUInt16();
		}
		return _hx_anonymous(array("fileName" => $fname, "comments" => $comments, "extraData" => $xdata));
	}
	public function readData($o, $bufsize = null) {
		if($bufsize === null) {
			$bufsize = 65536;
		}
		$buf = haxe_io_Bytes::alloc($bufsize);
		$tsize = 0;
		$inflate = new haxe_zip_InflateImpl($this->i, false, false);
		while(true) {
			$len = $inflate->readBytes($buf, 0, $bufsize);
			$o->writeFullBytes($buf, 0, $len);
			if($len < $bufsize) {
				break;
			}
			$tsize = $tsize + $len;
			unset($len);
		}
		return $tsize;
	}
	public function __call($m, $a) {
		if(isset($this->$m) && is_callable($this->$m))
			return call_user_func_array($this->$m, $a);
		else if(isset($this->__dynamics[$m]) && is_callable($this->__dynamics[$m]))
			return call_user_func_array($this->__dynamics[$m], $a);
		else if('toString' == $m)
			return $this->__toString();
		else
			throw new HException('Unable to call <'.$m.'>');
	}
	function __toString() { return 'format.gz.Reader'; }
}
