<?php

// Copyright (c) Apptimize, Inc. | https://sdk.apptimize.com/license
class haxe_io_Input {
	public function __construct(){}
	public $bigEndian;
	public function readByte() {
		throw new HException("Not implemented");
	}
	public function readBytes($s, $pos, $len) {
		$k = $len;
		$b = $s->b;
		$tmp = null;
		$tmp1 = null;
		if($pos >= 0) {
			$tmp1 = $len < 0;
		} else {
			$tmp1 = true;
		}
		if(!$tmp1) {
			$tmp = $pos + $len > $s->length;
		} else {
			$tmp = true;
		}
		if($tmp) {
			throw new HException(haxe_io_Error::$OutsideBounds);
		}
		try {
			while($k > 0) {
				{
					$val = $this->readByte();
					$b->s[$pos] = chr($val);
					unset($val);
				}
				$pos = $pos + 1;
				$k = $k - 1;
			}
		}catch(Exception $__hx__e) {
			$_ex_ = ($__hx__e instanceof HException) && $__hx__e->getCode() == null ? $__hx__e->e : $__hx__e;
			if(($eof = $_ex_) instanceof haxe_io_Eof){
			} else throw $__hx__e;;
		}
		return $len - $k;
	}
	public function close() {
	}
	public function read($nbytes) {
		$s = haxe_io_Bytes::alloc($nbytes);
		$p = 0;
		while($nbytes > 0) {
			$k = $this->readBytes($s, $p, $nbytes);
			if($k === 0) {
				throw new HException(haxe_io_Error::$Blocked);
			}
			$p = $p + $k;
			$nbytes = $nbytes - $k;
			unset($k);
		}
		return $s;
	}
	public function readUntil($end) {
		$buf = new haxe_io_BytesBuffer();
		$last = null;
		while(true) {
			$last = $this->readByte();
			if(!($last !== $end)) {
				break;
			}
			$buf1 = $buf;
			$buf2 = $buf1->b;
			$buf1->b = _hx_string_or_null($buf2) . _hx_string_or_null(chr($last));
			unset($buf2,$buf1);
		}
		return $buf->getBytes()->toString();
	}
	public function readUInt16() {
		$ch1 = $this->readByte();
		$ch2 = $this->readByte();
		if($this->bigEndian) {
			return $ch2 | $ch1 << 8;
		} else {
			return $ch1 | $ch2 << 8;
		}
	}
	public function __call($m, $a) {
		if(isset($this->$m) && is_callable($this->$m))
			return call_user_func_array($this->$m, $a);
		else if(isset($this->__dynamics[$m]) && is_callable($this->__dynamics[$m]))
			return call_user_func_array($this->__dynamics[$m], $a);
		else if('toString' == $m)
			return $this->__toString();
		else
			throw new HException('Unable to call <'.$m.'>');
	}
	function __toString() { return 'haxe.io.Input'; }
}
