<?php

// Copyright (c) Apptimize, Inc. | https://sdk.apptimize.com/license
class haxe_zip_HuffTools {
	public function __construct() {}
	public function treeDepth($t) {
		switch($t->index) {
		case 0:{
			return 0;
		}break;
		case 1:{
			$b = _hx_deref($t)->params[1];
			$a = _hx_deref($t)->params[0];
			$da = $this->treeDepth($a);
			$db = $this->treeDepth($b);
			$tmp = null;
			if($da < $db) {
				$tmp = $da;
			} else {
				$tmp = $db;
			}
			return 1 + $tmp;
		}break;
		case 2:{
			throw new HException("assert");
		}break;
		}
	}
	public function treeCompress($t) {
		$d = $this->treeDepth($t);
		if($d === 0) {
			return $t;
		}
		if($d === 1) {
			if($t->index === 1) {
				$b = _hx_deref($t)->params[1];
				$a = _hx_deref($t)->params[0];
				$tmp = $this->treeCompress($a);
				return haxe_zip_Huffman::NeedBit($tmp, $this->treeCompress($b));
			} else {
				throw new HException("assert");
			}
		}
		$size = 1 << $d;
		$table = new _hx_array(array());
		{
			$_g1 = 0;
			$_g = $size;
			while($_g1 < $_g) {
				$_g1 = $_g1 + 1;
				$i = $_g1 - 1;
				$table->push(haxe_zip_Huffman::Found(-1));
				unset($i);
			}
		}
		$this->treeWalk($table, 0, 0, $d, $t);
		return haxe_zip_Huffman::NeedBits($d, $table);
	}
	public function treeWalk($table, $p, $cd, $d, $t) {
		if($t->index === 1) {
			$b = _hx_deref($t)->params[1];
			$a = _hx_deref($t)->params[0];
			if($d > 0) {
				$this->treeWalk($table, $p, $cd + 1, $d - 1, $a);
				$this->treeWalk($table, $p | 1 << $cd, $cd + 1, $d - 1, $b);
			} else {
				$table[$p] = $this->treeCompress($t);
			}
		} else {
			$table[$p] = $this->treeCompress($t);
		}
	}
	public function treeMake($bits, $maxbits, $v, $len) {
		if($len > $maxbits) {
			throw new HException("Invalid huffman");
		}
		$idx = $v << 5 | $len;
		if($bits->exists($idx)) {
			return haxe_zip_Huffman::Found($bits->get($idx));
		}
		$v = $v << 1;
		$len = $len + 1;
		$tmp = $this->treeMake($bits, $maxbits, $v, $len);
		return haxe_zip_Huffman::NeedBit($tmp, $this->treeMake($bits, $maxbits, $v | 1, $len));
	}
	public function make($lengths, $pos, $nlengths, $maxbits) {
		$counts = new _hx_array(array());
		$tmp = new _hx_array(array());
		if($maxbits > 32) {
			throw new HException("Invalid huffman");
		}
		{
			$_g1 = 0;
			$_g = $maxbits;
			while($_g1 < $_g) {
				$_g1 = $_g1 + 1;
				$i = $_g1 - 1;
				$counts->push(0);
				$tmp->push(0);
				unset($i);
			}
		}
		{
			$_g11 = 0;
			$_g2 = $nlengths;
			while($_g11 < $_g2) {
				$_g11 = $_g11 + 1;
				$i1 = $_g11 - 1;
				$p = $lengths[$i1 + $pos];
				if($p >= $maxbits) {
					throw new HException("Invalid huffman");
				}
				$counts->a[$p]++;
				unset($p,$i1);
			}
		}
		$code = 0;
		{
			$_g12 = 1;
			$_g3 = $maxbits - 1;
			while($_g12 < $_g3) {
				$_g12 = $_g12 + 1;
				$i2 = $_g12 - 1;
				$code = $code + $counts[$i2] << 1;
				$tmp[$i2] = $code;
				unset($i2);
			}
		}
		$bits = new haxe_ds_IntMap();
		{
			$_g13 = 0;
			$_g4 = $nlengths;
			while($_g13 < $_g4) {
				$_g13 = $_g13 + 1;
				$i3 = $_g13 - 1;
				$l = $lengths[$i3 + $pos];
				if($l !== 0) {
					$n = $tmp[$l - 1];
					$tmp[$l - 1] = $n + 1;
					$bits->set($n << 5 | $l, $i3);
					unset($n);
				}
				unset($l,$i3);
			}
		}
		$tmp1 = $this->treeMake($bits, $maxbits, 0, 1);
		return $this->treeCompress(haxe_zip_Huffman::NeedBit($tmp1, $this->treeMake($bits, $maxbits, 1, 1)));
	}
	function __toString() { return 'haxe.zip.HuffTools'; }
}
