<?php

// Copyright (c) Apptimize, Inc. | https://sdk.apptimize.com/license
class haxe_zip_InflateImpl {
	public function __construct($i, $header = null, $crc = null) {
		if(!php_Boot::$skip_constructor) {
		if($crc === null) {
			$crc = true;
		}
		if($header === null) {
			$header = true;
		}
		$this->{"final"} = false;
		$this->htools = new haxe_zip_HuffTools();
		$this->huffman = $this->buildFixedHuffman();
		$this->huffdist = null;
		$this->len = 0;
		$this->dist = 0;
		$tmp = null;
		if($header) {
			$tmp = haxe_zip__InflateImpl_State::$Head;
		} else {
			$tmp = haxe_zip__InflateImpl_State::$Block;
		}
		$this->state = $tmp;
		$this->input = $i;
		$this->bits = 0;
		$this->nbits = 0;
		$this->needed = 0;
		$this->output = null;
		$this->outpos = 0;
		$this->lengths = new _hx_array(array());
		{
			$_g = 0;
			while($_g < 19) {
				$_g = $_g + 1;
				$i1 = $_g - 1;
				$this->lengths->push(-1);
				unset($i1);
			}
		}
		$this->window = new haxe_zip__InflateImpl_Window($crc);
	}}
	public $nbits;
	public $bits;
	public $state;
	public $final;
	public $huffman;
	public $huffdist;
	public $htools;
	public $len;
	public $dist;
	public $needed;
	public $output;
	public $outpos;
	public $input;
	public $lengths;
	public $window;
	public function buildFixedHuffman() {
		if(haxe_zip_InflateImpl::$FIXED_HUFFMAN !== null) {
			return haxe_zip_InflateImpl::$FIXED_HUFFMAN;
		}
		$a = new _hx_array(array());
		{
			$_g = 0;
			while($_g < 288) {
				$_g = $_g + 1;
				$n = $_g - 1;
				$tmp = null;
				if($n <= 143) {
					$tmp = 8;
				} else {
					if($n <= 255) {
						$tmp = 9;
					} else {
						if($n <= 279) {
							$tmp = 7;
						} else {
							$tmp = 8;
						}
					}
				}
				$a->push($tmp);
				unset($tmp,$n);
			}
		}
		haxe_zip_InflateImpl::$FIXED_HUFFMAN = $this->htools->make($a, 0, 288, 10);
		return haxe_zip_InflateImpl::$FIXED_HUFFMAN;
	}
	public function readBytes($b, $pos, $len) {
		$this->needed = $len;
		$this->outpos = $pos;
		$this->output = $b;
		if($len > 0) {
			while($this->inflateLoop()) {
			}
		}
		return $len - $this->needed;
	}
	public function getBits($n) {
		while($this->nbits < $n) {
			$tmp = $this;
			$tmp1 = $tmp->bits;
			$tmp2 = $this->input->readByte();
			$tmp->bits = $tmp1 | $tmp2 << $this->nbits;
			$tmp3 = $this;
			$tmp3->nbits = $tmp3->nbits + 8;
			unset($tmp3,$tmp2,$tmp1,$tmp);
		}
		$b = $this->bits & (1 << $n) - 1;
		$tmp4 = $this;
		$tmp4->nbits = $tmp4->nbits - $n;
		$tmp5 = $this;
		$tmp5->bits = $tmp5->bits >> $n;
		return $b;
	}
	public function getBit() {
		if($this->nbits === 0) {
			$this->nbits = 8;
			$this->bits = $this->input->readByte();
		}
		$b = ($this->bits & 1) === 1;
		$this->nbits--;
		$tmp = $this;
		$tmp->bits = $tmp->bits >> 1;
		return $b;
	}
	public function getRevBits($n) {
		if($n === 0) {
			return 0;
		} else {
			if($this->getBit()) {
				return 1 << $n - 1 | $this->getRevBits($n - 1);
			} else {
				return $this->getRevBits($n - 1);
			}
		}
	}
	public function resetBits() {
		$this->bits = 0;
		$this->nbits = 0;
	}
	public function addBytes($b, $p, $len) {
		$this->window->addBytes($b, $p, $len);
		$this->output->blit($this->outpos, $b, $p, $len);
		$tmp = $this;
		$tmp->needed = $tmp->needed - $len;
		$tmp1 = $this;
		$tmp1->outpos = $tmp1->outpos + $len;
	}
	public function addByte($b) {
		$this->window->addByte($b);
		{
			$pos = $this->outpos;
			{
				$this1 = $this->output->b;
				$this1->s[$pos] = chr($b);
			}
		}
		$this->needed--;
		$this->outpos++;
	}
	public function addDistOne($n) {
		$c = $this->window->getLastChar();
		{
			$_g1 = 0;
			$_g = $n;
			while($_g1 < $_g) {
				$_g1 = $_g1 + 1;
				$i = $_g1 - 1;
				$this->addByte($c);
				unset($i);
			}
		}
	}
	public function addDist($d, $len) {
		$this->addBytes($this->window->buffer, $this->window->pos - $d, $len);
	}
	public function applyHuffman($h) {
		switch($h->index) {
		case 0:{
			$n = _hx_deref($h)->params[0];
			return $n;
		}break;
		case 1:{
			$b = _hx_deref($h)->params[1];
			$a = _hx_deref($h)->params[0];
			$tmp = null;
			if($this->getBit()) {
				$tmp = $b;
			} else {
				$tmp = $a;
			}
			return $this->applyHuffman($tmp);
		}break;
		case 2:{
			$tbl = _hx_deref($h)->params[1];
			$n1 = _hx_deref($h)->params[0];
			return $this->applyHuffman($tbl[$this->getBits($n1)]);
		}break;
		}
	}
	public function inflateLengths($a, $max) {
		$i = 0;
		$prev = 0;
		while($i < $max) {
			$n = $this->applyHuffman($this->huffman);
			switch($n) {
			case 0:case 1:case 2:case 3:case 4:case 5:case 6:case 7:case 8:case 9:case 10:case 11:case 12:case 13:case 14:case 15:{
				$prev = $n;
				$a[$i] = $n;
				$i = $i + 1;
			}break;
			case 16:{
				$end = $i + 3 + $this->getBits(2);
				if($end > $max) {
					throw new HException("Invalid data");
				}
				while($i < $end) {
					$a[$i] = $prev;
					$i = $i + 1;
				}
			}break;
			case 17:{
				$i = $i + (3 + $this->getBits(3));
				if($i > $max) {
					throw new HException("Invalid data");
				}
			}break;
			case 18:{
				$i = $i + (11 + $this->getBits(7));
				if($i > $max) {
					throw new HException("Invalid data");
				}
			}break;
			default:{
				throw new HException("Invalid data");
			}break;
			}
			unset($n);
		}
	}
	public function inflateLoop() {
		$_g = $this->state;
		switch($_g->index) {
		case 0:{
			$cmf = $this->input->readByte();
			$cm = $cmf & 15;
			$cinfo = $cmf >> 4;
			if($cm !== 8) {
				throw new HException("Invalid data");
			}
			$flg = $this->input->readByte();
			$fdict = ($flg & 32) !== 0;
			if(_hx_mod((($cmf << 8) + $flg), 31) !== 0) {
				throw new HException("Invalid data");
			}
			if($fdict) {
				throw new HException("Unsupported dictionary");
			}
			$this->state = haxe_zip__InflateImpl_State::$Block;
			return true;
		}break;
		case 1:{
			$this->{"final"} = $this->getBit();
			$_g1 = $this->getBits(2);
			switch($_g1) {
			case 0:{
				$this->len = $this->input->readUInt16();
				$nlen = $this->input->readUInt16();
				if($nlen !== 65535 - $this->len) {
					throw new HException("Invalid data");
				}
				$this->state = haxe_zip__InflateImpl_State::$Flat;
				$r = $this->inflateLoop();
				$this->resetBits();
				return $r;
			}break;
			case 1:{
				$this->huffman = $this->buildFixedHuffman();
				$this->huffdist = null;
				$this->state = haxe_zip__InflateImpl_State::$CData;
				return true;
			}break;
			case 2:{
				$hlit = $this->getBits(5) + 257;
				$hdist = $this->getBits(5) + 1;
				$hclen = $this->getBits(4) + 4;
				{
					$_g11 = 0;
					$_g2 = $hclen;
					while($_g11 < $_g2) {
						$_g11 = $_g11 + 1;
						$i = $_g11 - 1;
						$this->lengths[haxe_zip_InflateImpl::$CODE_LENGTHS_POS[$i]] = $this->getBits(3);
						unset($i);
					}
				}
				{
					$_g3 = $hclen;
					while($_g3 < 19) {
						$_g3 = $_g3 + 1;
						$i1 = $_g3 - 1;
						$this->lengths[haxe_zip_InflateImpl::$CODE_LENGTHS_POS[$i1]] = 0;
						unset($i1);
					}
				}
				$this->huffman = $this->htools->make($this->lengths, 0, 19, 8);
				$lengths = new _hx_array(array());
				{
					$_g12 = 0;
					$_g4 = $hlit + $hdist;
					while($_g12 < $_g4) {
						$_g12 = $_g12 + 1;
						$i2 = $_g12 - 1;
						$lengths->push(0);
						unset($i2);
					}
				}
				$this->inflateLengths($lengths, $hlit + $hdist);
				$this->huffdist = $this->htools->make($lengths, $hlit, $hdist, 16);
				$this->huffman = $this->htools->make($lengths, 0, $hlit, 16);
				$this->state = haxe_zip__InflateImpl_State::$CData;
				return true;
			}break;
			default:{
				throw new HException("Invalid data");
			}break;
			}
		}break;
		case 2:{
			$n = $this->applyHuffman($this->huffman);
			if($n < 256) {
				$this->addByte($n);
				return $this->needed > 0;
			} else {
				if($n === 256) {
					$tmp = null;
					if($this->{"final"}) {
						$tmp = haxe_zip__InflateImpl_State::$Crc;
					} else {
						$tmp = haxe_zip__InflateImpl_State::$Block;
					}
					$this->state = $tmp;
					return true;
				} else {
					$n = $n - 257;
					$extra_bits = haxe_zip_InflateImpl::$LEN_EXTRA_BITS_TBL[$n];
					if($extra_bits === -1) {
						throw new HException("Invalid data");
					}
					$tmp1 = haxe_zip_InflateImpl::$LEN_BASE_VAL_TBL[$n];
					$this->len = $tmp1 + $this->getBits($extra_bits);
					$dist_code = null;
					if($this->huffdist === null) {
						$dist_code = $this->getRevBits(5);
					} else {
						$dist_code = $this->applyHuffman($this->huffdist);
					}
					$extra_bits = haxe_zip_InflateImpl::$DIST_EXTRA_BITS_TBL[$dist_code];
					if($extra_bits === -1) {
						throw new HException("Invalid data");
					}
					$tmp2 = haxe_zip_InflateImpl::$DIST_BASE_VAL_TBL[$dist_code];
					$this->dist = $tmp2 + $this->getBits($extra_bits);
					$tmp3 = $this->dist;
					if($tmp3 > $this->window->available()) {
						throw new HException("Invalid data");
					}
					$tmp4 = null;
					if($this->dist === 1) {
						$tmp4 = haxe_zip__InflateImpl_State::$DistOne;
					} else {
						$tmp4 = haxe_zip__InflateImpl_State::$Dist;
					}
					$this->state = $tmp4;
					return true;
				}
			}
		}break;
		case 3:{
			$rlen = null;
			if($this->len < $this->needed) {
				$rlen = $this->len;
			} else {
				$rlen = $this->needed;
			}
			$bytes = $this->input->read($rlen);
			$tmp5 = $this;
			$tmp5->len = $tmp5->len - $rlen;
			$this->addBytes($bytes, 0, $rlen);
			if($this->len === 0) {
				$tmp6 = null;
				if($this->{"final"}) {
					$tmp6 = haxe_zip__InflateImpl_State::$Crc;
				} else {
					$tmp6 = haxe_zip__InflateImpl_State::$Block;
				}
				$this->state = $tmp6;
			}
			return $this->needed > 0;
		}break;
		case 4:{
			$calc = $this->window->checksum();
			if($calc === null) {
				$this->state = haxe_zip__InflateImpl_State::$Done;
				return true;
			}
			$crc = haxe_crypto_Adler32::read($this->input);
			if(!$calc->equals($crc)) {
				throw new HException("Invalid CRC");
			}
			$this->state = haxe_zip__InflateImpl_State::$Done;
			return true;
		}break;
		case 5:{
			while(true) {
				$tmp7 = null;
				if($this->len > 0) {
					$tmp7 = $this->needed > 0;
				} else {
					$tmp7 = false;
				}
				if(!$tmp7) {
					break;
				}
				$rdist = null;
				if($this->len < $this->dist) {
					$rdist = $this->len;
				} else {
					$rdist = $this->dist;
				}
				$rlen1 = null;
				if($this->needed < $rdist) {
					$rlen1 = $this->needed;
				} else {
					$rlen1 = $rdist;
				}
				$this->addDist($this->dist, $rlen1);
				$tmp8 = $this;
				$tmp8->len = $tmp8->len - $rlen1;
				unset($tmp8,$tmp7,$rlen1,$rdist);
			}
			if($this->len === 0) {
				$this->state = haxe_zip__InflateImpl_State::$CData;
			}
			return $this->needed > 0;
		}break;
		case 6:{
			$rlen2 = null;
			if($this->len < $this->needed) {
				$rlen2 = $this->len;
			} else {
				$rlen2 = $this->needed;
			}
			$this->addDistOne($rlen2);
			$tmp9 = $this;
			$tmp9->len = $tmp9->len - $rlen2;
			if($this->len === 0) {
				$this->state = haxe_zip__InflateImpl_State::$CData;
			}
			return $this->needed > 0;
		}break;
		case 7:{
			return false;
		}break;
		}
	}
	public function __call($m, $a) {
		if(isset($this->$m) && is_callable($this->$m))
			return call_user_func_array($this->$m, $a);
		else if(isset($this->__dynamics[$m]) && is_callable($this->__dynamics[$m]))
			return call_user_func_array($this->__dynamics[$m], $a);
		else if('toString' == $m)
			return $this->__toString();
		else
			throw new HException('Unable to call <'.$m.'>');
	}
	static $LEN_EXTRA_BITS_TBL;
	static $LEN_BASE_VAL_TBL;
	static $DIST_EXTRA_BITS_TBL;
	static $DIST_BASE_VAL_TBL;
	static $CODE_LENGTHS_POS;
	static $FIXED_HUFFMAN = null;
	function __toString() { return 'haxe.zip.InflateImpl'; }
}
haxe_zip_InflateImpl::$LEN_EXTRA_BITS_TBL = (new _hx_array(array(0, 0, 0, 0, 0, 0, 0, 0, 1, 1, 1, 1, 2, 2, 2, 2, 3, 3, 3, 3, 4, 4, 4, 4, 5, 5, 5, 5, 0, -1, -1)));
haxe_zip_InflateImpl::$LEN_BASE_VAL_TBL = (new _hx_array(array(3, 4, 5, 6, 7, 8, 9, 10, 11, 13, 15, 17, 19, 23, 27, 31, 35, 43, 51, 59, 67, 83, 99, 115, 131, 163, 195, 227, 258)));
haxe_zip_InflateImpl::$DIST_EXTRA_BITS_TBL = (new _hx_array(array(0, 0, 0, 0, 1, 1, 2, 2, 3, 3, 4, 4, 5, 5, 6, 6, 7, 7, 8, 8, 9, 9, 10, 10, 11, 11, 12, 12, 13, 13, -1, -1)));
haxe_zip_InflateImpl::$DIST_BASE_VAL_TBL = (new _hx_array(array(1, 2, 3, 4, 5, 7, 9, 13, 17, 25, 33, 49, 65, 97, 129, 193, 257, 385, 513, 769, 1025, 1537, 2049, 3073, 4097, 6145, 8193, 12289, 16385, 24577)));
haxe_zip_InflateImpl::$CODE_LENGTHS_POS = (new _hx_array(array(16, 17, 18, 0, 8, 7, 9, 6, 10, 5, 11, 4, 12, 3, 13, 2, 14, 1, 15)));
