<?php

// Copyright (c) Apptimize, Inc. | https://sdk.apptimize.com/license
class hx_concurrent_lock_RLock implements hx_concurrent_lock_Acquirable{
	public function __construct() {
		if(!php_Boot::$skip_constructor) {
		$this->_holderEntranceCount = 0;
		$this->_holder = null;
	}}
	public $_holder;
	public $_holderEntranceCount;
	public function execute($func, $swallowExceptions = null) {
		if($swallowExceptions === null) {
			$swallowExceptions = false;
		}
		$ex = null;
		$result = null;
		$this->acquire();
		try {
			$result = call_user_func($func);
		}catch(Exception $__hx__e) {
			$_ex_ = ($__hx__e instanceof HException) && $__hx__e->getCode() == null ? $__hx__e->e : $__hx__e;
			$e = $_ex_;
			{
				$ex = new hx_concurrent_ConcurrentException($e);
			}
		}
		$this->release();
		$tmp = null;
		if(!$swallowExceptions) {
			$tmp = $ex !== null;
		} else {
			$tmp = false;
		}
		if($tmp) {
			throw new HException($ex->toString());
		}
		return $result;
	}
	public function acquire() {
		$this->_holder = hx_concurrent_thread_Threads::get_current();
		$this->_holderEntranceCount++;
	}
	public function release() {
		$tmp = $this->_holder;
		if(_hx_equal($tmp, hx_concurrent_thread_Threads::get_current())) {
			$this->_holderEntranceCount--;
			if($this->_holderEntranceCount === 0) {
				$this->_holder = null;
			}
		} else {
			$tmp1 = null;
			if(_hx_field($this, "_holder") !== null) {
				$tmp2 = $this->_holder;
				$tmp1 = !_hx_equal($tmp2, hx_concurrent_thread_Threads::get_current());
			} else {
				$tmp1 = false;
			}
			if($tmp1) {
				throw new HException("Lock was aquired by another thread!");
			} else {
				throw new HException("Lock was not aquired by any thread!");
			}
		}
	}
	public function __call($m, $a) {
		if(isset($this->$m) && is_callable($this->$m))
			return call_user_func_array($this->$m, $a);
		else if(isset($this->__dynamics[$m]) && is_callable($this->__dynamics[$m]))
			return call_user_func_array($this->__dynamics[$m], $a);
		else if('toString' == $m)
			return $this->__toString();
		else
			throw new HException('Unable to call <'.$m.'>');
	}
	function __toString() { return 'hx.concurrent.lock.RLock'; }
}
